/*!
 * Application Insights JavaScript Web SDK - Basic, 3.3.9
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */
"use strict";function _pureAssign(e,t){return e||t}function _pureRef(e,t){return e[t]}var _primitiveTypes,UNDEF_VALUE=undefined,NULL_VALUE=null,EMPTY="",FUNCTION="function",OBJECT="object",PROTOTYPE="prototype",__PROTO__="__proto__",UNDEFINED="undefined",CONSTRUCTOR="constructor",SYMBOL="Symbol",LENGTH="length",NAME="name",CALL="call",TO_STRING="toString",GET_OWN_PROPERTY_DESCRIPTOR="getOwnPropertyDescriptor",ObjClass$1=_pureAssign(Object),ObjProto$1=_pureRef(ObjClass$1,PROTOTYPE),StrCls=_pureAssign(String),StrProto=_pureRef(StrCls,PROTOTYPE),MathCls=_pureAssign(Math),ArrCls=_pureAssign(Array),ArrProto=_pureRef(ArrCls,PROTOTYPE),ArrSlice=_pureRef(ArrProto,"slice"),POLYFILL_TAG="_polyfill",POLYFILL_TYPE_NAME="__nw21$polytype__";function safe(e,t){try{return{v:e.apply(this,t)}}catch(n){return{e:n}}}function safeGet(e,t,n){e=safe(e,n);return e.e?t:e.v}function _createIs(t){return function(e){return typeof e===t}}function _createObjIs(e){var t="[object "+e+"]";return function(e){return!(!e||objToString(e)!==t)}}function objToString(e){return ObjProto$1[TO_STRING].call(e)}function isUndefined(e){return typeof e===UNDEFINED||e===UNDEFINED}function isStrictUndefined(e){return e===UNDEF_VALUE}function isNullOrUndefined(e){return e===NULL_VALUE||isUndefined(e)}function isStrictNullOrUndefined(e){return e===NULL_VALUE||e===UNDEF_VALUE}function isDefined(e){return!!e||e!==UNDEF_VALUE}function isPrimitiveType(e){return _primitiveTypes=_primitiveTypes||["string","number","boolean",UNDEFINED,"symbol","bigint"],!(e===OBJECT||!~_primitiveTypes.indexOf(e))}var isString=_createIs("string"),isFunction=_createIs(FUNCTION);function isObject(e){return!(!e&&isNullOrUndefined(e)||!e||typeof e!==OBJECT)}var isArray=_pureRef(ArrCls,"isArray"),isDate=_createObjIs("Date"),isNumber=_createIs("number"),isBoolean=_createIs("boolean"),isError=_createObjIs("Error");function isPromiseLike(e){return!!(e&&e.then&&isFunction(e.then))}function isTruthy(e){return!(!e||safeGet(function(){return!(e&&0+e)},!e))}function _returnNothing(){}function _returnFalse(){return!1}var asString=_pureAssign(StrCls),ERROR_TYPE="[object Error]";function dumpObj(e,t){var n=EMPTY,r=ObjProto$1[TO_STRING][CALL](e);r===ERROR_TYPE&&(e={stack:asString(e.stack),message:asString(e.message),name:asString(e.name)});try{n=((n=JSON.stringify(e,NULL_VALUE,t?"number"==typeof t?t:4:UNDEF_VALUE))?n.replace(/"(\w+)"\s*:\s{0,1}/g,"$1: "):NULL_VALUE)||asString(e)}catch(o){n=" - "+dumpObj(o,t)}return r+": "+n}function throwError(e){throw Error(e)}function throwTypeError(e){throw new TypeError(e)}function _throwIfNullOrUndefined(e){isStrictNullOrUndefined(e)&&throwTypeError("Cannot convert undefined or null to object")}function _throwIfNotString(e){isString(e)||throwTypeError("'"+dumpObj(e)+"' is not a string")}function objHasOwnProperty(e,t){return!!e&&ObjProto$1.hasOwnProperty[CALL](e,t)}var _objGetOwnPropertyDescriptor$2=_pureAssign(_pureRef(ObjClass$1,GET_OWN_PROPERTY_DESCRIPTOR),_returnNothing),objHasOwn=_pureAssign(_pureRef(ObjClass$1,"hasOwn"),polyObjHasOwn);function polyObjHasOwn(e,t){return _throwIfNullOrUndefined(e),objHasOwnProperty(e,t)||!!_objGetOwnPropertyDescriptor$2(e,t)}function objForEachKey(e,t,n){if(e&&(isObject(e)||isFunction(e)))for(var r in e)if(objHasOwn(e,r)&&-1===t[CALL](n||e,r,e[r]))break}function arrForEach(e,t,n){if(e)for(var r=e[LENGTH]>>>0,o=0;o<r&&!(o in e&&-1===t[CALL](n||e,e[o],o,e));o++);}var _unwrapFunction=_unwrapFunctionWithPoly;function _unwrapFunctionWithPoly(r,e,o){var i=e?e[r]:NULL_VALUE;return function(e){var t,n=(e?e[r]:NULL_VALUE)||i;if(n||o)return t=arguments,(n||o).apply(e,n?ArrSlice[CALL](t,1):t);throwTypeError('"'+asString(r)+'" not defined for '+dumpObj(e))}}function _unwrapProp(t){return function(e){return e[t]}}var _objGetOwnPropertyDescriptor$1=_pureAssign(_pureRef(ObjClass$1,GET_OWN_PROPERTY_DESCRIPTOR),_returnNothing),propMap={e:"enumerable",c:"configurable",v:"value",w:"writable",g:"get",s:"set"};function _createProp(t){var e,n={};return n[propMap.c]=!0,n[propMap.e]=!0,t.l&&(n.get=function(){return t.l.v},(e=_objGetOwnPropertyDescriptor$1(t.l,"v"))&&e.set&&(n.set=function(e){t.l.v=e})),objForEachKey(t,function(e,t){n[propMap[e]]=isStrictUndefined(t)?n[propMap[e]]:t}),n}var objDefineProp=_pureRef(ObjClass$1,"defineProperty"),objDefineProperties=_pureRef(ObjClass$1,"defineProperties");function objDefine(e,t,n){return objDefineProp(e,t,_createProp(n))}function _createKeyValueMap(e,n,r,t,o){var i={};return objForEachKey(e,function(e,t){_assignMapValue(i,e,n?t:e),_assignMapValue(i,t,r?t:e)}),t?t(i):i}function _assignMapValue(e,t,n,r){objDefineProp(e,t,{value:n,enumerable:!0,writable:!1})}var objIsFrozen=_pureAssign(_pureRef(ObjClass$1,"isFrozen"),_returnFalse),_objFreeze=_pureRef(ObjClass$1,"freeze");function _doNothing(e){return e}function _getProto(e){return _throwIfNullOrUndefined(e),e[__PROTO__]||NULL_VALUE}var objAssign=_pureRef(ObjClass$1,"assign"),objKeys=_pureRef(ObjClass$1,"keys");function _deepFreeze(e,n){if((isArray(e)||isObject(e)||isFunction(e))&&!objIsFrozen(e)){for(var t=0;t<n.length;t++)if(n[t]===e)return e;n.push(e),objForEachKey(e,function(e,t){_deepFreeze(t,n)}),objFreeze(e)}return e}function objDeepFreeze(e){return _objFreeze?_deepFreeze(e,[]):e}var objFreeze=_pureAssign(_objFreeze,_doNothing),objGetPrototypeOf=_pureAssign(_pureRef(ObjClass$1,"getPrototypeOf"),_getProto);function createEnum(e){return _createKeyValueMap(e,1,0,objFreeze)}function createEnumKeyMap(e){return _createKeyValueMap(e,0,0,objFreeze)}function createSimpleMap(e){var n={};return objForEachKey(e,function(e,t){_assignMapValue(n,e,t[1]),_assignMapValue(n,t[0],t[1])}),objFreeze(n)}function createTypeMap(e){return createSimpleMap(e)}var _globalCfg,_wellKnownSymbolMap=createEnumKeyMap({asyncIterator:0,hasInstance:1,isConcatSpreadable:2,iterator:3,match:4,matchAll:5,replace:6,search:7,species:8,split:9,toPrimitive:10,toStringTag:11,unscopables:12}),GLOBAL_CONFIG_KEY="__tsUtils$gblCfg";function _getGlobalValue(){var e;return(e=(e=(e=typeof globalThis!==UNDEFINED?globalThis:e)||typeof self===UNDEFINED?e:self)||typeof window===UNDEFINED?e:window)||typeof global===UNDEFINED?e:global}function _getGlobalConfig(){var e;return _globalCfg||(e=safe(_getGlobalValue).v||{},_globalCfg=e[GLOBAL_CONFIG_KEY]=e[GLOBAL_CONFIG_KEY]||{}),_globalCfg}var mathMin=_pureRef(MathCls,"min"),mathMax=_pureRef(MathCls,"max"),strSlice=_unwrapFunctionWithPoly("slice",StrProto),strSubstring=_unwrapFunctionWithPoly("substring",StrProto),strSubstr=_unwrapFunctionWithPoly("substr",StrProto,polyStrSubstr);function polyStrSubstr(e,t,n){return _throwIfNullOrUndefined(e),n<0?EMPTY:((t=t||0)<0&&(t=mathMax(t+e[LENGTH],0)),isUndefined(n)?strSlice(e,t):strSlice(e,t,t+n))}function strLeft(e,t){return strSubstring(e,0,t)}function _tagAsPolyfill(e,t){return e&&(safe(function(){e[POLYFILL_TAG]=!0,e[POLYFILL_TYPE_NAME]=t}),safe(objDefine,[e,POLYFILL_TAG,{v:!0,w:!1,e:!1}]),safe(objDefine,[e,POLYFILL_TYPE_NAME,{v:t,w:!1,e:!1}])),e}var _globalLazyTestHooks,objCreate=_pureAssign(_pureRef(ObjClass$1,"create"),polyObjCreate);function polyObjCreate(e,t){var n;function r(){}return n=isStrictNullOrUndefined(e)?{}:((n=typeof e)!==OBJECT&&n!==FUNCTION&&throwTypeError("Prototype must be an Object or function: "+dumpObj(e)),r[PROTOTYPE]=e,safe(function(){r[__PROTO__]=e}),new r),t&&safe(objDefineProperties,[n,t]),n}function utcNow(){return(Date.now||polyUtcNow)()}function polyUtcNow(){return(new Date).getTime()}function fnApply(e,t,n){return e.apply(t,n)}function _initTestHooks(){_globalLazyTestHooks=_getGlobalConfig()}function getLazy(t,n){var r={};return _globalLazyTestHooks||_initTestHooks(),r.b=_globalLazyTestHooks.lzy,objDefineProp(r,"v",{configurable:!0,get:function(){var e=fnApply(t,null,n);return _globalLazyTestHooks.lzy||objDefineProp(r,"v",{value:e}),r.b=_globalLazyTestHooks.lzy,e}}),r}var _polySymbols,_wellKnownSymbolCache,mathRandom=_pureRef(MathCls,"random"),_uniqueInstanceId=getLazy(function(){for(var e=utcNow().toString(36).slice(2);e.length<16;)e+=mathRandom().toString(36).slice(2);return e.substring(0,16)}),UNIQUE_REGISTRY_ID="_urid",POLY_SYM="$nw21sym",_polyId=0;function _globalSymbolRegistry(){var e;return _polySymbols||(e=_getGlobalConfig(),_polySymbols=e.gblSym=e.gblSym||{k:{},s:{}}),_polySymbols}function polyNewSymbol(e){var t="_"+_polyId+++"_"+_uniqueInstanceId.v,n=SYMBOL+"("+e+")";function r(e,t){objDefine(o,e,{v:t,e:!1,w:!1})}var o=objCreate(null);return r("description",asString(e)),r(TO_STRING,function(){return n+POLY_SYM+t}),r("valueOf",function(){return o}),r("v",n),r("_uid",t),_tagAsPolyfill(o,"symbol")}function polySymbolFor(e){var t,n,r=_globalSymbolRegistry();return objHasOwn(r.k,e)||(t=polyNewSymbol(e),n=objKeys(r.s).length,t[UNIQUE_REGISTRY_ID]=function(){return n+"_"+t[TO_STRING]()},r.k[e]=t,r.s[t[UNIQUE_REGISTRY_ID]()]=asString(e)),r.k[e]}function polyGetKnownSymbol(e){_wellKnownSymbolCache=_wellKnownSymbolCache||{};e=_wellKnownSymbolMap[e];return e?_wellKnownSymbolCache[e]=_wellKnownSymbolCache[e]||polyNewSymbol(SYMBOL+"."+e):void 0}function createCachedValue(e){return objDefineProp({toJSON:function(){return e}},"v",{value:e})}var _cachedGlobal,WINDOW="window";function _getGlobalInstFn(e,t){var n;return function(){return _globalLazyTestHooks||_initTestHooks(),(n=n&&!_globalLazyTestHooks.lzy?n:createCachedValue(safe(e,t).v)).v}}function getGlobal(e){return _globalLazyTestHooks||_initTestHooks(),(_cachedGlobal=_cachedGlobal&&!1!==e&&!_globalLazyTestHooks.lzy?_cachedGlobal:createCachedValue(safe(_getGlobalValue).v||NULL_VALUE)).v}function getInst(e,t){t=_cachedGlobal&&!1!==t?_cachedGlobal.v:getGlobal(t);if(t&&t[e])return t[e];if(e===WINDOW)try{return window}catch(n){}return NULL_VALUE}function hasDocument(){return!!getDocument()}var getDocument=_getGlobalInstFn(getInst,["document"]);function hasWindow(){return!!getWindow()}var getWindow=_getGlobalInstFn(getInst,[WINDOW]);function hasNavigator(){return!!getNavigator()}var _symbol,_symbolFor,_iterSymbol$1,getNavigator=_getGlobalInstFn(getInst,["navigator"]),isNode=_getGlobalInstFn(function(){return!!safe(function(){return process&&(process.versions||{}).node}).v});function _initSymbol(){return _symbol=createCachedValue(safe(getInst,[SYMBOL]).v)}function _getSymbolKey(e){var t=(_globalLazyTestHooks.lzy?0:_symbol)||_initSymbol();return t.v?t.v[e]:UNDEF_VALUE}function hasSymbol(){return!!getSymbol()}function getSymbol(){return _globalLazyTestHooks||_initTestHooks(),((_globalLazyTestHooks.lzy?0:_symbol)||_initSymbol()).v}function getKnownSymbol(e,t){var n=_wellKnownSymbolMap[e],r=(_globalLazyTestHooks||_initTestHooks(),(_globalLazyTestHooks.lzy?0:_symbol)||_initSymbol());return r.v?r.v[n||e]:t?UNDEF_VALUE:polyGetKnownSymbol(e)}function newSymbol(e,t){_globalLazyTestHooks||_initTestHooks();var n=(_globalLazyTestHooks.lzy?0:_symbol)||_initSymbol();return n.v?n.v(e):t?NULL_VALUE:polyNewSymbol(e)}function symbolFor(e){return _globalLazyTestHooks||_initTestHooks(),((_symbolFor=(_globalLazyTestHooks.lzy?0:_symbolFor)||createCachedValue(safe(_getSymbolKey,["for"]).v)).v||polySymbolFor)(e)}function isIterator(e){return!!e&&isFunction(e.next)}function isIterable(e){return!isStrictNullOrUndefined(e)&&isFunction(e[getKnownSymbol(3)])}function iterForOf(e,t,n){if(e&&(isIterator(e)||(e=e[(_iterSymbol$1=_iterSymbol$1||createCachedValue(getKnownSymbol(3))).v]?e[_iterSymbol$1.v]():NULL_VALUE),isIterator(e))){var r=UNDEF_VALUE,o=UNDEF_VALUE;try{for(var i=0;!(o=e.next()).done&&-1!==t[CALL](n||e,o.value,i,e);)i++}catch(a){r={e:a},e["throw"]&&(o=NULL_VALUE,e["throw"](r))}finally{try{o&&!o.done&&e["return"]&&e["return"](o)}finally{if(r)throw r.e}}}}function arrAppend(t,e){return!isUndefined(e)&&t&&(isArray(e)?fnApply(t.push,t,e):isIterator(e)||isIterable(e)?iterForOf(e,function(e){t.push(e)}):t.push(e)),t}var arrIndexOf=_unwrapFunctionWithPoly("indexOf",ArrProto),arrMap=_unwrapFunctionWithPoly("map",ArrProto);function arrSlice(e,t,n){return((e?e.slice:NULL_VALUE)||ArrSlice).apply(e,ArrSlice[CALL](arguments,1))}var _isProtoArray,arrReduce=_unwrapFunctionWithPoly("reduce",ArrProto),objSetPrototypeOf=_pureAssign(_pureRef(ObjClass$1,"setPrototypeOf"),_polyObjSetPrototypeOf);function _polyObjSetPrototypeOf(n,e){var t;return(_isProtoArray=_isProtoArray||createCachedValue(((t={})[__PROTO__]=[],t instanceof Array))).v?n[__PROTO__]=e:objForEachKey(e,function(e,t){return n[e]=t}),n}function _createCustomError(e,t,n){function r(){this[CONSTRUCTOR]=t,safe(objDefine,[this,NAME,{v:e,c:!0,e:!1}])}return safe(objDefine,[t,NAME,{v:e,c:!0,e:!1}]),(t=objSetPrototypeOf(t,n))[PROTOTYPE]=n===NULL_VALUE?objCreate(n):(r[PROTOTYPE]=n[PROTOTYPE],new r),t}function _setName(e,t){t&&(e[NAME]=t)}function createCustomError(o,i,e){var a=e||Error,_=a[PROTOTYPE][NAME],s=Error.captureStackTrace;return _createCustomError(o,function(){var e=this,t=arguments;try{safe(_setName,[a,o]);var n,r=fnApply(a,e,ArrSlice[CALL](t))||e;return r!==e&&(n=objGetPrototypeOf(e))!==objGetPrototypeOf(r)&&objSetPrototypeOf(r,n),s&&s(r,e[CONSTRUCTOR]),i&&i(r,t),r}finally{safe(_setName,[a,_])}},a)}function _createTrimFn(t){return function(e){return _throwIfNullOrUndefined(e),e&&e.replace?e.replace(t,EMPTY):e}}var _fnToString,_objCtrFnString,_gblWindow,polyStrTrim=_createTrimFn(/^\s+|(?=\s)\s+$/g),strTrim=_unwrapFunctionWithPoly("trim",StrProto,polyStrTrim),mathFloor=_pureRef(MathCls,"floor");function isPlainObject(e){if(!e||typeof e!==OBJECT)return!1;var t=!1;if(e!==(_gblWindow=_gblWindow||!hasWindow()||getWindow())){_objCtrFnString||(_fnToString=Function[PROTOTYPE][TO_STRING],_objCtrFnString=_fnToString[CALL](ObjClass$1));try{var n=objGetPrototypeOf(e),t=(t=!n)||!(!(n=objHasOwnProperty(n,CONSTRUCTOR)?n[CONSTRUCTOR]:n)||typeof n!==FUNCTION||_fnToString[CALL](n)!==_objCtrFnString)}catch(r){}}return t}function _defaultDeepCopyHandler(e){return e.value&&plainObjDeepCopyHandler(e),!0}var defaultDeepCopyHandlers=[arrayDeepCopyHandler,plainObjDeepCopyHandler,functionDeepCopyHandler,dateDeepCopyHandler];function _getSetVisited(e,t,n,r){var o;return arrForEach(e,function(e){if(e.k===t)return o=e,-1}),o||(o={k:t,v:t},e.push(o),r(o)),o.v}function _deepCopy(n,e,r,t){var o=r.handler,t=r.path?t?r.path.concat(t):r.path:[],i={handler:r.handler,src:r.src,path:t},a=typeof e,_=!1,s=e===NULL_VALUE,u=(s||(e&&a===OBJECT?_=isPlainObject(e):s=isPrimitiveType(a)),{type:a,isPrim:s,isPlain:_,value:e,result:e,path:t,origin:r.src,copy:function(e,t){return _deepCopy(n,e,t?i:r,t)},copyTo:function(e,t){return _copyProps(n,e,t,i)}});return u.isPrim?o&&o[CALL](r,u)?u.result:e:_getSetVisited(n,e,t,function(t){objDefine(u,"result",{g:function(){return t.v},s:function(e){t.v=e}});for(var e=0,n=o;!(n||(e<defaultDeepCopyHandlers.length?defaultDeepCopyHandlers[e++]:_defaultDeepCopyHandler))[CALL](r,u);)n=NULL_VALUE})}function _copyProps(e,t,n,r){if(!isNullOrUndefined(n))for(var o in n)t[o]=_deepCopy(e,n[o],r,o);return t}function objCopyProps(e,t,n){return _copyProps([],e,t,{handler:n,src:t,path:[]})}function objDeepCopy(e,t){return _deepCopy([],e,{handler:t,src:e})}function arrayDeepCopyHandler(e){var t,n=e.value;return!!isArray(n)&&((t=e.result=[]).length=n.length,e.copyTo(t,n),!0)}function dateDeepCopyHandler(e){var t=e.value;return!!isDate(t)&&(e.result=new Date(t.getTime()),!0)}function functionDeepCopyHandler(e){return e.type===FUNCTION}function plainObjDeepCopyHandler(e){var t,n=e.value;return!(!n||!e.isPlain||(t=e.result={},e.copyTo(t,n),0))}function _doExtend(t,e){return arrForEach(e,function(e){objCopyProps(t,e)}),t}function deepExtend(e,t,n,r,o,i,a){return _doExtend(objDeepCopy(e)||{},ArrSlice[CALL](arguments))}var getLength=_unwrapProp(LENGTH),mathRound=_pureRef(MathCls,"round"),objGetOwnPropertyDescriptor=_pureAssign(_pureRef(ObjClass$1,GET_OWN_PROPERTY_DESCRIPTOR),_returnNothing),strEndsWith=_unwrapFunctionWithPoly("endsWith",StrProto,polyStrEndsWith);function polyStrEndsWith(e,t,n){_throwIfNotString(e);t=isString(t)?t:asString(t),n=!isUndefined(n)&&n<e[LENGTH]?n:e[LENGTH];return strSubstring(e,n-t[LENGTH],n)===t}var _setTimeoutFn,_clearTimeoutFn,_a$6,strIndexOf=_unwrapFunctionWithPoly("indexOf",StrProto),REF="ref",UNREF="unref",HAS_REF="hasRef",ENABLED="enabled";function _createTimerHandler(e,t,n){var r,o=!0,i=e?t(NULL_VALUE):NULL_VALUE;function a(){return o=!1,i&&i[UNREF]&&i[UNREF](),r}function _(){i&&n(i),i=NULL_VALUE}function s(){return i=t(i),o||a(),r}return(r={cancel:_,refresh:s})[HAS_REF]=function(){return i&&i[HAS_REF]?i[HAS_REF]():o},r[REF]=function(){return o=!0,i&&i[REF]&&i[REF](),r},r[UNREF]=a,{h:r=objDefineProp(r,ENABLED,{get:function(){return!!i},set:function(e){!e&&i&&_(),e&&!i&&s()}}),dn:function(){i=NULL_VALUE}}}function _resolveTimeoutFn(e){var t,e=isFunction(e)?e:_setTimeoutFn;return e||(t=_getGlobalConfig().tmOut||[],isArray(t)&&0<t.length&&isFunction(t[0])&&(e=t[0])),e||setTimeout}function _resolveClearTimeoutFn(e){var t,e=isFunction(e)?e:_clearTimeoutFn;return e||(t=_getGlobalConfig().tmOut||[],isArray(t)&&1<t.length&&isFunction(t[1])&&(e=t[1])),e||clearTimeout}function _createTimeoutWith(e,t,n){var r=isArray(t),o=r?t.length:0,i=_resolveTimeoutFn(0<o?t[0]:r?UNDEF_VALUE:t),a=_resolveClearTimeoutFn(1<o?t[1]:UNDEF_VALUE),_=n[0],s=(n[0]=function(){s.dn(),fnApply(_,UNDEF_VALUE,ArrSlice[CALL](arguments))},_createTimerHandler(e,function(e){if(e){if(e.refresh)return e.refresh(),e;fnApply(a,UNDEF_VALUE,[e])}return fnApply(i,UNDEF_VALUE,n)},function(e){fnApply(a,UNDEF_VALUE,[e])}));return s.h}function scheduleTimeout(e,t){return _createTimeoutWith(!0,UNDEF_VALUE,ArrSlice[CALL](arguments))}function createTimeout(e,t){return _createTimeoutWith(!1,UNDEF_VALUE,ArrSlice[CALL](arguments))}var Constructor="constructor",Prototype="prototype",strFunction="function",DynInstFuncTable="_dynInstFuncs",DynProxyTag="_isDynProxy",DynClassName="_dynClass",DynClassNamePrefix="_dynCls$",DynInstChkTag="_dynInstChk",DynAllowInstChkTag=DynInstChkTag,DynProtoDefaultOptions="_dfOpts",UnknownValue="_unknown_",str__Proto="__proto__",DynProtoBaseProto="_dyn"+str__Proto,DynProtoGlobalSettings="__dynProto$Gbl",DynProtoCurrent="_dynInstProto",strUseBaseInst="useBaseInst",strSetInstFuncs="setInstFuncs",Obj=Object,_objGetPrototypeOf=Obj.getPrototypeOf,_objGetOwnProps=Obj.getOwnPropertyNames,_gbl=getGlobal(),_gblInst=_gbl[DynProtoGlobalSettings]||(_gbl[DynProtoGlobalSettings]={o:((_a$6={})[strSetInstFuncs]=!0,_a$6[strUseBaseInst]=!0,_a$6),n:1e3});function _isObjectOrArrayPrototype(e){return e&&(e===Obj[Prototype]||e===Array[Prototype])}function _isObjectArrayOrFunctionPrototype(e){return _isObjectOrArrayPrototype(e)||e===Function[Prototype]}function _getObjProto(e){if(e){if(_objGetPrototypeOf)return _objGetPrototypeOf(e);var t=e[str__Proto]||e[Prototype]||(e[Constructor]?e[Constructor][Prototype]:null),n=e[DynProtoBaseProto]||t;objHasOwnProperty(e,DynProtoBaseProto)||(delete e[DynProtoCurrent],n=e[DynProtoBaseProto]=e[DynProtoCurrent]||e[DynProtoBaseProto],e[DynProtoCurrent]=t)}return n}function _forEachProp(e,t){var n=[];if(_objGetOwnProps)n=_objGetOwnProps(e);else for(var r in e)"string"==typeof r&&objHasOwnProperty(e,r)&&n.push(r);if(n&&0<n.length)for(var o=0;o<n.length;o++)t(n[o])}function _isDynamicCandidate(e,t,n){return t!==Constructor&&typeof e[t]===strFunction&&(n||objHasOwnProperty(e,t))&&t!==str__Proto&&t!==Prototype}function _throwTypeError(e){throwTypeError("DynamicProto: "+e)}function _getInstanceFuncs(t){var n=objCreate(null);return _forEachProp(t,function(e){!n[e]&&_isDynamicCandidate(t,e,!1)&&(n[e]=t[e])}),n}function _hasVisited(e,t){for(var n=e.length-1;0<=n;n--)if(e[n]===t)return!0;return!1}function _getBaseFuncs(e,t,n,i){function r(e,t,n){var r,o=t[n];return o[DynProxyTag]&&i&&!1!==(r=e[DynInstFuncTable]||{})[DynAllowInstChkTag]&&(o=(r[t[DynClassName]]||{})[n]||o),function(){return o.apply(e,arguments)}}for(var o=objCreate(null),a=(_forEachProp(n,function(e){o[e]=r(t,n,e)}),_getObjProto(e)),_=[];a&&!_isObjectArrayOrFunctionPrototype(a)&&!_hasVisited(_,a);)_forEachProp(a,function(e){!o[e]&&_isDynamicCandidate(a,e,!_objGetPrototypeOf)&&(o[e]=r(t,a,e))}),_.push(a),a=_getObjProto(a);return o}function _getInstFunc(e,t,n,r){var o=null;if(e&&objHasOwnProperty(n,DynClassName)){var i=e[DynInstFuncTable]||objCreate(null);if((o=(i[n[DynClassName]]||objCreate(null))[t])||_throwTypeError("Missing ["+t+"] "+strFunction),!o[DynInstChkTag]&&!1!==i[DynAllowInstChkTag]){for(var a=!objHasOwnProperty(e,t),_=_getObjProto(e),s=[];a&&_&&!_isObjectArrayOrFunctionPrototype(_)&&!_hasVisited(s,_);){var u=_[t];if(u){a=u===r;break}s.push(_),_=_getObjProto(_)}try{a&&(e[t]=o),o[DynInstChkTag]=1}catch(c){i[DynAllowInstChkTag]=!1}}}return o}function _getProtoFunc(e,t,n){var r=t[e];return typeof(r=r===n?_getObjProto(t)[e]:r)!==strFunction&&_throwTypeError("["+e+"] is not a "+strFunction),r}function _populatePrototype(o,e,i,a,t){var n,_;_isObjectOrArrayPrototype(o)||_isObjectOrArrayPrototype(n=i[DynInstFuncTable]=i[DynInstFuncTable]||objCreate(null))||(_=n[e]=n[e]||objCreate(null),!1!==n[DynAllowInstChkTag]&&(n[DynAllowInstChkTag]=!!t),_isObjectOrArrayPrototype(_)||_forEachProp(i,function(e){var t,n,r;_isDynamicCandidate(i,e,!1)&&i[e]!==a[e]&&(_[e]=i[e],delete i[e],objHasOwnProperty(o,e)&&(!o[e]||o[e][DynProxyTag])||(o[e]=(t=o,n=e,(r=function(){return(_getInstFunc(this,n,t,r)||_getProtoFunc(n,t,r)).apply(this,arguments)})[DynProxyTag]=1,r)))}))}function _checkPrototype(e,t){if(_objGetPrototypeOf){for(var n=[],r=_getObjProto(t);r&&!_isObjectArrayOrFunctionPrototype(r)&&!_hasVisited(n,r);){if(r===e)return!0;n.push(r),r=_getObjProto(r)}return!1}return!0}function _getObjName(e,t){return objHasOwnProperty(e,Prototype)?e.name||t||UnknownValue:((e||{})[Constructor]||{}).name||t||UnknownValue}function dynamicProto(e,t,n,r){objHasOwnProperty(e,Prototype)||_throwTypeError("theClass is an invalid class definition.");var o=e[Prototype],i=(_checkPrototype(o,t)||_throwTypeError("["+_getObjName(e)+"] not in hierarchy of ["+_getObjName(t)+"]"),null),e=(objHasOwnProperty(o,DynClassName)?i=o[DynClassName]:(i=DynClassNamePrefix+_getObjName(e,"_")+"$"+_gblInst.n,_gblInst.n++,o[DynClassName]=i),dynamicProto[DynProtoDefaultOptions]),a=!!e[strUseBaseInst],_=(a&&r&&r[strUseBaseInst]!==undefined&&(a=!!r[strUseBaseInst]),_getInstanceFuncs(t)),a=(n(t,_getBaseFuncs(o,t,_,a)),!!_objGetPrototypeOf&&!!e[strSetInstFuncs]);_populatePrototype(o,i,t,_,!1!==(a=a&&r?!!r[strSetInstFuncs]:a))}dynamicProto[DynProtoDefaultOptions]=_gblInst.o;var strShimFunction="function",strShimObject="object",strShimUndefined="undefined",strShimPrototype="prototype",ObjClass=Object,ObjProto=ObjClass[strShimPrototype],strHasOwnProperty=((getGlobal()||{}).Symbol,(getGlobal()||{}).Reflect,"hasOwnProperty"),__objAssignFnImpl=function(e){for(var t,n=1,r=arguments.length;n<r;n++)for(var o in t=arguments[n])ObjProto[strHasOwnProperty].call(t,o)&&(e[o]=t[o]);return e},__assignFn=objAssign||__objAssignFnImpl,extendStaticsFn=function(e,t){return(extendStaticsFn=ObjClass.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t[strHasOwnProperty](n)&&(e[n]=t[n])})(e,t)};function __extendsFn(e,t){function n(){this.constructor=e}typeof t!==strShimFunction&&null!==t&&throwTypeError("Class extends value "+t+" is not a constructor or null"),extendStaticsFn(e,t),e[strShimPrototype]=null===t?objCreate(t):(n[strShimPrototype]=t[strShimPrototype],new n)}function __spreadArrayFn(e,t){for(var n=0,r=t.length,o=e.length;n<r;n++,o++)e[o]=t[n];return e}var aggregationErrorType,createEnumStyle=createEnum,createValueMap=createTypeMap,ActiveStatus=createEnumStyle({NONE:0,PENDING:3,INACTIVE:1,ACTIVE:2}),_DYN_TO_LOWER_CASE$1="toLowerCase",_DYN_LENGTH$2="length",_DYN_WARN_TO_CONSOLE="warnToConsole",_DYN_THROW_INTERNAL="throwInternal",_DYN_WATCH="watch",_DYN_APPLY="apply",_DYN_PUSH$1="push",_DYN_SPLICE="splice",_DYN_LOGGER="logger",_DYN_CANCEL="cancel",_DYN_INITIALIZE$1="initialize",_DYN_IDENTIFIER="identifier",_DYN_REMOVE_NOTIFICATION_0="removeNotificationListener",_DYN_ADD_NOTIFICATION_LIS1="addNotificationListener",_DYN_IS_INITIALIZED="isInitialized",_DYN_GET_NOTIFY_MGR="getNotifyMgr",_DYN_GET_PLUGIN="getPlugin",_DYN_NAME$2="name",_DYN_PROCESS_NEXT="processNext",_DYN_GET_PROCESS_TEL_CONT2="getProcessTelContext",_DYN_VALUE="value",_DYN_ENABLED="enabled",_DYN_STOP_POLLING_INTERNA3="stopPollingInternalLogs",_DYN_UNLOAD="unload",_DYN_ON_COMPLETE="onComplete",_DYN_VERSION="version",_DYN_LOGGING_LEVEL_CONSOL4="loggingLevelConsole",_DYN_CREATE_NEW="createNew",_DYN_TEARDOWN="teardown",_DYN_MESSAGE_ID="messageId",_DYN_MESSAGE$1="message",_DYN_DIAG_LOG$1="diagLog",_DYN__DO_TEARDOWN="_doTeardown",_DYN_UPDATE="update",_DYN_GET_NEXT="getNext",_DYN_SET_NEXT_PLUGIN="setNextPlugin",_DYN_USER_AGENT="userAgent",_DYN_SPLIT$1="split",_DYN_REPLACE="replace",_DYN_TYPE="type",_DYN_EVT_NAME="evtName",_DYN_STATUS="status",_DYN_INDEX_OF="indexOf",_DYN_GET_ALL_RESPONSE_HEA5="getAllResponseHeaders",_DYN_IS_CHILD_EVT="isChildEvt",_DYN_DATA$1="data",_DYN_GET_CTX="getCtx",_DYN_SET_CTX="setCtx",_DYN_ITEMS_RECEIVED$1="itemsReceived",_DYN_HEADERS="headers",_DYN_URL_STRING="urlString",_DYN_TIMEOUT="timeout",_DYN_TRACE_FLAGS="traceFlags";function throwAggregationError(e,t){aggregationErrorType=aggregationErrorType||createCustomError("AggregationError",function(e,t){1<t[_DYN_LENGTH$2]&&(e.errors=t[1])});var n=e||"One or more errors occurred.";throw arrForEach(t,function(e,t){n+="\n".concat(t," > ").concat(dumpObj(e))}),new aggregationErrorType(n,t||[])}var STR_PROMISE="Promise",REJECTED="rejected";function doAwaitResponse(e,t){return doAwait(e,function(e){return t?t({status:"fulfilled",rejected:!1,value:e}):e},function(e){return t?t({status:REJECTED,rejected:!0,reason:e}):e})}function doAwait(e,t,n,r){var o=e;try{if(isPromiseLike(e))(t||n)&&(o=e.then(t,n));else try{t&&(o=t(e))}catch(i){if(!n)throw i;o=n(i)}}finally{r&&doFinally(o,r)}return o}function doFinally(e,t){var n=e;return t&&(isPromiseLike(e)?n=e["finally"]?e["finally"](t):e.then(function(e){return t(),e},function(e){throw t(),e}):t()),n}var _hasInitEvent,STRING_STATES=["pending","resolving","resolved",REJECTED],DISPATCH_EVENT="dispatchEvent";function _hasInitEventFn(e){var t;return!!(t=e&&e.createEvent?e.createEvent("Event"):t)&&t.initEvent}function emitEvent(e,t,n,r){var o=getDocument(),o=(_hasInitEvent=_hasInitEvent||createCachedValue(!!safe(_hasInitEventFn,[o]).v)).v?o.createEvent("Event"):r?new Event(t):{};n&&n(o),_hasInitEvent.v&&o.initEvent(t,!1,!0),o&&e[DISPATCH_EVENT]?e[DISPATCH_EVENT](o):(r=e["on"+t])?r(o):(n=getInst("console"))&&(n.error||n.log)(t,dumpObj(o))}var _hasPromiseRejectionEvent,_promiseCls,_allSyncSettledCreator,_promiseCreator,NODE_UNHANDLED_REJECTION="unhandledRejection",UNHANDLED_REJECTION=NODE_UNHANDLED_REJECTION.toLowerCase(),_unhandledRejectionTimeout=10;function dumpFnObj(e){return isFunction(e)?e.toString():dumpObj(e)}function _createPromise(e,t,n){var _,r,o=arrSlice(arguments,3),s=0,u=!1,c=[],l=!1,N=null;function i(i,a){return l=!0,N&&N.cancel(),N=null,e(function(r,o){c.push(function(){try{var e=2===s?i:a,t=isUndefined(e)?_:isFunction(e)?e(_):e;isPromiseLike(t)?t.then(r,o):(e||3!==s?r:o)(t)}catch(n){o(n)}}),u&&E()},o)}function a(){return STRING_STATES[s]}function E(){var e;0<c.length&&(e=c.slice(),c=[],l=!0,N&&N.cancel(),N=null,t(e))}function f(t,n){return function(e){if(s===n){if(2===t&&isPromiseLike(e))return s=1,void e.then(f(2,1),f(3,1));s=t,u=!0,_=e,E(),l||3!==t||N||(N=scheduleTimeout(D,_unhandledRejectionTimeout))}}}function D(){var e;l||(l=!0,isNode()?process.emit(NODE_UNHANDLED_REJECTION,_,r):(e=getWindow()||getGlobal(),_hasPromiseRejectionEvent=_hasPromiseRejectionEvent||createCachedValue(safe(getInst,[STR_PROMISE+"RejectionEvent"]).v),emitEvent(e,UNHANDLED_REJECTION,function(e){return objDefine(e,"promise",{g:function(){return r}}),e.reason=_,e},!!_hasPromiseRejectionEvent.v)))}objDefineProp(r={then:i,"catch":function(e){return i(undefined,e)},"finally":function(t){var e=t,n=t;return isFunction(t)&&(e=function(e){return t&&t(),e},n=function(e){throw t&&t(),e}),i(e,n)}},"state",{get:a}),hasSymbol()&&(r[getKnownSymbol(11)]="IPromise"),r.toString=function(){return"IPromise "+a()+(u?" - "+dumpFnObj(_):"")},isFunction(n)||throwTypeError(STR_PROMISE+": executor is not a function - "+dumpFnObj(n));var d=f(3,0);try{n.call(r,f(2,0),d)}catch(T){d(T)}return r}function _createAllPromise(n){return function(t){var e=arrSlice(arguments,1);return n(function(n,r){try{var o=[],i=1;iterForOf(t,function(e,t){e&&(i++,doAwait(e,function(e){o[t]=e,0==--i&&n(o)},r))}),0==--i&&n(o)}catch(e){r(e)}},e)}}function _createAllSettledPromise(t){return createCachedValue(function(a){var e=arrSlice(arguments,1);return t(function(n,e){var r=[],o=1;function t(e,t){o++,doAwaitResponse(e,function(e){e.rejected?r[t]={status:REJECTED,reason:e.reason}:r[t]={status:"fulfilled",value:e.value},0==--o&&n(r)})}try{isArray(a)?arrForEach(a,t):isIterable(a)?iterForOf(a,t):throwTypeError("Input is not an iterable"),0==--o&&n(r)}catch(i){e(i)}},e)})}function syncItemProcessor(e){arrForEach(e,function(e){try{e()}catch(t){}})}function timeoutItemProcessor(e){var t=isNumber(e)?e:0;return function(e){scheduleTimeout(function(){syncItemProcessor(e)},t)}}function createAsyncPromise(e,t){return _createPromise(createAsyncPromise,timeoutItemProcessor(t),e,t)}function createNativePromise(e,t){var n=(_promiseCls=_promiseCls||createCachedValue(safe(getInst,[STR_PROMISE]).v||null)).v;if(!n)return createAsyncPromise(e);isFunction(e)||throwTypeError(STR_PROMISE+": executor is not a function - "+dumpObj(e));var r=0,n=new n(function(t,n){e(function(e){r=2,t(e)},function(e){r=3,n(e)})});return objDefineProp(n,"state",{get:function(){return STRING_STATES[r]}}),n}function createSyncPromise(e){return _createPromise(createSyncPromise,syncItemProcessor,e)}function createSyncAllSettledPromise(e,t){return(_allSyncSettledCreator=_allSyncSettledCreator||_createAllSettledPromise(createSyncPromise)).v(e,t)}function createPromise(e,t){return(_promiseCreator=_promiseCreator||createCachedValue(createNativePromise)).v.call(this,e,t)}var createAllPromise=_createAllPromise(createPromise),UNDEFINED_VALUE$2=undefined,STR_EMPTY$1="",STR_CHANNELS="channels",STR_CORE="core",STR_CREATE_PERF_MGR="createPerfMgr",STR_DISABLED="disabled",STR_EXTENSION_CONFIG="extensionConfig",STR_EXTENSIONS="extensions",STR_PROCESS_TELEMETRY="processTelemetry",STR_PRIORITY="priority",STR_EVENTS_SENT="eventsSent",STR_EVENTS_DISCARDED="eventsDiscarded",STR_EVENTS_SEND_REQUEST="eventsSendRequest",STR_PERF_EVENT="perfEvent",STR_OFFLINE_STORE="offlineEventsStored",STR_OFFLINE_SENT="offlineBatchSent",STR_OFFLINE_DROP="offlineBatchDrop",STR_GET_PERF_MGR="getPerfMgr",STR_DOMAIN="domain",STR_PATH="path",STR_NOT_DYNAMIC_ERROR="Not dynamic - ",rCamelCase=/-([a-z])/g,rNormalizeInvalid=/([^\w\d_$])/g,rLeadingNumeric=/^(\d+[\w\d_$])/;function isNotNullOrUndefined(e){return!isNullOrUndefined(e)}function normalizeJsName(e){return e&&isString(e)?(e=(e=e[_DYN_REPLACE](rCamelCase,function(e,t){return t.toUpperCase()}))[_DYN_REPLACE](rNormalizeInvalid,"_"))[_DYN_REPLACE](rLeadingNumeric,function(e,t){return"_"+t}):e}function strContains(e,t){return!(!e||!t)&&-1!==strIndexOf(e,t)}function toISOString(e){return e&&e.toISOString()||""}function getExceptionName(e){return isError(e)?e[_DYN_NAME$2]:STR_EMPTY$1}function setValue(e,t,n,r,o){var i=n;return!e||(i=e[t])===n||o&&!o(i)||r&&!r(n)||(e[t]=i=n),i}function getSetValue(e,t,n){var r;return e?!(r=e[t])&&isNullOrUndefined(r)&&(r=isUndefined(n)?{}:n,e[t]=r):r=isUndefined(n)?{}:n,r}function _createProxyFunction(e,t){var n=null,r=null;return isFunction(e)?n=e:r=e,function(){var e=arguments;if(r=n?n():r)return r[t][_DYN_APPLY](r,e)}}function proxyFunctionAs(e,t,n,r,o){e&&t&&n&&(!1===o&&!isUndefined(e[t])||(e[t]=_createProxyFunction(n,r)))}function proxyFunctions(t,n,e,r){return t&&n&&isObject(t)&&isArray(e)&&arrForEach(e,function(e){isString(e)&&proxyFunctionAs(t,e,n,e,r)}),t}function createClassFromInterface(e){return function(){var n=this;e&&objForEachKey(e,function(e,t){n[e]=t})}}function optimizeObject(e){return e&&objAssign?ObjClass(objAssign({},e)):e}function objExtend(e,t,n,r,o,i){var a=arguments,_=a[0]||{},s=a[_DYN_LENGTH$2],u=!1,c=1;for(0<s&&isBoolean(_)&&(u=_,_=a[c]||{},c++),isObject(_)||(_={});c<s;c++){var l,N,E,f,D=a[c],d=isArray(D),T=isObject(D);for(l in D)(d&&l in D||T&&objHasOwn(D,l))&&(N=D[l],E=void 0,u&&N&&((E=isArray(N))||isPlainObject(N))&&(f=_[l],E?isArray(f)||(f=[]):isPlainObject(f)||(f={}),N=objExtend(u,f,N)),N!==undefined&&(_[l]=N))}return _}function isFeatureEnabled(e,t,n){t=t&&t.featureOptIn&&t.featureOptIn[e];if(e&&t){e=t.mode;if(3===e)return!0;if(2===e)return!1}return n}function getResponseText(e){try{return e.responseText}catch(t){}return null}function formatErrorMessageXdr(e,t){return e?"XDomainRequest,Response:"+getResponseText(e)||"":t}function formatErrorMessageXhr(e,t){return e?"XMLHttpRequest,Status:"+e[_DYN_STATUS]+",Response:"+getResponseText(e)||e.response||"":t}function prependTransports(e,t){return t&&(isNumber(t)?e=[t].concat(e):isArray(t)&&(e=t.concat(e))),e}var strDisabledPropertyName="Microsoft_ApplicationInsights_BypassAjaxInstrumentation",strWithCredentials="withCredentials",strTimeout="timeout";function openXhr(e,t,n,r,o,i){function a(e,t,n){try{e[t]=n}catch(r){}}void 0===r&&(r=!1),void 0===o&&(o=!1);var _=new XMLHttpRequest;return r&&a(_,strDisabledPropertyName,r),n&&a(_,strWithCredentials,n),_.open(e,t,!o),n&&a(_,strWithCredentials,n),!o&&i&&a(_,strTimeout,i),_}function convertAllHeadersToMap(e){var r={};return isString(e)&&arrForEach(strTrim(e)[_DYN_SPLIT$1](/[\r\n]+/),function(e){var t,n;e&&(-1!==(n=e[_DYN_INDEX_OF](": "))?(t=strTrim(e.substring(0,n))[_DYN_TO_LOWER_CASE$1](),n=strTrim(e.substring(n+1)),r[t]=n):r[strTrim(e)]=1)}),r}function _appendHeader(e,t,n){return!e[n]&&t&&t.getResponseHeader&&(t=t.getResponseHeader(n))&&(e[n]=strTrim(t)),e}var STR_KILL_DURATION_HEADER="kill-duration",STR_KILL_DURATION_SECONDS_HEADER="kill-duration-seconds",STR_TIME_DELTA_HEADER="time-delta-millis";function _getAllResponseHeaders(e,t){var n={};return e[_DYN_GET_ALL_RESPONSE_HEA5]?n=convertAllHeadersToMap(e[_DYN_GET_ALL_RESPONSE_HEA5]()):t&&(n=_appendHeader(n,e,STR_TIME_DELTA_HEADER),n=_appendHeader(n,e,STR_KILL_DURATION_HEADER),n=_appendHeader(n,e,STR_KILL_DURATION_SECONDS_HEADER)),n}var strDocumentMode="documentMode",strLocation="location",strConsole="console",strJSON="JSON",strCrypto="crypto",strMsCrypto="msCrypto",strMsie="msie",strTrident="trident/",strXMLHttpRequest="XMLHttpRequest",_isTrident=null,_navUserAgentCheck=null,_enableMocks=!1,_useXDomainRequest=null,_beaconsSupported=null;function _hasProperty(e,t){var n,r=!1;if(e){try{(r=t in e)||(n=e[strShimPrototype])&&(r=t in n)}catch(o){}if(!r)try{r=!isUndefined((new e)[t])}catch(o){}}return r}function getLocation(e){if(e&&_enableMocks){e=getInst("__mockLocation");if(e)return e}return typeof location===strShimObject&&location?location:getInst(strLocation)}function getConsole(){return typeof console!==strShimUndefined?console:getInst(strConsole)}function hasJSON(){return!!(typeof JSON===strShimObject&&JSON||null!==getInst(strJSON))}function getJSON(){return hasJSON()?JSON||getInst(strJSON):null}function getCrypto(){return getInst(strCrypto)}function getMsCrypto(){return getInst(strMsCrypto)}function isIE(){var e=getNavigator();return!e||e[_DYN_USER_AGENT]===_navUserAgentCheck&&null!==_isTrident||(e=((_navUserAgentCheck=e[_DYN_USER_AGENT])||STR_EMPTY$1)[_DYN_TO_LOWER_CASE$1](),_isTrident=strContains(e,strMsie)||strContains(e,strTrident)),_isTrident}function getIEVersion(e){var t=((e=(e=void 0===e?null:e)?e:(t=getNavigator()||{})?(t.userAgent||STR_EMPTY$1)[_DYN_TO_LOWER_CASE$1]():STR_EMPTY$1)||STR_EMPTY$1)[_DYN_TO_LOWER_CASE$1]();if(strContains(t,strMsie))return e=getDocument()||{},mathMax(parseInt(t[_DYN_SPLIT$1](strMsie)[1]),e[strDocumentMode]||0);if(strContains(t,strTrident)){e=parseInt(t[_DYN_SPLIT$1](strTrident)[1]);if(e)return e+4}return null}function isBeaconsSupported(e){return _beaconsSupported=null!==_beaconsSupported&&!1!==e?_beaconsSupported:hasNavigator()&&!!getNavigator().sendBeacon}function isFetchSupported(e){var t=!1;try{var t=!!getInst("fetch"),n=getInst("Request");t&&e&&n&&(t=_hasProperty(n,"keepalive"))}catch(r){}return t}function useXDomainRequest(){return _useXDomainRequest=null===_useXDomainRequest&&(_useXDomainRequest=typeof XDomainRequest!==strShimUndefined)&&isXhrSupported()?_useXDomainRequest&&!_hasProperty(getInst(strXMLHttpRequest),"withCredentials"):_useXDomainRequest}function isXhrSupported(){var e=!1;try{e=!!getInst(strXMLHttpRequest)}catch(t){}return e}var UInt32Mask=4294967296,MaxUInt32=4294967295,SEED1=123456789,SEED2=987654321,_mwcSeeded=!1,_mwcW=SEED1,_mwcZ=SEED2;function _mwcSeed(e){e<0&&(e>>>=0),_mwcW=SEED1+e&MaxUInt32,_mwcZ=SEED2-e&MaxUInt32,_mwcSeeded=!0}function _autoSeedMwc(){try{var e=2147483647&utcNow();_mwcSeed((Math.random()*UInt32Mask^e)+e)}catch(t){}}function random32(e){var t=0,n=getCrypto()||getMsCrypto();return 0===(t=n&&n.getRandomValues?n.getRandomValues(new Uint32Array(1))[0]&MaxUInt32:t)&&isIE()&&(_mwcSeeded||_autoSeedMwc(),t=mwcRandom32()&MaxUInt32),0===t&&(t=mathFloor(UInt32Mask*Math.random()|0)),e||(t>>>=0),t}function mwcRandom32(e){var t=((_mwcZ=36969*(65535&_mwcZ)+(_mwcZ>>16)&MaxUInt32)<<16)+(65535&(_mwcW=18e3*(65535&_mwcW)+(_mwcW>>16)&MaxUInt32))>>>0&MaxUInt32|0;return e||(t>>>=0),t}function newId(e){void 0===e&&(e=22);for(var t=random32()>>>0,n=0,r=STR_EMPTY$1;r[_DYN_LENGTH$2]<e;)r+="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"[0|63&t]||"",t>>>=6,5==++n&&(t=(random32()<<2&4294967295|3&t)>>>0,n=0);return r}var version="3.3.9",instanceName="."+newId(6),_dataUid=0;function _canAcceptData(e){return 1===e.nodeType||9===e.nodeType||!+e.nodeType}function _getCache(e,t){var n=t[e.id];if(!n){n={};try{_canAcceptData(t)&&objDefine(t,e.id,{e:!1,v:n})}catch(r){}}return n}function createUniqueNamespace(e,t){return normalizeJsName(e+_dataUid+++((t=void 0!==t&&t)?"."+version:STR_EMPTY$1)+instanceName)}function createElmNodeData(e){var i={id:createUniqueNamespace("_aiData-"+(e||STR_EMPTY$1)+"."+version),accept:function(e){return _canAcceptData(e)},get:function(e,t,n,r){var o=e[i.id];return o?o[normalizeJsName(t)]:(r&&((o=_getCache(i,e))[normalizeJsName(t)]=n),n)},kill:function(e,t){if(e&&e[t])try{delete e[t]}catch(n){}}};return i}function _isConfigDefaults(e){return e&&isObject(e)&&!isArray(e)&&(e.isVal||e.fb||objHasOwn(e,"v")||objHasOwn(e,"mrg")||objHasOwn(e,"ref")||e.set)}function _getDefault(e,t,n){var r,o=n.dfVal||isDefined;if(t&&n.fb){var i=n.fb;isArray(i)||(i=[i]);for(var a=0;a<i[_DYN_LENGTH$2];a++){var _=i[a],s=t[_];if(o(s)?r=s:e&&(o(s=e.cfg[_])&&(r=s),e.set(e.cfg,asString(_),s)),o(r))break}}return!o(r)&&o(n.v)?n.v:r}function _resolveDefaultValue(n,r,e){var o,t=e;return(t=e&&_isConfigDefaults(e)?_getDefault(n,r,e):t)&&(_isConfigDefaults(t)&&(t=_resolveDefaultValue(n,r,t)),isArray(t)?(o=[])[_DYN_LENGTH$2]=t[_DYN_LENGTH$2]:isPlainObject(t)&&(o={}),o&&(objForEachKey(t,function(e,t){t&&_isConfigDefaults(t)&&(t=_resolveDefaultValue(n,r,t)),o[e]=t}),t=o)),t}function _applyDefaultValue(n,e,t,r){var o,i,a,_,s,u,c=r,c=_isConfigDefaults(c)?(o=c.isVal,i=c.set,s=c.rdOnly,l=c.blkVal,a=c.mrg,!(_=c.ref)&&isUndefined(_)&&(_=!!a),_getDefault(n,e,c)):r,r=(l&&n.blkVal(e,t),!0),l=e[t];!l&&isNullOrUndefined(l)||(u=l,r=!1,o&&u!==c&&!o(u)&&(u=c,r=!0),i&&(r=(u=i(u,c,e))===c)),r?u=c&&_resolveDefaultValue(n,e,c):(isPlainObject(u)||isArray(c))&&a&&c&&(isPlainObject(c)||isArray(c))&&objForEachKey(c,function(e,t){_applyDefaultValue(n,u,e,t)}),n.set(e,t,u),_&&n.ref(e,t),s&&n.rdOnly(e,t)}var CFG_HANDLER_LINK=symbolFor("[[ai_dynCfg_1]]"),BLOCK_DYNAMIC=symbolFor("[[ai_blkDynCfg_1]]"),FORCE_DYNAMIC=symbolFor("[[ai_frcDynCfg_1]]");function _cfgDeepCopy(e){var n;return e&&(isArray(e)?(n=[])[_DYN_LENGTH$2]=e[_DYN_LENGTH$2]:isPlainObject(e)&&(n={}),n)?(objForEachKey(e,function(e,t){n[e]=_cfgDeepCopy(t)}),n):e}function getDynamicConfigHandler(e){if(e){var t=e[CFG_HANDLER_LINK]||e;if(t.cfg&&(t.cfg===e||t.cfg[CFG_HANDLER_LINK]===t))return t}return null}function blockDynamicConversion(e){if(e&&(isPlainObject(e)||isArray(e)))try{e[BLOCK_DYNAMIC]=!0}catch(t){}return e}function _canMakeDynamic(e,t,n){var r=!1;return!n||e[t.blkVal]||(r=n[FORCE_DYNAMIC])||n[BLOCK_DYNAMIC]?r:isPlainObject(n)||isArray(n)}function throwInvalidAccess(e){throwTypeError("InvalidAccess:"+e)}var arrayMethodsToPatch=["push","pop","shift","unshift","splice"],_throwDynamicError=function(e,t,n,r){e&&e[_DYN_THROW_INTERNAL](3,108,"".concat(n," [").concat(t,"] failed - ")+dumpObj(r))};function _patchArray(o,i,a){isArray(i)&&arrForEach(arrayMethodsToPatch,function(e){var r=i[e];i[e]=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var n=r[_DYN_APPLY](this,e);return _makeDynamicObject(o,i,a,"Patching"),n}})}function _getOwnPropGetter(e,t){e=objGetOwnPropertyDescriptor(e,t);return e&&e.get}function _createDynamicProperty(o,i,a,_){var s={n:a,h:[],trk:function(e){e&&e.fn&&(-1===arrIndexOf(s.h,e)&&s.h[_DYN_PUSH$1](e),o.trk(e,s))},clr:function(e){e=arrIndexOf(s.h,e);-1!==e&&s.h[_DYN_SPLICE](e,1)}},u=!0,c=!1;function l(){u&&(c=c||_canMakeDynamic(l,o,_),_&&!_[CFG_HANDLER_LINK]&&c&&(_=_makeDynamicObject(o,_,a,"Converting")),u=!1);var e=o.act;return e&&s.trk(e),_}l[o.prop]={chng:function(){o.add(s)}},objDefine(i,s.n,{g:l,s:function(t){if(_!==t){l[o.ro]&&!o.upd&&throwInvalidAccess("["+a+"] is read-only:"+dumpObj(i)),u&&(c=c||_canMakeDynamic(l,o,_),u=!1);var e,n=c&&l[o.rf];if(c)if(n){objForEachKey(_,function(e){_[e]=t?t[e]:UNDEFINED_VALUE$2});try{objForEachKey(t,function(e,t){_setDynamicProperty(o,_,e,t)}),t=_}catch(r){_throwDynamicError((o.hdlr||{})[_DYN_LOGGER],a,"Assigning",r),c=!1}}else _&&_[CFG_HANDLER_LINK]&&objForEachKey(_,function(e){var e=_getOwnPropGetter(_,e);e&&(e=e[o.prop])&&e.chng()});t!==_&&(e=t&&_canMakeDynamic(l,o,t),!n&&e&&(t=_makeDynamicObject(o,t,a,"Converting")),_=t,c=e),o.add(s)}}})}function _setDynamicProperty(e,t,n,r){var o;return t&&((o=_getOwnPropGetter(t,n))&&o[e.prop]?t[n]=r:_createDynamicProperty(e,t,n,r)),t}function _setDynamicPropertyState(e,t,n,r){if(t){var o=_getOwnPropGetter(t,n),i=o&&!!o[e.prop],a=r&&r[0],_=r&&r[1],r=r&&r[2];if(!i){if(r)try{blockDynamicConversion(t)}catch(s){_throwDynamicError((e.hdlr||{})[_DYN_LOGGER],n,"Blocking",s)}try{_setDynamicProperty(e,t,n,t[n]),o=_getOwnPropGetter(t,n)}catch(s){_throwDynamicError((e.hdlr||{})[_DYN_LOGGER],n,"State",s)}}a&&(o[e.rf]=a),_&&(o[e.ro]=_),r&&(o[e.blkVal]=!0)}return t}function _makeDynamicObject(n,r,e,t){try{objForEachKey(r,function(e,t){_setDynamicProperty(n,r,e,t)}),r[CFG_HANDLER_LINK]||(objDefineProp(r,CFG_HANDLER_LINK,{get:function(){return n.hdlr}}),_patchArray(n,r,e))}catch(o){_throwDynamicError((n.hdlr||{})[_DYN_LOGGER],e,t,o)}return r}var symPrefix="[[ai_",symPostfix="]]";function _createState(i){var a,e=newSymbol(symPrefix+"get"+i.uid+symPostfix),t=newSymbol(symPrefix+"ro"+i.uid+symPostfix),n=newSymbol(symPrefix+"rf"+i.uid+symPostfix),r=newSymbol(symPrefix+"blkVal"+i.uid+symPostfix),_=newSymbol(symPrefix+"dtl"+i.uid+symPostfix),o=null,s=null;function u(t,e){var n=a.act;try{(a.act=t)&&t[_]&&(arrForEach(t[_],function(e){e.clr(t)}),t[_]=[]),e({cfg:i.cfg,set:i.set.bind(i),setDf:i.setDf.bind(i),ref:i.ref.bind(i),rdOnly:i.rdOnly.bind(i)})}catch(o){var r=i[_DYN_LOGGER];throw r&&r[_DYN_THROW_INTERNAL](1,107,dumpObj(o)),o}finally{a.act=n||null}}function c(){if(o){var e=o,n=(o=null,s&&s[_DYN_CANCEL](),s=null,[]);if(arrForEach(e,function(t){if(t&&(t[_]&&(arrForEach(t[_],function(e){e.clr(t)}),t[_]=null),t.fn))try{u(t,t.fn)}catch(e){n[_DYN_PUSH$1](e)}}),o)try{c()}catch(t){n[_DYN_PUSH$1](t)}0<n[_DYN_LENGTH$2]&&throwAggregationError("Watcher error(s): ",n)}}return a={prop:e,ro:t,rf:n,blkVal:r,hdlr:i,add:function(e){if(e&&0<e.h[_DYN_LENGTH$2]){o=o||[],s=s||scheduleTimeout(function(){s=null,c()},0);for(var t=0;t<e.h[_DYN_LENGTH$2];t++){var n=e.h[t];n&&-1===arrIndexOf(o,n)&&o[_DYN_PUSH$1](n)}}},notify:c,use:u,trk:function(e,t){e&&(e=e[_]=e[_]||[],-1===arrIndexOf(e,t)&&e[_DYN_PUSH$1](t))}}}function _createAndUseHandler(e,t){var n={fn:t,rm:function(){n.fn=null,t=e=null}};return objDefine(n,"toJSON",{v:function(){return"WatcherHandler"+(n.fn?"":"[X]")}}),e.use(n,t),n}function _createDynamicHandler(o,e,t){var n=getDynamicConfigHandler(e);if(n)return n;var i,n=createUniqueNamespace("dyncfg",!0),t=e&&!1!==t?e:_cfgDeepCopy(e),r={uid:null,cfg:t,logger:o,notify:function(){i.notify()},set:function(e,t,n){try{e=_setDynamicProperty(i,e,t,n)}catch(r){_throwDynamicError(o,t,"Setting value",r)}return e[t]},setDf:function(n,e){return e&&objForEachKey(e,function(e,t){_applyDefaultValue(r,n,e,t)}),n},watch:function(e){return _createAndUseHandler(i,e)},ref:function(e,t){return _setDynamicPropertyState(i,e,t,((e={})[0]=!0,e))[t]},rdOnly:function(e,t){return _setDynamicPropertyState(i,e,t,((e={})[1]=!0,e))[t]},blkVal:function(e,t){return _setDynamicPropertyState(i,e,t,((e={})[2]=!0,e))[t]},_block:function(n,r){i.use(null,function(e){var t=i.upd;try{isUndefined(r)||(i.upd=r),n(e)}finally{i.upd=t}})}};return objDefine(r,"uid",{c:!1,e:!1,w:!1,v:n}),_makeDynamicObject(i=_createState(r),t,"config","Creating"),r}function _logInvalidAccess(e,t){e?(e[_DYN_WARN_TO_CONSOLE](t),e[_DYN_THROW_INTERNAL](2,108,t)):throwInvalidAccess(t)}function createDynamicConfig(e,t,n,r){n=_createDynamicHandler(n,e||{},r);return t&&n.setDf(n.cfg,t),n}function onConfigChange(e,t,n){var r=e[CFG_HANDLER_LINK]||e;return!r.cfg||r.cfg!==e&&r.cfg[CFG_HANDLER_LINK]!==r?(_logInvalidAccess(n,STR_NOT_DYNAMIC_ERROR+dumpObj(e)),createDynamicConfig(e,null,n)[_DYN_WATCH](t)):r[_DYN_WATCH](t)}function runTargetUnload(e,t){if(e&&e[_DYN_UNLOAD])return e[_DYN_UNLOAD](t)}function doUnloadAll(e,t,n){var r;return n||(r=createPromise(function(e){n=e})),e&&0<getLength(e)?doAwaitResponse(runTargetUnload(e[0],t),function(){doUnloadAll(arrSlice(e,1),t,n)}):n(),r}var ChannelControllerPriority=500,DisabledPropertyName="Microsoft_ApplicationInsights_BypassAjaxInstrumentation";function _stringToBoolOrDefault(e,t,n){return!e&&isNullOrUndefined(e)?t:isBoolean(e)?e:"true"===asString(e)[_DYN_TO_LOWER_CASE$1]()}function cfgDfMerge(e){return{mrg:!0,v:e}}function cfgDfValidate(e,t,n){return{fb:n,isVal:e,v:t}}function cfgDfBoolean(e,t){return{fb:t,set:_stringToBoolOrDefault,v:!!e}}var _debugListener,_a$5,listenerFuncs=[STR_EVENTS_SENT,STR_EVENTS_DISCARDED,STR_EVENTS_SEND_REQUEST,STR_PERF_EVENT],_aiNamespace=null;function _listenerProxyFunc(n,r){return function(){var e=arguments,t=getDebugExt(r);t&&(t=t.listener)&&t[n]&&t[n][_DYN_APPLY](t,e)}}function _getExtensionNamespace(){var e=getInst("Microsoft");return _aiNamespace=e?e.ApplicationInsights:_aiNamespace}function getDebugExt(e){var t=_aiNamespace;return(t=t||!0===e.disableDbgExt?t:_aiNamespace||_getExtensionNamespace())?t.ChromeDbgExt:null}function getDebugListener(e){if(!_debugListener){_debugListener={};for(var t=0;t<listenerFuncs[_DYN_LENGTH$2];t++)_debugListener[listenerFuncs[t]]=_listenerProxyFunc(listenerFuncs[t],e)}return _debugListener}var STR_WARN_TO_CONSOLE="warnToConsole",AiNonUserActionablePrefix="AI (Internal): ",AiUserActionablePrefix="AI: ",AIInternalMessagePrefix="AITR_",defaultValues$2={loggingLevelConsole:0,loggingLevelTelemetry:1,maxMessageLimit:25,enableDebug:!1},_logFuncs=((_a$5={})[0]=null,_a$5[1]="errorToConsole",_a$5[2]=STR_WARN_TO_CONSOLE,_a$5[3]="debugToConsole",_a$5);function _sanitizeDiagnosticText(e){return e?'"'+e[_DYN_REPLACE](/\"/g,STR_EMPTY$1)+'"':STR_EMPTY$1}function _logToConsole(e,t){var n,r=getConsole();r&&(n="log",r[e]&&(n=e),isFunction(r[n])&&r[n](t))}var _InternalLogMessage=function(){function e(e,t,n,r){void 0===n&&(n=!1),this[_DYN_MESSAGE_ID]=e,this[_DYN_MESSAGE$1]=(n?AiUserActionablePrefix:AiNonUserActionablePrefix)+e;n=STR_EMPTY$1,hasJSON()&&(n=getJSON().stringify(r)),e=(t?" message:"+_sanitizeDiagnosticText(t):STR_EMPTY$1)+(r?" props:"+_sanitizeDiagnosticText(n):STR_EMPTY$1);this[_DYN_MESSAGE$1]+=e}return e.dataType="MessageData",e}();function safeGetLogger(e,t){return(e||{})[_DYN_LOGGER]||new DiagnosticLogger(t)}var _a$4,_b$2,DiagnosticLogger=function(){function e(r){this.identifier="DiagnosticLogger",this.queue=[];var s,o,u,c,t,l=0,N={};dynamicProto(e,this,function(i){function a(e,t){var n,r;u<=l||(r=!0,n=AIInternalMessagePrefix+t[_DYN_MESSAGE_ID],N[n]?r=!1:N[n]=!0,r&&(e<=o&&(i.queue[_DYN_PUSH$1](t),l++,_(1===e?"error":"warn",t)),l===u&&(r=new _InternalLogMessage(23,n="Internal events throttle limit per PageView reached for this app.",!1),i.queue[_DYN_PUSH$1](r),1===e?i.errorToConsole(n):i[_DYN_WARN_TO_CONSOLE](n))))}function _(e,t){var n=getDebugExt(r||{});n&&n[_DYN_DIAG_LOG$1]&&n[_DYN_DIAG_LOG$1](e,t)}t=onConfigChange(createDynamicConfig(r||{},defaultValues$2,i).cfg,function(e){e=e.cfg;s=e[_DYN_LOGGING_LEVEL_CONSOL4],o=e.loggingLevelTelemetry,u=e.maxMessageLimit,c=e.enableDebug}),i.consoleLoggingLevel=function(){return s},i[_DYN_THROW_INTERNAL]=function(e,t,n,r,o){t=new _InternalLogMessage(t,n,o=void 0!==o&&o,r);if(c)throw dumpObj(t);n=_logFuncs[e]||STR_WARN_TO_CONSOLE;isUndefined(t[_DYN_MESSAGE$1])?_("throw"+(1===e?"Critical":"Warning"),t):(o?(r=+t[_DYN_MESSAGE_ID],!N[r]&&e<=s&&(i[n](t[_DYN_MESSAGE$1]),N[r]=!0)):e<=s&&i[n](t[_DYN_MESSAGE$1]),a(e,t))},i.debugToConsole=function(e){_logToConsole("debug",e),_("warning",e)},i[_DYN_WARN_TO_CONSOLE]=function(e){_logToConsole("warn",e),_("warning",e)},i.errorToConsole=function(e){_logToConsole("error",e),_("error",e)},i.resetInternalMessageCount=function(){l=0,N={}},i.logInternalMessage=a,i[_DYN_UNLOAD]=function(e){t&&t.rm(),t=null}})}return e.__ieDyn=1,e}();function _getLogger(e){return e||new DiagnosticLogger}function _throwInternal(e,t,n,r,o,i){void 0===i&&(i=!1),_getLogger(e)[_DYN_THROW_INTERNAL](t,n,r,o,i)}function _warnToConsole(e,t){_getLogger(e)[_DYN_WARN_TO_CONSOLE](t)}var _doc,strToGMTString="toGMTString",strToUTCString="toUTCString",strCookie="cookie",strExpires="expires",strIsCookieUseDisabled="isCookieUseDisabled",strDisableCookiesUsage="disableCookiesUsage",strConfigCookieMgr="_ckMgr",_supportsCookies=null,_allowUaSameSite=null,_parsedCookieValue=null,_cookieCache={},_globalCookieConfig={},rootDefaultConfig=((_a$4={cookieCfg:cfgDfMerge(((_b$2={})[STR_DOMAIN]={fb:"cookieDomain",dfVal:isNotNullOrUndefined},_b$2.path={fb:"cookiePath",dfVal:isNotNullOrUndefined},_b$2.enabled=UNDEFINED_VALUE$2,_b$2.ignoreCookies=UNDEFINED_VALUE$2,_b$2.blockedCookies=UNDEFINED_VALUE$2,_b$2)),cookieDomain:UNDEFINED_VALUE$2,cookiePath:UNDEFINED_VALUE$2})[strDisableCookiesUsage]=UNDEFINED_VALUE$2,_a$4);function _getDoc(){_doc=_doc||getLazy(function(){return getDocument()})}function _isMgrEnabled(e){return!e||e.isEnabled()}function _isIgnoredCookie(e,t){return!!(t&&e&&isArray(e.ignoreCookies))&&-1!==arrIndexOf(e.ignoreCookies,t)}function _isBlockedCookie(e,t){return!!(t&&e&&isArray(e.blockedCookies)&&-1!==arrIndexOf(e.blockedCookies,t))||_isIgnoredCookie(e,t)}function _isCfgEnabled(e,t){var n,t=t[_DYN_ENABLED];return isNullOrUndefined(t)&&(n=void 0,isUndefined(e[strIsCookieUseDisabled])||(n=!e[strIsCookieUseDisabled]),t=n=isUndefined(e[strDisableCookiesUsage])?n:!e[strDisableCookiesUsage]),t}function createCookieMgr(n,o){var u,c,l,r,i,N,a,t=onConfigChange(n=createDynamicConfig(n||_globalCookieConfig,null,o).cfg,function(e){e.setDf(e.cfg,rootDefaultConfig),u=e.ref(e.cfg,"cookieCfg"),c=u[STR_PATH]||"/",l=u[STR_DOMAIN],r=!1!==_isCfgEnabled(n,u),i=u.getCookie||_getCookieValue,N=u.setCookie||_setCookieValue,a=u.delCookie||_setCookieValue},o),E={isEnabled:function(){var e=!1!==_isCfgEnabled(n,u)&&r&&areCookiesSupported(o),t=_globalCookieConfig[strConfigCookieMgr];return e&&t&&E!==t?_isMgrEnabled(t):e},setEnabled:function(e){r=!1!==e,u[_DYN_ENABLED]=e},set:function(e,t,n,r,o){var i,a,_,s=!1;return _isMgrEnabled(E)&&!_isBlockedCookie(u,e)&&(i={},a=strTrim(t||STR_EMPTY$1),-1!==(_=strIndexOf(a,";"))&&(a=strTrim(strLeft(t,_)),i=_extractParts(strSubstring(t,_+1))),setValue(i,STR_DOMAIN,r||l,isTruthy,isUndefined),isNullOrUndefined(n)||(t=isIE(),isUndefined(i[strExpires])&&0<(_=utcNow()+1e3*n)&&((r=new Date).setTime(_),setValue(i,strExpires,_formatDate(r,t?strToGMTString:strToUTCString)||_formatDate(r,t?strToGMTString:strToUTCString)||STR_EMPTY$1,isTruthy)),t||setValue(i,"max-age",STR_EMPTY$1+n,null,isUndefined)),(_=getLocation())&&"https:"===_.protocol&&(setValue(i,"secure",null,null,isUndefined),(_allowUaSameSite=null===_allowUaSameSite?!uaDisallowsSameSiteNone((getNavigator()||{})[_DYN_USER_AGENT]):_allowUaSameSite)&&setValue(i,"SameSite","None",null,isUndefined)),setValue(i,STR_PATH,o||c,null,isUndefined),N(e,_formatCookieValue(a,i)),s=!0),s},get:function(e){var t=STR_EMPTY$1;return _isMgrEnabled(E)&&!_isIgnoredCookie(u,e)?i(e):t},del:function(e,t){return!!_isMgrEnabled(E)&&E.purge(e,t)},purge:function(e,t){var n,r=!1;return areCookiesSupported(o)&&((n={})[STR_PATH]=t||"/",n[strExpires]="Thu, 01 Jan 1970 00:00:01 GMT",t=n,isIE()||(t["max-age"]="0"),a(e,_formatCookieValue(STR_EMPTY$1,t)),r=!0),r},unload:function(e){t&&t.rm(),t=null}};return E[strConfigCookieMgr]=E}function areCookiesSupported(e){if(null===_supportsCookies){_supportsCookies=!1,_doc||_getDoc();try{var t=_doc.v||{};_supportsCookies=t[strCookie]!==undefined}catch(n){_throwInternal(e,2,68,"Cannot access document.cookie - "+getExceptionName(n),{exception:dumpObj(n)})}}return _supportsCookies}function _extractParts(e){var n={};return e&&e[_DYN_LENGTH$2]&&arrForEach(strTrim(e)[_DYN_SPLIT$1](";"),function(e){var t;(e=strTrim(e||STR_EMPTY$1))&&(-1===(t=strIndexOf(e,"="))?n[e]=null:n[strTrim(strLeft(e,t))]=strTrim(strSubstring(e,t+1)))}),n}function _formatDate(e,t){return isFunction(e[t])?e[t]():null}function _formatCookieValue(e,t){var n=e||STR_EMPTY$1;return objForEachKey(t,function(e,t){n+="; "+e+(isNullOrUndefined(t)?STR_EMPTY$1:"="+t)}),n}function _getCookieValue(e){var t,n=STR_EMPTY$1;return _doc||_getDoc(),_doc.v&&(t=_doc.v[strCookie]||STR_EMPTY$1,_parsedCookieValue!==t&&(_cookieCache=_extractParts(t),_parsedCookieValue=t),n=strTrim(_cookieCache[e]||STR_EMPTY$1)),n}function _setCookieValue(e,t){_doc||_getDoc(),_doc.v&&(_doc.v[strCookie]=e+"="+t)}function uaDisallowsSameSiteNone(e){return!(!isString(e)||!strContains(e,"CPU iPhone OS 12")&&!strContains(e,"iPad; CPU OS 12")&&!(strContains(e,"Macintosh; Intel Mac OS X 10_14")&&strContains(e,"Version/")&&strContains(e,"Safari"))&&(!strContains(e,"Macintosh; Intel Mac OS X 10_14")||!strEndsWith(e,"AppleWebKit/605.1.15 (KHTML, like Gecko)"))&&!strContains(e,"Chrome/5")&&!strContains(e,"Chrome/6")&&(!strContains(e,"UnrealEngine")||strContains(e,"Chrome"))&&!strContains(e,"UCBrowser/12")&&!strContains(e,"UCBrowser/11"))}var defaultValues$1={perfEvtsSendAll:!1};function _runScheduledListeners(e){e.h=null;var t=e.cb;e.cb=[],arrForEach(t,function(e){safe(e.fn,[e.arg])})}function _runListeners(e,t,n,r){arrForEach(e,function(e){e&&e[t]&&(n?(n.cb[_DYN_PUSH$1]({fn:r,arg:e}),n.h=n.h||scheduleTimeout(_runScheduledListeners,0,n)):safe(r,[e]))})}var NotificationManager=function(){function t(e){this.listeners=[];var n,o=[],i={h:null,cb:[]},a=createDynamicConfig(e,defaultValues$1)[_DYN_WATCH](function(e){n=!!e.cfg.perfEvtsSendAll});dynamicProto(t,this,function(e){objDefine(e,"listeners",{g:function(){return o}}),e[_DYN_ADD_NOTIFICATION_LIS1]=function(e){o[_DYN_PUSH$1](e)},e[_DYN_REMOVE_NOTIFICATION_0]=function(e){for(var t=arrIndexOf(o,e);-1<t;)o[_DYN_SPLICE](t,1),t=arrIndexOf(o,e)},e[STR_EVENTS_SENT]=function(t){_runListeners(o,STR_EVENTS_SENT,i,function(e){e[STR_EVENTS_SENT](t)})},e[STR_EVENTS_DISCARDED]=function(t,n){_runListeners(o,STR_EVENTS_DISCARDED,i,function(e){e[STR_EVENTS_DISCARDED](t,n)})},e[STR_EVENTS_SEND_REQUEST]=function(t,n){_runListeners(o,STR_EVENTS_SEND_REQUEST,n?i:null,function(e){e[STR_EVENTS_SEND_REQUEST](t,n)})},e[STR_PERF_EVENT]=function(t){!t||!n&&t[_DYN_IS_CHILD_EVT]()||_runListeners(o,STR_PERF_EVENT,null,function(e){t.isAsync?scheduleTimeout(function(){return e[STR_PERF_EVENT](t)},0):e[STR_PERF_EVENT](t)})},e[STR_OFFLINE_STORE]=function(t){t&&t[_DYN_LENGTH$2]&&_runListeners(o,STR_OFFLINE_STORE,i,function(e){e[STR_OFFLINE_STORE](t)})},e[STR_OFFLINE_SENT]=function(t){t&&t[_DYN_DATA$1]&&_runListeners(o,STR_OFFLINE_SENT,i,function(e){e[STR_OFFLINE_SENT](t)})},e[STR_OFFLINE_DROP]=function(t,e){var n;0<t&&(n=e||0,_runListeners(o,STR_OFFLINE_DROP,i,function(e){e[STR_OFFLINE_DROP](t,n)}))},e[_DYN_UNLOAD]=function(t){var n,r=function(){a&&a.rm(),a=null,o=[],i.h&&i.h[_DYN_CANCEL](),i.h=null,i.cb=[]};if(_runListeners(o,"unload",null,function(e){e=e[_DYN_UNLOAD](t);e&&(n=n||[])[_DYN_PUSH$1](e)}),n)return createPromise(function(e){return doAwaitResponse(createAllPromise(n),function(){r(),e()})});r()}})}return t.__ieDyn=1,t}(),strExecutionContextKey="ctx",strParentContextKey="ParentContextKey",strChildrenContextKey="ChildrenContextKey",_defaultPerfManager=null,PerfEvent=function(){function i(e,t,n){var r,o=this;o.start=utcNow(),o[_DYN_NAME$2]=e,o.isAsync=n,o[_DYN_IS_CHILD_EVT]=function(){return!1},isFunction(t)&&objDefine(o,"payload",{g:function(){return!r&&isFunction(t)&&(r=t(),t=null),r}}),o[_DYN_GET_CTX]=function(e){return e?(e===i[strParentContextKey]||e===i[strChildrenContextKey]?o:o[strExecutionContextKey]||{})[e]:null},o[_DYN_SET_CTX]=function(e,t){e&&(e===i[strParentContextKey]?(o[e]||(o[_DYN_IS_CHILD_EVT]=function(){return!0}),o[e]=t):e===i[strChildrenContextKey]?o[e]=t:(o[strExecutionContextKey]=o[strExecutionContextKey]||{})[e]=t)},o.complete=function(){var e=0,t=o[_DYN_GET_CTX](i[strChildrenContextKey]);if(isArray(t))for(var n=0;n<t[_DYN_LENGTH$2];n++){var r=t[n];r&&(e+=r.time)}o.time=utcNow()-o.start,o.exTime=o.time-e,o.complete=function(){}}}return i.ParentContextKey="parent",i.ChildrenContextKey="childEvts",i}(),PerfManager=function(){function e(t){this.ctx={},dynamicProto(e,this,function(n){n.create=function(e,t,n){return new PerfEvent(e,t,n)},n.fire=function(e){e&&(e.complete(),t&&isFunction(t[STR_PERF_EVENT])&&t[STR_PERF_EVENT](e))},n[_DYN_SET_CTX]=function(e,t){e&&((n[strExecutionContextKey]=n[strExecutionContextKey]||{})[e]=t)},n[_DYN_GET_CTX]=function(e){return(n[strExecutionContextKey]||{})[e]}})}return e.__ieDyn=1,e}(),doPerfActiveKey="CoreUtils.doPerf";function doPerf(e,t,n,r,o){if(e)if(e=e[STR_GET_PERF_MGR]?e[STR_GET_PERF_MGR]():e){var i,a=void 0,_=e[_DYN_GET_CTX](doPerfActiveKey);try{if(a=e.create(t(),r,o))return _&&a[_DYN_SET_CTX]&&(a[_DYN_SET_CTX](PerfEvent[strParentContextKey],_),_[_DYN_GET_CTX]&&_[_DYN_SET_CTX]&&((i=_[_DYN_GET_CTX](PerfEvent[strChildrenContextKey]))||(i=[],_[_DYN_SET_CTX](PerfEvent[strChildrenContextKey],i)),i[_DYN_PUSH$1](a))),e[_DYN_SET_CTX](doPerfActiveKey,a),n(a)}catch(s){a&&a[_DYN_SET_CTX]&&a[_DYN_SET_CTX]("exception",s)}finally{a&&e.fire(a),e[_DYN_SET_CTX](doPerfActiveKey,_)}}return n()}function getGblPerfMgr(){return _defaultPerfManager}var INVALID_TRACE_ID="00000000000000000000000000000000",INVALID_SPAN_ID="0000000000000000";function _isValid(e,t,n){return!(!e||e[_DYN_LENGTH$2]!==t||e===n||!e.match(/^[\da-f]*$/i))}function isValidTraceId(e){return _isValid(e,32,INVALID_TRACE_ID)}function isValidSpanId(e){return _isValid(e,16,INVALID_SPAN_ID)}var pluginStateData=createElmNodeData("plugin");function _getPluginState(e){return pluginStateData.get(e,"state",{},!0)}function initializePlugins(n,r){for(var e=[],t=null,o=n[_DYN_GET_NEXT]();o;){var i,a,_=o[_DYN_GET_PLUGIN]();_&&(t&&t[_DYN_SET_NEXT_PLUGIN]&&_[STR_PROCESS_TELEMETRY]&&t[_DYN_SET_NEXT_PLUGIN](_),a=!!(i=_getPluginState(_))[_DYN_IS_INITIALIZED],(a=_[_DYN_IS_INITIALIZED]?_[_DYN_IS_INITIALIZED]():a)||e[_DYN_PUSH$1](_),t=_,o=o[_DYN_GET_NEXT]())}arrForEach(e,function(e){var t=n[STR_CORE]();e[_DYN_INITIALIZE$1](n.getCfg(),t,r,n[_DYN_GET_NEXT]()),i=_getPluginState(e),e[STR_CORE]||i[STR_CORE]||(i[STR_CORE]=t),i[_DYN_IS_INITIALIZED]=!0,delete i[_DYN_TEARDOWN]})}function sortPlugins(e){return e.sort(function(e,t){var n,r=0;return t?(n=t[STR_PROCESS_TELEMETRY],e[STR_PROCESS_TELEMETRY]?r=n?e[STR_PRIORITY]-t[STR_PRIORITY]:1:n&&(r=-1)):r=e?1:-1,r})}function createDistributedTraceContext(t){var n={};return{getName:function(){return n[_DYN_NAME$2]},setName:function(e){t&&t.setName(e),n[_DYN_NAME$2]=e},getTraceId:function(){return n.traceId},setTraceId:function(e){t&&t.setTraceId(e),isValidTraceId(e)&&(n.traceId=e)},getSpanId:function(){return n.spanId},setSpanId:function(e){t&&t.setSpanId(e),isValidSpanId(e)&&(n.spanId=e)},getTraceFlags:function(){return n[_DYN_TRACE_FLAGS]},setTraceFlags:function(e){t&&t.setTraceFlags(e),n[_DYN_TRACE_FLAGS]=e}}}var _a$3,strTelemetryPluginChain="TelemetryPluginChain",strHasRunFlags="_hasRun",strGetTelCtx="_getTelCtx",_chainId=0;function _getNextProxyStart(e,t,n){for(;e;){if(e[_DYN_GET_PLUGIN]()===n)return e;e=e[_DYN_GET_NEXT]()}return createTelemetryProxyChain([n],t.config||{},t)}function _createInternalContext(e,i,n,t){var r=null,o=[],a=(i=i||createDynamicConfig({},null,n[_DYN_LOGGER]),null!==t&&(r=t?_getNextProxyStart(e,n,t):e),{_next:function(){var e,t=r;return r=t?t[_DYN_GET_NEXT]():null,t||(e=o)&&0<e[_DYN_LENGTH$2]&&(arrForEach(e,function(e){try{e.func.call(e.self,e.args)}catch(t){_throwInternal(n[_DYN_LOGGER],2,73,"Unexpected Exception during onComplete - "+dumpObj(t))}}),o=[]),t},ctx:{core:function(){return n},diagLog:function(){return safeGetLogger(n,i.cfg)},getCfg:function(){return i.cfg},getExtCfg:function(e,t){var r=_(e,!0);return t&&objForEachKey(t,function(e,t){var n;!isNullOrUndefined(r[e])||!(n=i.cfg[e])&&isNullOrUndefined(n)||(r[e]=n),_applyDefaultValue(i,r,e,t)}),i.setDf(r,t)},getConfig:function(e,t,n){void 0===n&&(n=!1);var r,e=_(e,!1),o=i.cfg;return!e||!e[t]&&isNullOrUndefined(e[t])?!o[t]&&isNullOrUndefined(o[t])||(r=o[t]):r=e[t],r||!isNullOrUndefined(r)?r:n},hasNext:function(){return!!r},getNext:function(){return r},setNext:function(e){r=e},iterate:function(e){for(;t=a._next();){var t=t[_DYN_GET_PLUGIN]();t&&e(t)}},onComplete:function(e,t){for(var n=[],r=2;r<arguments.length;r++)n[r-2]=arguments[r];e&&o[_DYN_PUSH$1]({func:e,self:isUndefined(t)?a.ctx:t,args:n})}}});function _(e,t){var n,r=null,o=i.cfg;return o&&e&&(n=o[STR_EXTENSION_CONFIG],o[STR_EXTENSION_CONFIG]=n=!n&&t?{}:n,(n=i.ref(o,STR_EXTENSION_CONFIG))&&(r=n[e],n[e]=r=!r&&t?{}:r,r=i.ref(n,e))),r}return a}function createProcessTelemetryContext(e,t,n,r){var o=createDynamicConfig(t),i=_createInternalContext(e,o,n,r),a=i.ctx;return a[_DYN_PROCESS_NEXT]=function(e){var t=i._next();return t&&t[STR_PROCESS_TELEMETRY](e,a),!t},a[_DYN_CREATE_NEW]=function(e,t){return createProcessTelemetryContext((e=isArray(e=void 0===e?null:e)?createTelemetryProxyChain(e,o.cfg,n,t):e)||a[_DYN_GET_NEXT](),o.cfg,n,t)},a}function createProcessTelemetryUnloadContext(e,n,t){var r=createDynamicConfig(n.config),o=_createInternalContext(e,r,n,t),i=o.ctx;return i[_DYN_PROCESS_NEXT]=function(e){var t=o._next();return t&&t[_DYN_UNLOAD](i,e),!t},i[_DYN_CREATE_NEW]=function(e,t){return createProcessTelemetryUnloadContext((e=isArray(e=void 0===e?null:e)?createTelemetryProxyChain(e,r.cfg,n,t):e)||i[_DYN_GET_NEXT](),n,t)},i}function createProcessTelemetryUpdateContext(e,n,t){var r=createDynamicConfig(n.config),o=_createInternalContext(e,r,n,t).ctx;return o[_DYN_PROCESS_NEXT]=function(t){return o.iterate(function(e){isFunction(e[_DYN_UPDATE])&&e[_DYN_UPDATE](o,t)})},o[_DYN_CREATE_NEW]=function(e,t){return createProcessTelemetryUpdateContext((e=isArray(e=void 0===e?null:e)?createTelemetryProxyChain(e,r.cfg,n,t):e)||o[_DYN_GET_NEXT](),n,t)},o}function createTelemetryProxyChain(e,t,n,r){var o,i=null,a=!r;return isArray(e)&&0<e[_DYN_LENGTH$2]&&(o=null,arrForEach(e,function(e){(a=!a&&r===e||a)&&e&&isFunction(e[STR_PROCESS_TELEMETRY])&&(e=createTelemetryPluginProxy(e,t,n),i=i||e,o&&o._setNext(e),o=e)})),r&&!i?createTelemetryProxyChain([r],t,n):i}function createTelemetryPluginProxy(s,r,o){var u=null,i=isFunction(s[STR_PROCESS_TELEMETRY]),a=isFunction(s[_DYN_SET_NEXT_PLUGIN]),c=s?s[_DYN_IDENTIFIER]+"-"+s[STR_PRIORITY]+"-"+_chainId++:"Unknown-0-"+_chainId++,_={getPlugin:function(){return s},getNext:function(){return u},processTelemetry:function(n,e){var t;l(e=e||(t=(t=s&&isFunction(s[strGetTelCtx])?s[strGetTelCtx]():t)||createProcessTelemetryContext(_,r,o)),function(e){if(!s||!i)return!1;var t=_getPluginState(s);return!t[_DYN_TEARDOWN]&&!t[STR_DISABLED]&&(a&&s[_DYN_SET_NEXT_PLUGIN](u),s[STR_PROCESS_TELEMETRY](n,e),!0)},"processTelemetry",function(){return{item:n}},!n.sync)||e[_DYN_PROCESS_NEXT](n)},unload:function(r,o){l(r,function(){var e,t,n=!1;return s&&(e=_getPluginState(s),t=s[STR_CORE]||e[STR_CORE],!s||t&&t!==r.core()||e[_DYN_TEARDOWN]||(e[STR_CORE]=null,e[_DYN_TEARDOWN]=!0,e[_DYN_IS_INITIALIZED]=!1,s[_DYN_TEARDOWN]&&!0===s[_DYN_TEARDOWN](r,o)&&(n=!0))),n},"unload",function(){},o.isAsync)||r[_DYN_PROCESS_NEXT](o)},update:function(r,o){l(r,function(){var e,t,n=!1;return s&&(e=_getPluginState(s),t=s[STR_CORE]||e[STR_CORE],!s||t&&t!==r.core()||e[_DYN_TEARDOWN]||s[_DYN_UPDATE]&&!0===s[_DYN_UPDATE](r,o)&&(n=!0)),n},"update",function(){},!1)||r[_DYN_PROCESS_NEXT](o)},_id:c,_setNext:function(e){u=e}};function l(n,r,o,e,t){var i=!1,a=s?s[_DYN_IDENTIFIER]:strTelemetryPluginChain,_=(_=n[strHasRunFlags])||(n[strHasRunFlags]={});return n.setNext(u),s&&doPerf(n[STR_CORE](),function(){return a+":"+o},function(){_[c]=!0;try{var e=u?u._id:STR_EMPTY$1;e&&(_[e]=!1),i=r(n)}catch(t){e=!u||_[u._id];e&&(i=!0),u&&e||_throwInternal(n[_DYN_DIAG_LOG$1](),1,73,"Plugin ["+a+"] failed during "+o+" - "+dumpObj(t)+", run flags: "+dumpObj(_))}},e,t),i}return objFreeze(_)}function createUnloadHandlerContainer(){var t=[];return{add:function(e){e&&t[_DYN_PUSH$1](e)},run:function(n,r){arrForEach(t,function(e){try{e(n,r)}catch(t){_throwInternal(n[_DYN_DIAG_LOG$1](),2,73,"Unexpected error calling unload handler - "+dumpObj(t))}}),t=[]}}}function createUnloadHookContainer(){var t=[];return{run:function(n){var e=t;t=[],arrForEach(e,function(e){try{(e.rm||e.remove).call(e)}catch(t){_throwInternal(n,2,73,"Unloading:"+dumpObj(t))}})},add:function(e){e&&arrAppend(t,e)}}}var strGetPlugin="getPlugin",defaultValues=((_a$3={})[STR_EXTENSION_CONFIG]={isVal:isNotNullOrUndefined,v:{}},_a$3),BaseTelemetryPlugin=function(){function e(){var o,i,u,c,l,a=this;function t(e){var t,e=e=void 0===e?null:e;return e||(t=i||createProcessTelemetryContext(null,{},a[STR_CORE]),e=u&&u[strGetPlugin]?t[_DYN_CREATE_NEW](null,u[strGetPlugin]):t[_DYN_CREATE_NEW](null,u)),e}function _(e,t,n){createDynamicConfig(e,defaultValues,safeGetLogger(t)),!n&&t&&(n=t[_DYN_GET_PROCESS_TEL_CONT2]()[_DYN_GET_NEXT]());var r=u;u&&u[strGetPlugin]&&(r=u[strGetPlugin]()),a[STR_CORE]=t,i=createProcessTelemetryContext(n,e,t,r)}function N(){o=!1,a[STR_CORE]=null,u=i=null,l=createUnloadHookContainer(),c=createUnloadHandlerContainer()}N(),dynamicProto(e,a,function(s){s[_DYN_INITIALIZE$1]=function(e,t,n,r){_(e,t,r),o=!0},s[_DYN_TEARDOWN]=function(e,t){var n,r,o,i,a=s[STR_CORE];if(a&&(!e||a===e[STR_CORE]()))return r=!1,o=e||createProcessTelemetryUnloadContext(null,a,u&&u[strGetPlugin]?u[strGetPlugin]():u),i=t||{reason:0,isAsync:!1},s[_DYN__DO_TEARDOWN]&&!0===s[_DYN__DO_TEARDOWN](o,i,_)?n=!0:_(),n;function _(){r||(r=!0,c.run(o,t),l.run(o[_DYN_DIAG_LOG$1]()),!0===n&&o[_DYN_PROCESS_NEXT](i),N())}},s[_DYN_UPDATE]=function(e,t){var n,r,o,i=s[STR_CORE];if(i&&(!e||i===e[STR_CORE]()))return r=!1,o=e||createProcessTelemetryUpdateContext(null,i,u&&u[strGetPlugin]?u[strGetPlugin]():u),s._doUpdate&&!0===s._doUpdate(o,t||{reason:0},a)?n=!0:a(),n;function a(){r||(r=!0,_(o.getCfg(),o.core(),o[_DYN_GET_NEXT]()))}},proxyFunctionAs(s,"_addUnloadCb",function(){return c},"add"),proxyFunctionAs(s,"_addHook",function(){return l},"add"),objDefine(s,"_unloadHooks",{g:function(){return l}})}),a[_DYN_DIAG_LOG$1]=function(e){return t(e)[_DYN_DIAG_LOG$1]()},a[_DYN_IS_INITIALIZED]=function(){return o},a.setInitialized=function(e){o=e},a[_DYN_SET_NEXT_PLUGIN]=function(e){u=e},a[_DYN_PROCESS_NEXT]=function(e,t){t?t[_DYN_PROCESS_NEXT](e):u&&isFunction(u[STR_PROCESS_TELEMETRY])&&u[STR_PROCESS_TELEMETRY](e,null)},a._getTelCtx=t}return e.__ieDyn=1,e}();function _addInitializer(n,e,t){var r={id:e,fn:t};return arrAppend(n,r),{remove:function(){arrForEach(n,function(e,t){if(e.id===r.id)return n[_DYN_SPLICE](t,1),-1})}}}function _runInitializers(e,t,n){for(var r=!1,o=e[_DYN_LENGTH$2],i=0;i<o;++i){var a=e[i];if(a)try{if(!1===a.fn[_DYN_APPLY](null,[t])){r=!0;break}}catch(_){_throwInternal(n,2,64,"Telemetry initializer failed: "+getExceptionName(_),{exception:dumpObj(_)},!0)}}return!r}var _a$2,TelemetryInitializerPlugin=function(n){function i(){var t,r,e=n.call(this)||this;function o(){t=0,r=[]}return e.identifier="TelemetryInitializerPlugin",e.priority=199,o(),dynamicProto(i,e,function(n,e){n.addTelemetryInitializer=function(e){return _addInitializer(r,t++,e)},n[STR_PROCESS_TELEMETRY]=function(e,t){_runInitializers(r,e,(t||n)[_DYN_DIAG_LOG$1]())&&n[_DYN_PROCESS_NEXT](e,t)},n[_DYN__DO_TEARDOWN]=function(){o()}}),e}return __extendsFn(i,n),i.__ieDyn=1,i}(BaseTelemetryPlugin),strValidationError="Plugins must provide initialize method",strNotificationManager="_notificationManager",strSdkUnloadingError="SDK is still unloading...",strSdkNotInitialized="SDK is not initialized",maxInitQueueSize=100,maxInitTimeout=5e4,defaultConfig=objDeepFreeze(((_a$2={cookieCfg:{}})[STR_EXTENSIONS]={rdOnly:!0,ref:!0,v:[]},_a$2[STR_CHANNELS]={rdOnly:!0,ref:!0,v:[]},_a$2[STR_EXTENSION_CONFIG]={ref:!0,v:{}},_a$2[STR_CREATE_PERF_MGR]=UNDEFINED_VALUE$2,_a$2.loggingLevelConsole=0,_a$2.diagnosticLogInterval=UNDEFINED_VALUE$2,_a$2));function _createPerfManager(e,t){return new PerfManager(t)}function _validateExtensions(r,o,e){var i=[],a=[],_={};return arrForEach(e,function(e){(isNullOrUndefined(e)||isNullOrUndefined(e[_DYN_INITIALIZE$1]))&&throwError(strValidationError);var t=e[STR_PRIORITY],n=e[_DYN_IDENTIFIER];e&&t&&(isNullOrUndefined(_[t])?_[t]=n:_warnToConsole(r,"Two extensions have same priority #"+t+" - "+_[t]+", "+n)),(!t||t<o?i:a)[_DYN_PUSH$1](e)}),{core:i,channels:a}}function _isPluginPresent(t,e){var n=!1;return arrForEach(e,function(e){if(e===t)return n=!0,-1}),n}function _deepMergeConfig(n,r,e,o){e&&objForEachKey(e,function(e,t){o&&isPlainObject(t)&&isPlainObject(r[e])&&_deepMergeConfig(n,r[e],t,o),o&&isPlainObject(t)&&isPlainObject(r[e])?_deepMergeConfig(n,r[e],t,o):n.set(r,e,t)})}function _findWatcher(e,n){var r=null,o=-1;return arrForEach(e,function(e,t){if(e.w===n)return r=e,o=t,-1}),{i:o,l:r}}function _addDelayedCfgListener(t,n){var e=_findWatcher(t,n).l;return e||t[_DYN_PUSH$1](e={w:n,rm:function(){var e=_findWatcher(t,n);-1!==e.i&&t[_DYN_SPLICE](e.i,1)}}),e}function _registerDelayedCfgListener(n,e,r){arrForEach(e,function(e){var t=onConfigChange(n,e.w,r);delete e.w,e.rm=function(){t.rm()}})}function _initDebugListener(e,t,n,r){return t.add(e[_DYN_WATCH](function(e){var t=e.cfg.disableDbgExt;!0===t&&r&&(n[_DYN_REMOVE_NOTIFICATION_0](r),r=null),n&&!r&&!0!==t&&(r=getDebugListener(e.cfg),n[_DYN_ADD_NOTIFICATION_LIS1](r))})),r}function _createUnloadHook(e){return objDefine({rm:function(){e.rm()}},"toJSON",{v:function(){return"aicore::onCfgChange<"+JSON.stringify(e)+">"}})}var AppInsightsCore=function(){function e(){var p,g,I,r,Y,m,y,A,O,C,R,P,v,h,L,b,U,F,M,G,w,x,H,$,j,V,k,B,K,z,X,W,q;dynamicProto(e,this,function(a){function _(){K=!0,isNullOrUndefined(w)?(V=ActiveStatus.INACTIVE,_throwInternal(I,1,112,"ikey can't be resolved from promises")):V=ActiveStatus.ACTIVE,s()}function s(){g&&(a.releaseQueue(),a.pollInternalLogs())}function u(e){return X&&X[_DYN_ENABLED]||q||(e||I&&0<I.queue[_DYN_LENGTH$2])&&(W||(W=!0,i(p[_DYN_WATCH](function(e){var e=e.cfg.diagnosticLogInterval,t=(e&&0<e||(e=1e4),!1);X&&(t=X[_DYN_ENABLED],X[_DYN_CANCEL]()),(X=createTimeout(d,e)).unref(),X[_DYN_ENABLED]=t}))),X[_DYN_ENABLED]=!0),X}function t(){var n={},t=($=[],function(e){e&&arrForEach(e,function(e){var t;e[_DYN_IDENTIFIER]&&e[_DYN_VERSION]&&!n[e.identifier]&&(t=e[_DYN_IDENTIFIER]+"="+e[_DYN_VERSION],$[_DYN_PUSH$1](t),n[e.identifier]=e)})});t(P),R&&arrForEach(R,function(e){t(e)}),t(C)}function c(){g=!1,(p=createDynamicConfig({},defaultConfig,a[_DYN_LOGGER])).cfg[_DYN_LOGGING_LEVEL_CONSOL4]=1,objDefine(a,"config",{g:function(){return p.cfg},s:function(e){a.updateCfg(e,!1)}}),objDefine(a,"pluginVersionStringArr",{g:function(){return $||t(),$}}),objDefine(a,"pluginVersionString",{g:function(){return j||($||t(),j=$.join(";")),j||STR_EMPTY$1}}),objDefine(a,"logger",{g:function(){return I||(I=new DiagnosticLogger(p.cfg),p[_DYN_LOGGER]=I),I},s:function(e){p[_DYN_LOGGER]=e,I!==e&&(runTargetUnload(I,!1),I=e)}}),a[_DYN_LOGGER]=new DiagnosticLogger(p.cfg),H=[];var e=a.config[STR_EXTENSIONS]||[];e.splice(0,e[_DYN_LENGTH$2]),arrAppend(e,H),h=new TelemetryInitializerPlugin,runTargetUnload(Y,!(r=[])),y=m=Y=null,runTargetUnload(A,!1),v=!(C=[]),b=createUniqueNamespace("AIBaseCore",!(L=P=R=O=A=null)),U=createUnloadHandlerContainer(),w=G=null,F=createUnloadHookContainer(),V=0,K=W=q=!(x=[]),z=B=k=X=$=j=null}function l(){var e=createProcessTelemetryContext(f(),p.cfg,a);return e[_DYN_ON_COMPLETE](u),e}function N(e){var t=_validateExtensions(a[_DYN_LOGGER],ChannelControllerPriority,C),t=($=j=O=null,P=sortPlugins(arrAppend(P=(R||[])[0]||[],t[STR_CHANNELS])),arrAppend(sortPlugins(t[STR_CORE]),P)),n=(H=objFreeze(t),a.config[STR_EXTENSIONS]||[]),n=(n.splice(0,n[_DYN_LENGTH$2]),arrAppend(n,H),l());P&&0<P[_DYN_LENGTH$2]&&initializePlugins(n[_DYN_CREATE_NEW](P),t),initializePlugins(n,t),e&&o(e)}function E(t){var r=null,n=[];return arrForEach(H,function(e){if(e[_DYN_IDENTIFIER]===t&&e!==h)return r=e,-1;e.getChannel&&n[_DYN_PUSH$1](e)}),!r&&0<n[_DYN_LENGTH$2]&&arrForEach(n,function(e){if(!(r=e.getChannel(t)))return-1}),r?{plugin:r,setEnabled:function(e){_getPluginState(r)[STR_DISABLED]=!e},isEnabled:function(){var e=_getPluginState(r);return!e[_DYN_TEARDOWN]&&!e[STR_DISABLED]},remove:function(e,t){var n=[r];D(n,{reason:1,isAsync:e=void 0===e||e},function(e){e&&N({reason:32,removed:n}),t&&t(e)})}}:null}function f(){var e;return O||(e=(H||[]).slice(),-1===arrIndexOf(e,h)&&e[_DYN_PUSH$1](h),O=createTelemetryProxyChain(sortPlugins(e),p.cfg,a)),O}function D(i,e,t){var n;i&&0<i[_DYN_LENGTH$2]?((n=createProcessTelemetryUnloadContext(createTelemetryProxyChain(i,p.cfg,a),a))[_DYN_ON_COMPLETE](function(){var r=!1,n=[],o=(arrForEach(C,function(e,t){_isPluginPresent(e,i)?r=!0:n[_DYN_PUSH$1](e)}),C=n,$=j=null,[]);R&&(arrForEach(R,function(e,t){var n=[];arrForEach(e,function(e){_isPluginPresent(e,i)?r=!0:n[_DYN_PUSH$1](e)}),o[_DYN_PUSH$1](n)}),R=o),t&&t(r),u()}),n[_DYN_PROCESS_NEXT](e)):t(!1)}function d(){var e;I&&I.queue&&(e=I.queue.slice(0),I.queue[_DYN_LENGTH$2]=0,arrForEach(e,function(e){e={name:L||"InternalMessageId: "+e[_DYN_MESSAGE_ID],iKey:w,time:toISOString(new Date),baseType:_InternalLogMessage.dataType,baseData:{message:e[_DYN_MESSAGE$1]}};a.track(e)}))}function T(n,e,r,o){var i=1,t=!1,a=null;function _(){i--,t&&0===i&&(a&&a[_DYN_CANCEL](),a=null,e&&e(t),e=null)}return o=o||5e3,P&&0<P[_DYN_LENGTH$2]&&l()[_DYN_CREATE_NEW](P).iterate(function(e){var t;e.flush&&(i++,t=!1,e.flush(n,function(){t=!0,_()},r)||t||(n&&null==a?a=scheduleTimeout(function(){a=null,_()},o):_()))}),t=!0,_(),!0}function o(e){var t=createProcessTelemetryUpdateContext(f(),a);t[_DYN_ON_COMPLETE](u),a._updateHook&&!0===a._updateHook(t,e)||t[_DYN_PROCESS_NEXT](e)}function S(e){var t=a[_DYN_LOGGER];t?(_throwInternal(t,2,73,e),u()):throwError(e)}function n(e){var t=a[_DYN_GET_NOTIFY_MGR]();t&&t[STR_EVENTS_DISCARDED]([e],2)}function i(e){F.add(e)}c(),a._getDbgPlgTargets=function(){return[H,r]},a[_DYN_IS_INITIALIZED]=function(){return g},a.activeStatus=function(){return V},a._setPendingStatus=function(){V=3},a[_DYN_INITIALIZE$1]=function(e,t,n,r){v&&throwError(strSdkUnloadingError),a[_DYN_IS_INITIALIZED]()&&throwError("Core cannot be initialized more than once"),e=(p=createDynamicConfig(e,defaultConfig,n||a[_DYN_LOGGER],!1)).cfg,i(p[_DYN_WATCH](function(t){var e=t.cfg,n=(B=e.initInMemoMaxSize||maxInitQueueSize,function(e){var i,t=e.instrumentationKey,n=e.endpointUrl;if(3!==V){if(isNullOrUndefined(t))return w=null,V=ActiveStatus.INACTIVE,r="Please provide instrumentation key",g?(_throwInternal(I,1,100,r),s()):throwError(r);var r=[];w=isPromiseLike(t)?(r[_DYN_PUSH$1](t),null):t,k=isPromiseLike(n)?(r[_DYN_PUSH$1](n),null):n,r[_DYN_LENGTH$2]?(t=r,K=!1,V=3,n=isNotNullOrUndefined((i=e).initTimeOut)?i.initTimeOut:maxInitTimeout,r=createSyncAllSettledPromise(t),z&&z[_DYN_CANCEL](),z=scheduleTimeout(function(){z=null,K||_()},n),doAwaitResponse(r,function(e){try{if(K)return;var t,n,r;e.rejected||((t=e[_DYN_VALUE])&&t[_DYN_LENGTH$2]&&(n=t[0],w=n&&n[_DYN_VALUE],1<t[_DYN_LENGTH$2]&&(r=t[1],k=r&&r[_DYN_VALUE])),w&&(i.instrumentationKey=w,i.endpointUrl=k)),_()}catch(o){K||_()}})):_()}}(e),t.ref(t.cfg,STR_EXTENSION_CONFIG));objForEachKey(n,function(e){t.ref(n,e)})})),M=_initDebugListener(p,F,(Y=r)&&a[_DYN_GET_NOTIFY_MGR](),M),i(p[_DYN_WATCH](function(e){var t;e.cfg.enablePerfMgr?(t=e.cfg[STR_CREATE_PERF_MGR],o===t&&o||(getSetValue(e.cfg,STR_CREATE_PERF_MGR,t=t||_createPerfManager),o=t,y=null),m||y||!isFunction(t)||(y=t(a,a[_DYN_GET_NOTIFY_MGR]()))):o=y=null})),a[_DYN_LOGGER]=n;var o,r=e[STR_EXTENSIONS];(C=[])[_DYN_PUSH$1].apply(C,__spreadArrayFn(__spreadArrayFn([],t,!1),r)),R=e[STR_CHANNELS],N(null),P&&0!==P[_DYN_LENGTH$2]||throwError("No "+STR_CHANNELS+" available"),R&&1<R[_DYN_LENGTH$2]&&((n=a[_DYN_GET_PLUGIN]("TeeChannelController"))&&n.plugin||_throwInternal(I,1,28,"TeeChannel required")),_registerDelayedCfgListener(e,x,I),g=!(x=null),V===ActiveStatus.ACTIVE&&s()},a.getChannels=function(){var t=[];return P&&arrForEach(P,function(e){t[_DYN_PUSH$1](e)}),objFreeze(t)},a.track=function(e){doPerf(a[STR_GET_PERF_MGR](),function(){return"AppInsightsCore:track"},function(){null===e&&(n(e),throwError("Invalid telemetry item")),!e[_DYN_NAME$2]&&isNullOrUndefined(e[_DYN_NAME$2])&&(n(e),throwError("telemetry name required")),e.iKey=e.iKey||w,e.time=e.time||toISOString(new Date),e.ver=e.ver||"4.0",!v&&a[_DYN_IS_INITIALIZED]()&&V===ActiveStatus.ACTIVE?l()[_DYN_PROCESS_NEXT](e):V!==ActiveStatus.INACTIVE&&r[_DYN_LENGTH$2]<=B&&r[_DYN_PUSH$1](e)},function(){return{item:e}},!e.sync)},a[_DYN_GET_PROCESS_TEL_CONT2]=l,a[_DYN_GET_NOTIFY_MGR]=function(){return Y||(Y=new NotificationManager(p.cfg),a[strNotificationManager]=Y),Y},a[_DYN_ADD_NOTIFICATION_LIS1]=function(e){a.getNotifyMgr()[_DYN_ADD_NOTIFICATION_LIS1](e)},a[_DYN_REMOVE_NOTIFICATION_0]=function(e){Y&&Y[_DYN_REMOVE_NOTIFICATION_0](e)},a.getCookieMgr=function(){return A=A||createCookieMgr(p.cfg,a[_DYN_LOGGER])},a.setCookieMgr=function(e){A!==e&&(runTargetUnload(A,!1),A=e)},a[STR_GET_PERF_MGR]=function(){return m||y||getGblPerfMgr()},a.setPerfMgr=function(e){m=e},a.eventCnt=function(){return r[_DYN_LENGTH$2]},a.releaseQueue=function(){var e;g&&0<r[_DYN_LENGTH$2]&&(e=r,r=[],2===V?arrForEach(e,function(e){e.iKey=e.iKey||w,l()[_DYN_PROCESS_NEXT](e)}):_throwInternal(I,2,20,"core init status is not active"))},a.pollInternalLogs=function(e){return L=e||null,q=!1,X&&X[_DYN_CANCEL](),u(!0)},a[_DYN_STOP_POLLING_INTERNA3]=function(){q=!0,X&&X[_DYN_CANCEL](),d()},proxyFunctions(a,function(){return h},["addTelemetryInitializer"]),a[_DYN_UNLOAD]=function(e,t,n){void 0===e&&(e=!0),g||throwError(strSdkNotInitialized),v&&throwError(strSdkUnloadingError);var r,o={reason:50,isAsync:e,flushComplete:!1},i=(e&&!t&&(r=createPromise(function(e){t=e})),createProcessTelemetryUnloadContext(f(),a));return i[_DYN_ON_COMPLETE](function(){F.run(a[_DYN_LOGGER]),doUnloadAll([A,Y,I],e,function(){c(),t&&t(o)})},a),d(),T(e,function(e){o.flushComplete=e,v=!0,U.run(i,o),a[_DYN_STOP_POLLING_INTERNA3](),i[_DYN_PROCESS_NEXT](o)},6,n),r},a[_DYN_GET_PLUGIN]=E,a.addPlugin=function(e,t,n,r){if(!e)return r&&r(!1),void S(strValidationError);var o=E(e[_DYN_IDENTIFIER]);if(o&&!t)return r&&r(!1),void S("Plugin ["+e[_DYN_IDENTIFIER]+"] is already loaded!");var i,a={reason:16};function _(){C[_DYN_PUSH$1](e),a.added=[e],N(a),r&&r(!0)}o?D(i=[o.plugin],{reason:2,isAsync:!!n},function(e){e?(a.removed=i,a.reason|=32,_()):r&&r(!1)}):_()},a.updateCfg=function(r,e){var t,n;void 0===e&&(e=!0),a[_DYN_IS_INITIALIZED]()&&(t={reason:1,cfg:p.cfg,oldCfg:deepExtend({},p.cfg),newConfig:deepExtend({},r),merge:e},r=t.newConfig,n=p.cfg,r[STR_EXTENSIONS]=n[STR_EXTENSIONS],r[STR_CHANNELS]=n[STR_CHANNELS]),p._block(function(t){var n=t.cfg;_deepMergeConfig(t,n,r,e),e||objForEachKey(n,function(e){objHasOwn(r,e)||t.set(n,e,UNDEFINED_VALUE$2)}),t.setDf(n,defaultConfig)},!0),p.notify(),t&&o(t)},a.evtNamespace=function(){return b},a.flush=T,a.getTraceCtx=function(e){return G=G||createDistributedTraceContext()},a.setTraceCtx=function(e){G=e||null},a.addUnloadHook=i,proxyFunctionAs(a,"addUnloadCb",function(){return U},"add"),a.onCfgChange=function(e){return _createUnloadHook(g?onConfigChange(p.cfg,e,a[_DYN_LOGGER]):_addDelayedCfgListener(x,e))},a.getWParam=function(){return hasDocument()||p.cfg.enableWParam?0:-1}})}return e.__ieDyn=1,e}();function parseResponse(e,t){try{if(e&&""!==e){var n=getJSON().parse(e);if(n&&n[_DYN_ITEMS_RECEIVED$1]&&n[_DYN_ITEMS_RECEIVED$1]>=n.itemsAccepted&&n.itemsReceived-n.itemsAccepted===n.errors[_DYN_LENGTH$2])return n}}catch(r){_throwInternal(t,1,43,"Cannot parse the response. "+(r[_DYN_NAME$2]||dumpObj(r)),{response:e})}return null}var STR_EMPTY="",STR_NO_RESPONSE_BODY="NoResponseBody",_noResponseQs="&"+STR_NO_RESPONSE_BODY+"=true",STR_POST_METHOD="POST",SenderPostManager=function(){function e(){var g,o,N,I,Y,i,m,E,f,D,d,y,A,O,C=0;dynamicProto(e,this,function(n,e){var T=!0;function _(e,t){_throwInternal(N,2,26,"Failed to send telemetry.",{message:e}),p(t,400,{})}function S(e){_("No endpoint url is provided for the batch",e)}function p(e,t,n,r){try{e&&e(t,n,r)}catch(o){}}function a(e,t){var n=getNavigator();if(!e[_DYN_URL_STRING])return S(t),!0;t=e[_DYN_URL_STRING]+(A?_noResponseQs:STR_EMPTY),e=e[_DYN_DATA$1],e=I?e:new Blob([e],{type:"text/plain;charset=UTF-8"});return n.sendBeacon(t,e)}function s(e,t,n){var r,o=e[_DYN_DATA$1];try{o&&(a(e,t)?p(t,200,{},STR_EMPTY):(r=Y&&Y.beaconOnRetry)&&isFunction(r)?r(e,t,a):(E&&E.sendPOST(e,t,!0),_throwInternal(N,2,40,". Failed to send telemetry with Beacon API, retried with normal sender.")))}catch(i){I&&_warnToConsole(N,"Failed to send telemetry using sendBeacon API. Ex:"+dumpObj(i)),p(t,I?0:400,{},STR_EMPTY)}}function u(n,r,e){var t,o,i,a=n[_DYN_HEADERS]||{},_=(!e&&g&&(t=createPromise(function(e,t){o=e,i=t})),I&&e&&n.disableXhrSync&&(e=!1),n[_DYN_URL_STRING]);if(!_)return S(r),void(o&&o(!1));var s=openXhr(STR_POST_METHOD,_,T,!0,e,n[_DYN_TIMEOUT]);function u(e){var t=Y&&Y.xhrOnComplete;t&&isFunction(t)?t(e,r,n):(t=getResponseText(e),p(r,e[_DYN_STATUS],_getAllResponseHeaders(e,I),t))}return I||s.setRequestHeader("Content-type","application/json"),arrForEach(objKeys(a),function(e){s.setRequestHeader(e,a[e])}),s.onreadystatechange=function(){I||(u(s),4===s.readyState&&o&&o(!0))},s.onload=function(){I&&u(s)},s.onerror=function(e){p(r,I?s[_DYN_STATUS]:400,_getAllResponseHeaders(s,I),I?STR_EMPTY:formatErrorMessageXhr(s)),i&&i(e)},s.ontimeout=function(){p(r,I?s[_DYN_STATUS]:500,_getAllResponseHeaders(s,I),I?STR_EMPTY:formatErrorMessageXhr(s)),o&&o(!1)},s.send(n[_DYN_DATA$1]),t}function c(n,i,r){var e,o,a,t=n[_DYN_URL_STRING],_=n[_DYN_DATA$1],s=I?_:new Blob([_],{type:"application/json"}),u=new Headers,c=_[_DYN_LENGTH$2],_=!1,l=!1,N=n[_DYN_HEADERS]||{},E=((s={method:STR_POST_METHOD,body:s})[DisabledPropertyName]=!0,n.headers&&0<objKeys(n.headers)[_DYN_LENGTH$2]&&(arrForEach(objKeys(N),function(e){u.append(e,N[e])}),s[_DYN_HEADERS]=u),m?s.credentials=m:T&&I&&(s.credentials="include"),r&&(s.keepalive=!0,C+=c,I?2===n._sendReason&&(_=!0,A&&(t+=_noResponseQs)):_=!0),new Request(t,s));try{E[DisabledPropertyName]=!0}catch(d){}if(!r&&g&&(e=createPromise(function(e,t){o=e,a=t})),!t)return S(i),void(o&&o(!1));function f(e,t){p(i,t?I?0:t:I?0:400,{},I?STR_EMPTY:e)}function D(e,t,n){var r=e[_DYN_STATUS],o=Y.fetchOnComplete;o&&isFunction(o)?o(e,i,n||STR_EMPTY,t):p(i,r,{},n||STR_EMPTY)}try{doAwaitResponse(fetch(I?t:E,I?s:null),function(e){if(r&&(C-=c,c=0),!l)if(l=!0,e.rejected)f(e.reason&&e.reason[_DYN_MESSAGE$1],499),a&&a(e.reason);else{var t=e[_DYN_VALUE];try{I||t.ok?I&&!t.body?(D(t,null,STR_EMPTY),o&&o(!0)):doAwaitResponse(t.text(),function(e){D(t,n,e[_DYN_VALUE]),o&&o(!0)}):(t[_DYN_STATUS]?f(t.statusText,t[_DYN_STATUS]):f(t.statusText,499),o&&o(!1))}catch(d){t&&t[_DYN_STATUS]?f(dumpObj(d),t[_DYN_STATUS]):f(dumpObj(d),499),a&&a(d)}}})}catch(d){l||(f(dumpObj(d),499),a&&a(d))}return _&&!l&&(l=!0,p(i,200,{}),o&&o(!0)),I&&!l&&0<n[_DYN_TIMEOUT]&&O&&O.set(function(){l||(l=!0,p(i,500,{}),o&&o(!0))},n[_DYN_TIMEOUT]),e}function l(n,r,e){var t=getWindow(),o=new XDomainRequest,i=n[_DYN_DATA$1],t=(o.onload=function(){var e=getResponseText(o),t=Y&&Y.xdrOnComplete;t&&isFunction(t)?t(o,r,n):p(r,200,{},e)},o.onerror=function(){p(r,400,{},I?STR_EMPTY:formatErrorMessageXdr(o))},o.ontimeout=function(){p(r,500,{})},o.onprogress=function(){},t&&t.location&&t.location.protocol||""),a=n[_DYN_URL_STRING];if(a){if(!I&&a.lastIndexOf(t,0))return _throwInternal(N,2,40,". Cannot send XDomain request. The endpoint URL protocol doesn't match the hosting page protocol."),void _("Cannot send XDomain request. The endpoint URL protocol doesn't match the hosting page protocol.",r);t=I?a:a[_DYN_REPLACE](/^(https?:)/,"");o.open(STR_POST_METHOD,t),n[_DYN_TIMEOUT]&&(o[_DYN_TIMEOUT]=n[_DYN_TIMEOUT]),o.send(i),I&&e?O&&O.set(function(){o.send(i)},0):o.send(i)}else S(r)}function r(){C=0,A=y=d=D=f=g=o=!1,O=E=m=i=Y=I=N=null}r(),n[_DYN_INITIALIZE$1]=function(e,t){N=t,o&&_throwInternal(N,1,28,"Sender is already initialized"),n.SetConfig(e),o=!0},n._getDbgPlgTargets=function(){return[o,I,i,g]},n.SetConfig=function(e){try{var t;return Y=e.senderOnCompleteCallBack||{},i=!!e.disableCredentials,m=e.fetchCredentials,I=!!e.isOneDs,g=!!e.enableSendPromise,f=!!e.disableXhr,D=!!e.disableBeacon,d=!!e.disableBeaconSync,O=e.timeWrapper,A=!!e.addNoResponse,y=!!e.disableFetchKeepAlive,E={sendPOST:u},I||(T=!1),i&&(t=getLocation())&&t.protocol&&"file:"===t.protocol[_DYN_TO_LOWER_CASE$1]()&&(T=!1),!0}catch(n){}return!1},n.getSyncFetchPayload=function(){return C},n.getSenderInst=function(e,t){if(e&&e[_DYN_LENGTH$2]){for(var n=e,r=t,o=0,i=null,a=0;null==i&&a<n[_DYN_LENGTH$2];)o=n[a],f||1!==o?2!==o||!isFetchSupported(r)||r&&y?3!==o||!isBeaconsSupported()||(r?d:D)||(i=s):i=c:useXDomainRequest()?i=l:isXhrSupported()&&(i=u),a++;return i?{_transport:o,_isSync:r,sendPOST:i}:null}return null},n.getFallbackInst=function(){return E},n[_DYN__DO_TEARDOWN]=function(e,t){r()},n.preparePayload=function(a,e,_,t){if(e&&!t&&_[_DYN_DATA$1])try{var s,u,c,l,n=getInst("CompressionStream");if(isFunction(n))return s=new ReadableStream({start:function(e){e.enqueue(isString(_[_DYN_DATA$1])?(new TextEncoder).encode(_[_DYN_DATA$1]):_[_DYN_DATA$1]),e.close()}}).pipeThrough(new n("gzip")).getReader(),c=0,l=!(u=[]),doAwaitResponse(s.read(),function N(e){if(!l&&!e.rejected){e=e[_DYN_VALUE];if(!e.done)return u[_DYN_PUSH$1](e[_DYN_VALUE]),c+=e.value[_DYN_LENGTH$2],doAwaitResponse(s.read(),N);for(var t=new Uint8Array(c),n=0,r=0,o=u;r<o.length;r++){var i=o[r];t.set(i,n),n+=i[_DYN_LENGTH$2]}_[_DYN_DATA$1]=t,_[_DYN_HEADERS]["Content-Encoding"]="gzip",_._chunkCount=u[_DYN_LENGTH$2]}l||(l=!0,a(_))}),s;a(_)}catch(r){return void a(_)}else a(_)}})}return e.__ieDyn=1,e}(),strOnPrefix="on",strAttachEvent="attachEvent",strAddEventHelper="addEventListener",strDetachEvent="detachEvent",strRemoveEventListener="removeEventListener",strEvents="events",rRemoveEmptyNs=(createUniqueNamespace("aiEvtPageHide"),createUniqueNamespace("aiEvtPageShow"),/\.[\.]+/g),rRemoveTrailingEmptyNs=/[\.]+$/,_guid=1,elmNodeData=createElmNodeData("events"),eventNamespace=/^([^.]*)(?:\.(.+)|)/;function _normalizeNamespace(e){return e&&e[_DYN_REPLACE]?e[_DYN_REPLACE](/^[\s\.]+|(?=[\s\.])[\.\s]+$/g,STR_EMPTY$1):e}function _getEvtNamespace(e,t){t&&(n=STR_EMPTY$1,isArray(t)?(n=STR_EMPTY$1,arrForEach(t,function(e){(e=_normalizeNamespace(e))&&("."!==e[0]&&(e="."+e),n+=e)})):n=_normalizeNamespace(t),n&&("."!==n[0]&&(n="."+n),e=(e||STR_EMPTY$1)+n));var n,t=eventNamespace.exec(e||STR_EMPTY$1)||[];return{type:t[1],ns:(t[2]||STR_EMPTY$1).replace(rRemoveEmptyNs,".").replace(rRemoveTrailingEmptyNs,STR_EMPTY$1)[_DYN_SPLIT$1](".").sort().join(".")}}function _getRegisteredEvents(e,t,n){e=elmNodeData.get(e,strEvents,{},n=void 0===n||n);return e[t]||(e[t]=[])}function _doDetach(e,t,n,r){e&&t&&t[_DYN_TYPE]&&(e[strRemoveEventListener]?e[strRemoveEventListener](t[_DYN_TYPE],n,r):e[strDetachEvent]&&e[strDetachEvent](strOnPrefix+t[_DYN_TYPE],n))}function _doAttach(e,t,n,r){var o=!1;return e&&t&&t[_DYN_TYPE]&&n&&(e[strAddEventHelper]?(e[strAddEventHelper](t[_DYN_TYPE],n,r),o=!0):e[strAttachEvent]&&(e[strAttachEvent](strOnPrefix+t[_DYN_TYPE],n),o=!0)),o}function _doUnregister(e,t,n,r){for(var o=t[_DYN_LENGTH$2];o--;){var i=t[o];!i||n.ns&&n.ns!==i[_DYN_EVT_NAME].ns||r&&!r(i)||(_doDetach(e,i[_DYN_EVT_NAME],i.handler,i.capture),t[_DYN_SPLICE](o,1))}}function _unregisterEvents(n,r,o){var e;r[_DYN_TYPE]?_doUnregister(n,_getRegisteredEvents(n,r[_DYN_TYPE]),r,o):(objForEachKey(e=elmNodeData.get(n,strEvents,{}),function(e,t){_doUnregister(n,t,r,o)}),0===objKeys(e)[_DYN_LENGTH$2]&&elmNodeData.kill(n,strEvents))}function mergeEvtNamespace(e,t){return t?_getEvtNamespace("xx",isArray(t)?[e].concat(t):[e,t]).ns[_DYN_SPLIT$1]("."):e}function eventOn(e,t,n,r,o){void 0===o&&(o=!1);var i=!1;if(e)try{var a,_=_getEvtNamespace(t,r);(i=_doAttach(e,_,n,o))&&elmNodeData.accept(e)&&(a={guid:_guid++,evtName:_,handler:n,capture:o},_getRegisteredEvents(e,_.type)[_DYN_PUSH$1](a))}catch(s){}return i}function eventOff(e,t,n,r,o){if(void 0===o&&(o=!1),e)try{var i=_getEvtNamespace(t,r),a=!1;_unregisterEvents(e,i,function(e){return!((!i.ns||n)&&e.handler!==n)&&(a=!0)}),a||_doDetach(e,i,n,o)}catch(_){}}var SampleRate="sampleRate",ProcessLegacy="ProcessLegacy",HttpMethod="http.method",DEFAULT_BREEZE_ENDPOINT="https://dc.services.visualstudio.com",DEFAULT_BREEZE_PATH="/v2/track",strNotSpecified="not_specified",RequestHeaders=createValueMap({requestContextHeader:[0,"Request-Context"],requestContextTargetKey:[1,"appId"],requestContextAppIdFormat:[2,"appId=cid-v1:"],requestIdHeader:[3,"Request-Id"],traceParentHeader:[4,"traceparent"],traceStateHeader:[5,"tracestate"],sdkContextHeader:[6,"Sdk-Context"],sdkContextHeaderAppIdRequest:[7,"appId"],requestContextHeaderLowerCase:[8,"request-context"]}),_DYN_SPLIT="split",_DYN_LENGTH$1="length",_DYN_TO_LOWER_CASE="toLowerCase",_DYN_INGESTIONENDPOINT="ingestionendpoint",_DYN_TO_STRING$1="toString",_DYN_REMOVE_ITEM="removeItem",_DYN_MESSAGE="message",_DYN_COUNT$1="count",_DYN_STRINGIFY$1="stringify",_DYN_PATHNAME="pathname",_DYN_MATCH="match",_DYN_NAME$1="name",_DYN_PROPERTIES="properties",_DYN_MEASUREMENTS$1="measurements",_DYN_SIZE_IN_BYTES="sizeInBytes",_DYN_TYPE_NAME="typeName",_DYN_EXCEPTIONS="exceptions",_DYN_SEVERITY_LEVEL="severityLevel",_DYN_PROBLEM_GROUP="problemGroup",_DYN_PARSED_STACK="parsedStack",_DYN_HAS_FULL_STACK="hasFullStack",_DYN_ASSEMBLY="assembly",_DYN_FILE_NAME="fileName",_DYN_LINE="line",_DYN_AI_DATA_CONTRACT="aiDataContract",_DYN_DURATION="duration";function dataSanitizeKeyAndAddUniqueness(e,t,n){var r=t[_DYN_LENGTH$1],o=dataSanitizeKey(e,t);if(o[_DYN_LENGTH$1]!==r){for(var i=0,a=o;n[a]!==undefined;)i++,a=strSubstring(o,0,147)+dsPadNumber(i);o=a}return o}function dataSanitizeKey(e,t){var n;return t&&150<(t=strTrim(asString(t)))[_DYN_LENGTH$1]&&(n=strSubstring(t,0,150),_throwInternal(e,2,57,"name is too long.  It has been truncated to 150 characters.",{name:t},!0)),n||t}function dataSanitizeString(e,t,n){var r;return void 0===n&&(n=1024),t&&(n=n||1024,(t=strTrim(asString(t)))[_DYN_LENGTH$1]>n&&(r=strSubstring(t,0,n),_throwInternal(e,2,61,"string value is too long. It has been truncated to "+n+" characters.",{value:t},!0))),r||t}function dataSanitizeUrl(e,t){return dataSanitizeInput(e,t,2048,66)}function dataSanitizeMessage(e,t){var n;return t&&32768<t[_DYN_LENGTH$1]&&(n=strSubstring(t,0,32768),_throwInternal(e,2,56,"message is too long, it has been truncated to 32768 characters.",{message:t},!0)),n||t}function dataSanitizeException(e,t){var n,r;return t&&32768<(r=""+t)[_DYN_LENGTH$1]&&(n=strSubstring(r,0,32768),_throwInternal(e,2,52,"exception is too long, it has been truncated to 32768 characters.",{exception:t},!0)),n||t}function dataSanitizeProperties(r,e){var o;return e&&(o={},objForEachKey(e,function(e,t){if(isObject(t)&&hasJSON())try{t=getJSON()[_DYN_STRINGIFY$1](t)}catch(n){_throwInternal(r,2,49,"custom property is not valid",{exception:n},!0)}t=dataSanitizeString(r,t,8192),e=dataSanitizeKeyAndAddUniqueness(r,e,o),o[e]=t}),e=o),e}function dataSanitizeMeasurements(n,e){var r;return e&&(r={},objForEachKey(e,function(e,t){e=dataSanitizeKeyAndAddUniqueness(n,e,r),r[e]=t}),e=r),e}function dataSanitizeId(e,t){return t&&dataSanitizeInput(e,t,128,69)[_DYN_TO_STRING$1]()}function dataSanitizeInput(e,t,n,r){var o;return t&&(t=strTrim(asString(t)))[_DYN_LENGTH$1]>n&&(o=strSubstring(t,0,n),_throwInternal(e,2,r,"input is too long, it has been truncated to "+n+" characters.",{data:t},!0)),o||t}function dsPadNumber(e){e="00"+e;return strSubstr(e,e[_DYN_LENGTH$1]-3)}var _document=getDocument()||{},_htmlAnchorIdx=0,_htmlAnchorElement=[null,null,null,null,null];function urlParseUrl(e){var t=_htmlAnchorIdx,n=_htmlAnchorElement,r=n[t];return _document.createElement?n[t]||(r=n[t]=_document.createElement("a")):r={host:urlParseHost(e,!0)},r.href=e,++t>=n[_DYN_LENGTH$1]&&(t=0),_htmlAnchorIdx=t,r}function urlParseHost(e,t){e=urlParseFullHost(e,t)||"";if(e){t=e[_DYN_MATCH](/(www\d{0,5}\.)?([^\/:]{1,256})(:\d{1,20})?/i);if(null!=t&&3<t[_DYN_LENGTH$1]&&isString(t[2])&&0<t[2][_DYN_LENGTH$1])return t[2]+(t[3]||"")}return e}function urlParseFullHost(e,t){var n=null;return e&&null!=(e=e[_DYN_MATCH](/(\w{1,150}):\/\/([^\/:]{1,256})(:\d{1,20})?/i))&&2<e[_DYN_LENGTH$1]&&isString(e[2])&&0<e[2][_DYN_LENGTH$1]&&(n=e[2]||"",t&&2<e[_DYN_LENGTH$1]&&(t=(e[1]||"")[_DYN_TO_LOWER_CASE](),e=e[3]||"",n+=e="http"===t&&":80"===e||"https"===t&&":443"===e?"":e)),n}var _internalEndpoints=[DEFAULT_BREEZE_ENDPOINT+DEFAULT_BREEZE_PATH,"https://breeze.aimon.applicationinsights.io"+DEFAULT_BREEZE_PATH,"https://dc-int.services.visualstudio.com"+DEFAULT_BREEZE_PATH];function isInternalApplicationInsightsEndpoint(e){return-1!==arrIndexOf(_internalEndpoints,e[_DYN_TO_LOWER_CASE]())}function AjaxHelperParseDependencyPath(e,t,n,r){var o,i,a,_=r,s=r,_=t&&0<t[_DYN_LENGTH$1]?(a=(o=urlParseUrl(t)).host,_||(null!=o[_DYN_PATHNAME]?("/"!=((i=0===o.pathname[_DYN_LENGTH$1]?"/":o[_DYN_PATHNAME])[0]||"")&&(i="/"+i),s=o[_DYN_PATHNAME],dataSanitizeString(e,n?n+" "+i:i)):dataSanitizeString(e,t))):a=r;return{target:a,name:_,data:s}}var StorageType=createEnumStyle({LocalStorage:0,SessionStorage:1}),_canUseSessionStorage=undefined,_storagePrefix="";function _getVerifiedStorageObject(e){try{if(isNullOrUndefined(getGlobal()))return null;var t=(new Date)[_DYN_TO_STRING$1](),n=getInst(e===StorageType.LocalStorage?"localStorage":"sessionStorage"),r=_storagePrefix+t,o=(n.setItem(r,t),n.getItem(r)!==t);if(n[_DYN_REMOVE_ITEM](r),!o)return n}catch(i){}return null}function _getSessionStorageObject(){return utlCanUseSessionStorage()?_getVerifiedStorageObject(StorageType.SessionStorage):null}function utlSetStoragePrefix(e){_storagePrefix=e||""}function utlCanUseSessionStorage(e){return _canUseSessionStorage=e||_canUseSessionStorage===undefined?!!_getVerifiedStorageObject(StorageType.SessionStorage):_canUseSessionStorage}function utlGetSessionStorage(e,t){var n=_getSessionStorageObject();if(null!==n)try{return n.getItem(t)}catch(r){_canUseSessionStorage=!1,_throwInternal(e,2,2,"Browser failed read of session storage. "+getExceptionName(r),{exception:dumpObj(r)})}return null}function utlSetSessionStorage(e,t,n){var r=_getSessionStorageObject();if(null!==r)try{return r.setItem(t,n),!0}catch(o){_canUseSessionStorage=!1,_throwInternal(e,2,4,"Browser failed write to session storage. "+getExceptionName(o),{exception:dumpObj(o)})}return!1}function utlRemoveSessionStorage(e,t){var n=_getSessionStorageObject();if(null!==n)try{return n[_DYN_REMOVE_ITEM](t),!0}catch(r){_canUseSessionStorage=!1,_throwInternal(e,2,6,"Browser failed removal of session storage item. "+getExceptionName(r),{exception:dumpObj(r)})}return!1}var _FIELDS_SEPARATOR=";",_FIELD_KEY_VALUE_SEPARATOR="=";function parseConnectionString(e){if(!e)return{};var t,e=e[_DYN_SPLIT](_FIELDS_SEPARATOR),e=arrReduce(e,function(e,t){var n,t=t[_DYN_SPLIT](_FIELD_KEY_VALUE_SEPARATOR);return 2===t[_DYN_LENGTH$1]&&(n=t[0][_DYN_TO_LOWER_CASE](),t=t[1],e[n]=t),e},{});return 0<objKeys(e)[_DYN_LENGTH$1]&&(e.endpointsuffix&&(t=e.location?e.location+".":"",e[_DYN_INGESTIONENDPOINT]=e[_DYN_INGESTIONENDPOINT]||"https://"+t+"dc."+e.endpointsuffix),e[_DYN_INGESTIONENDPOINT]=e[_DYN_INGESTIONENDPOINT]||DEFAULT_BREEZE_ENDPOINT,strEndsWith(e[_DYN_INGESTIONENDPOINT],"/")&&(e[_DYN_INGESTIONENDPOINT]=e[_DYN_INGESTIONENDPOINT].slice(0,-1))),e}var Envelope=function(e,t,n){var r=this,o=this;o.ver=1,o.sampleRate=100,o.tags={},o[_DYN_NAME$1]=dataSanitizeString(e,n)||strNotSpecified,o.data=t,o.time=toISOString(new Date),o[_DYN_AI_DATA_CONTRACT]={time:1,iKey:1,name:1,sampleRate:function(){return 100===r.sampleRate?4:1},tags:1,data:1}},Event$1=function(){function e(e,t,n,r){this.aiDataContract={ver:1,name:1,properties:0,measurements:0},this.ver=2,this[_DYN_NAME$1]=dataSanitizeString(e,t)||strNotSpecified,this[_DYN_PROPERTIES]=dataSanitizeProperties(e,n),this[_DYN_MEASUREMENTS$1]=dataSanitizeMeasurements(e,r)}return e.envelopeType="Microsoft.ApplicationInsights.{0}.Event",e.dataType="EventData",e}(),STACKFRAME_BASE_SIZE=58,IS_FRAME=/^\s{0,50}(from\s|at\s|Line\s{1,5}\d{1,10}\s{1,5}of|\w{1,50}@\w{1,80}|[^\(\s\n]+:[0-9\?]+(?::[0-9\?]+)?)/,FULL_STACK_FRAME_1=/^(?:\s{0,50}at)?\s{0,50}([^\@\()\s]+)?\s{0,50}(?:\s|\@|\()\s{0,5}([^\(\s\n\]]+):([0-9\?]+):([0-9\?]+)\)?$/,FULL_STACK_FRAME_2=/^(?:\s{0,50}at)?\s{0,50}([^\@\()\s]+)?\s{0,50}(?:\s|\@|\()\s{0,5}([^\(\s\n\]]+):([0-9\?]+)\)?$/,FULL_STACK_FRAME_3=/^(?:\s{0,50}at)?\s{0,50}([^\@\()\s]+)?\s{0,50}(?:\s|\@|\()\s{0,5}([^\(\s\n\)\]]+)\)?$/,EXTRACT_FILENAME=/(?:^|\(|\s{0,10}[\w\)]+\@)?([^\(\n\s\]\)]+)(?:\:([0-9]+)(?:\:([0-9]+))?)?\)?(?:,|$)/,PARSE_FILENAME_LINE_COL=/([^\(\s\n]+):([0-9]+):([0-9]+)$/,PARSE_FILENAME_LINE_ONLY=/([^\(\s\n]+):([0-9]+)$/,NoMethod="<no_method>",strError="error",strStack="stack",strStackDetails="stackDetails",strErrorSrc="errorSrc",strMessage="message",strDescription="description",_parseSequence=[{re:FULL_STACK_FRAME_1,len:5,m:1,fn:2,ln:3,col:4},{chk:_ignoreNative,pre:_scrubAnonymous,re:FULL_STACK_FRAME_2,len:4,m:1,fn:2,ln:3},{re:FULL_STACK_FRAME_3,len:3,m:1,fn:2,hdl:_handleFilename},{re:EXTRACT_FILENAME,len:2,fn:1,hdl:_handleFilename}];function _scrubAnonymous(e){return e.replace(/(\(anonymous\))/,"<anonymous>")}function _ignoreNative(e){return strIndexOf(e,"[native")<0}function _stringify(e,t){var n=e;return n&&!isString(n)&&(JSON&&JSON[_DYN_STRINGIFY$1]?(n=JSON[_DYN_STRINGIFY$1](e),!t||n&&"{}"!==n||(n=isFunction(e[_DYN_TO_STRING$1])?e[_DYN_TO_STRING$1]():""+e)):n=e+" - (Missing JSON.stringify)"),n||""}function _formatMessage(e,t){var n=e;return e&&((n=n&&!isString(n)&&(e[strMessage]||e[strDescription])||n)&&!isString(n)&&(n=_stringify(n,!0)),e.filename&&(n=n+" @"+(e.filename||"")+":"+(e.lineno||"?")+":"+(e.colno||"?"))),(t&&"String"!==t&&"Object"!==t&&"Error"!==t&&-1===strIndexOf(n||"",t)?t+": "+n:n)||""}function _isExceptionDetailsInternal(e){try{if(isObject(e))return"hasFullStack"in e&&"typeName"in e}catch(t){}return!1}function _isExceptionInternal(e){try{if(isObject(e))return"ver"in e&&"exceptions"in e&&"properties"in e}catch(t){}return!1}function _isStackDetails(e){return e&&e.src&&isString(e.src)&&e.obj&&isArray(e.obj)}function _convertStackObj(e){var e=e||"",t=(e=isString(e)?e:isString(e[strStack])?e[strStack]:""+e)[_DYN_SPLIT]("\n");return{src:e,obj:t}}function _getOperaStack(e){for(var t=[],n=e[_DYN_SPLIT]("\n"),r=0;r<n[_DYN_LENGTH$1];r++){var o=n[r];n[r+1]&&(o+="@"+n[r+1],r++),t.push(o)}return{src:e,obj:t}}function _getStackFromErrorObj(e){var t,n=null;if(e)try{e[strStack]?n=_convertStackObj(e[strStack]):e[strError]&&e[strError][strStack]?n=_convertStackObj(e[strError][strStack]):e.exception&&e.exception[strStack]?n=_convertStackObj(e.exception[strStack]):_isStackDetails(e)?n=e:_isStackDetails(e[strStackDetails])?n=e[strStackDetails]:getWindow()&&getWindow().opera&&e[strMessage]?n=_getOperaStack(e[_DYN_MESSAGE]):e.reason&&e.reason[strStack]?n=_convertStackObj(e.reason[strStack]):isString(e)?n=_convertStackObj(e):(t=e[strMessage]||e[strDescription]||"",isString(e[strErrorSrc])&&(t&&(t+="\n"),t+=" from "+e[strErrorSrc]),t&&(n=_convertStackObj(t)))}catch(r){n=_convertStackObj(r)}return n||{src:"",obj:null}}function _formatStackTrace(e){return e?e.obj?e.obj.join("\n"):e.src||"":""}function _parseStack(e){e=e.obj;if(e&&0<e[_DYN_LENGTH$1]){var t=[],n=0,r=!1,o=0;if(arrForEach(e,function(e){(r||_isStackFrame(e))&&(e=asString(e),r=!0,(e=_extractStackFrame(e,n))&&(o+=e[_DYN_SIZE_IN_BYTES],t.push(e),n++))}),32768<o)for(var i=0,a=t[_DYN_LENGTH$1]-1,_=0,s=i,u=a;i<a;){if(32768<(_+=t[i][_DYN_SIZE_IN_BYTES]+t[a][_DYN_SIZE_IN_BYTES])){t.splice(s,u-s+1);break}s=i,u=a,i++,a--}}return t}function _getErrorType(e){var t="";if(e&&!(t=e.typeName||e[_DYN_NAME$1]||""))try{var n=/function (.{1,200})\(/.exec(e.constructor[_DYN_TO_STRING$1]()),t=n&&1<n[_DYN_LENGTH$1]?n[1]:""}catch(r){}return t}function _formatErrorCode(e){if(e)try{var t,n;if(!isString(e))return t=_getErrorType(e),(n=_stringify(e,!1))&&"{}"!==n||(e[strError]&&(t=_getErrorType(e=e[strError])),n=_stringify(e,!0)),0!==strIndexOf(n,t)&&"String"!==t?t+":"+n:n}catch(r){}return""+(e||"")}var Exception=function(){function i(e,t,n,r,o,i){this.aiDataContract={ver:1,exceptions:1,severityLevel:0,properties:0,measurements:0};var a=this;a.ver=2,_isExceptionInternal(t)?(a[_DYN_EXCEPTIONS]=t[_DYN_EXCEPTIONS]||[],a[_DYN_PROPERTIES]=t[_DYN_PROPERTIES],a[_DYN_MEASUREMENTS$1]=t[_DYN_MEASUREMENTS$1],t[_DYN_SEVERITY_LEVEL]&&(a[_DYN_SEVERITY_LEVEL]=t[_DYN_SEVERITY_LEVEL]),t.id&&(a.id=t.id,t[_DYN_PROPERTIES].id=t.id),t[_DYN_PROBLEM_GROUP]&&(a[_DYN_PROBLEM_GROUP]=t[_DYN_PROBLEM_GROUP]),isNullOrUndefined(t.isManual)||(a.isManual=t.isManual)):(n=n||{},i&&(n.id=i),a[_DYN_EXCEPTIONS]=[_createExceptionDetails(e,t,n)],a[_DYN_PROPERTIES]=dataSanitizeProperties(e,n),a[_DYN_MEASUREMENTS$1]=dataSanitizeMeasurements(e,r),o&&(a[_DYN_SEVERITY_LEVEL]=o),i&&(a.id=i))}return i.CreateAutoException=function(e,t,n,r,o,i,a,_){var s=_getErrorType(o||i||e);return{message:_formatMessage(e,s),url:t,lineNumber:n,columnNumber:r,error:_formatErrorCode(o||i||e),evt:_formatErrorCode(i||e),typeName:s,stackDetails:_getStackFromErrorObj(a||o||i),errorSrc:_}},i.CreateFromInterface=function(t,e,n,r){var o=e[_DYN_EXCEPTIONS]&&arrMap(e[_DYN_EXCEPTIONS],function(e){return _createExDetailsFromInterface(t,e)});return new i(t,__assignFn(__assignFn({},e),{exceptions:o}),n,r)},i.prototype.toInterface=function(){var e=this,t=e.exceptions,n=e.properties,r=e.measurements,o=e.severityLevel,i=e.problemGroup,a=e.id,e=e.isManual;return{ver:"4.0",exceptions:t instanceof Array&&arrMap(t,function(e){return e.toInterface()})||undefined,severityLevel:o,properties:n,measurements:r,problemGroup:i,id:a,isManual:e}},i.CreateSimpleException=function(e,t,n,r,o,i){var a;return{exceptions:[((a={})[_DYN_HAS_FULL_STACK]=!0,a.message=e,a.stack=o,a.typeName=t,a)]}},i.envelopeType="Microsoft.ApplicationInsights.{0}.Exception",i.dataType="ExceptionData",i.formatError=_formatErrorCode,i}(),exDetailsAiDataContract=objFreeze({id:0,outerId:0,typeName:1,message:1,hasFullStack:0,stack:0,parsedStack:2});function _toInterface(){var e=this,t=isArray(e[_DYN_PARSED_STACK])&&arrMap(e[_DYN_PARSED_STACK],function(e){return _parsedFrameToInterface(e)});return{id:e.id,outerId:e.outerId,typeName:e[_DYN_TYPE_NAME],message:e[_DYN_MESSAGE],hasFullStack:e[_DYN_HAS_FULL_STACK],stack:e[strStack],parsedStack:t||undefined}}function _createExceptionDetails(t,e,n){var r,o,i,a,_,s,u;return _isExceptionDetailsInternal(e)?(r=e[_DYN_TYPE_NAME],o=e[_DYN_MESSAGE],a=e[strStack],u=e[_DYN_PARSED_STACK]||[],i=e[_DYN_HAS_FULL_STACK]):(s=(_=e)&&_.evt,isError(_)||(_=_[strError]||s||_),r=dataSanitizeString(t,_getErrorType(_))||strNotSpecified,o=dataSanitizeMessage(t,_formatMessage(e||_,r))||strNotSpecified,u=_parseStack(s=e[strStackDetails]||_getStackFromErrorObj(e)),isArray(u)&&arrMap(u,function(e){e[_DYN_ASSEMBLY]=dataSanitizeString(t,e[_DYN_ASSEMBLY]),e[_DYN_FILE_NAME]=dataSanitizeString(t,e[_DYN_FILE_NAME])}),a=dataSanitizeException(t,_formatStackTrace(s)),i=isArray(u)&&0<u[_DYN_LENGTH$1],n&&(n[_DYN_TYPE_NAME]=n[_DYN_TYPE_NAME]||r)),(_={})[_DYN_AI_DATA_CONTRACT]=exDetailsAiDataContract,_.id=void 0,_.outerId=void 0,_.typeName=r,_.message=o,_[_DYN_HAS_FULL_STACK]=i,_.stack=a,_.parsedStack=u,_.toInterface=_toInterface,_}function _createExDetailsFromInterface(e,t){var n=isArray(t[_DYN_PARSED_STACK])&&arrMap(t[_DYN_PARSED_STACK],function(e){return _stackFrameFromInterface(e)})||t[_DYN_PARSED_STACK];return _createExceptionDetails(e,__assignFn(__assignFn({},t),{parsedStack:n}))}function _parseFilename(e,t){var n=t[_DYN_MATCH](PARSE_FILENAME_LINE_COL);n&&4<=n[_DYN_LENGTH$1]?(e[_DYN_FILE_NAME]=n[1],e[_DYN_LINE]=parseInt(n[2])):(n=t[_DYN_MATCH](PARSE_FILENAME_LINE_ONLY))&&3<=n[_DYN_LENGTH$1]?(e[_DYN_FILE_NAME]=n[1],e[_DYN_LINE]=parseInt(n[2])):e[_DYN_FILE_NAME]=t}function _handleFilename(e,t,n){var r=e[_DYN_FILE_NAME];t.fn&&n&&n[_DYN_LENGTH$1]>t.fn&&(t.ln&&n[_DYN_LENGTH$1]>t.ln?(r=strTrim(n[t.fn]||""),e[_DYN_LINE]=parseInt(strTrim(n[t.ln]||""))||0):r=strTrim(n[t.fn]||"")),r&&_parseFilename(e,r)}function _isStackFrame(e){var t=!1;return e&&isString(e)&&(e=strTrim(e))?IS_FRAME.test(e):t}var stackFrameAiDataContract=objFreeze({level:1,method:1,assembly:0,fileName:0,line:0});function _extractStackFrame(e,t){var n;if(e&&isString(e)&&strTrim(e)){(n={})[_DYN_AI_DATA_CONTRACT]=stackFrameAiDataContract,n.level=t,n.assembly=strTrim(e),n.method=NoMethod,n.fileName="",n.line=0,n.sizeInBytes=0;for(var r=n,o=0;o<_parseSequence[_DYN_LENGTH$1];){var i=_parseSequence[o];if(i.chk&&!i.chk(e))break;var a=(e=i.pre?i.pre(e):e)[_DYN_MATCH](i.re);if(a&&a[_DYN_LENGTH$1]>=i.len){i.m&&(r.method=strTrim(a[i.m]||NoMethod)),i.hdl?i.hdl(r,i,a):i.fn&&(i.ln?(r[_DYN_FILE_NAME]=strTrim(a[i.fn]||""),r[_DYN_LINE]=parseInt(strTrim(a[i.ln]||""))||0):_parseFilename(r,a[i.fn]||""));break}o++}}return _populateFrameSizeInBytes(r)}function _stackFrameFromInterface(e){var t;return(t={})[_DYN_AI_DATA_CONTRACT]=stackFrameAiDataContract,t.level=e.level,t.method=e.method,t.assembly=e[_DYN_ASSEMBLY],t.fileName=e[_DYN_FILE_NAME],t.line=e[_DYN_LINE],t.sizeInBytes=0,_populateFrameSizeInBytes(t)}function _populateFrameSizeInBytes(e){var t=STACKFRAME_BASE_SIZE;return e&&(t=(t+=e.method[_DYN_LENGTH$1])+e.assembly[_DYN_LENGTH$1]+e.fileName[_DYN_LENGTH$1]+e.level.toString()[_DYN_LENGTH$1]+e.line.toString()[_DYN_LENGTH$1],e[_DYN_SIZE_IN_BYTES]=t),e}function _parsedFrameToInterface(e){return{level:e.level,method:e.method,assembly:e[_DYN_ASSEMBLY],fileName:e[_DYN_FILE_NAME],line:e[_DYN_LINE]}}var DataPoint=function(){this.aiDataContract={name:1,kind:0,value:1,count:0,min:0,max:0,stdDev:0},this.kind=0},Metric=function(){function e(e,t,n,r,o,i,a,_,s){this.aiDataContract={ver:1,metrics:1,properties:0},this.ver=2;var u=new DataPoint;u[_DYN_COUNT$1]=0<r?r:undefined,u.max=isNaN(i)||null===i?undefined:i,u.min=isNaN(o)||null===o?undefined:o,u[_DYN_NAME$1]=dataSanitizeString(e,t)||strNotSpecified,u.value=n,u.stdDev=isNaN(a)||null===a?undefined:a,this.metrics=[u],this[_DYN_PROPERTIES]=dataSanitizeProperties(e,_),this[_DYN_MEASUREMENTS$1]=dataSanitizeMeasurements(e,s)}return e.envelopeType="Microsoft.ApplicationInsights.{0}.Metric",e.dataType="MetricData",e}(),strEmpty="";function msToTimeSpan(e){e=mathRound(e=isNaN(e)||e<0?0:e);var t=strEmpty+e%1e3,n=strEmpty+mathFloor(e/1e3)%60,r=strEmpty+mathFloor(e/6e4)%60,o=strEmpty+mathFloor(e/36e5)%24,e=mathFloor(e/864e5),t=1===t[_DYN_LENGTH$1]?"00"+t:2===t[_DYN_LENGTH$1]?"0"+t:t,n=n[_DYN_LENGTH$1]<2?"0"+n:n,r=r[_DYN_LENGTH$1]<2?"0"+r:r,o=o[_DYN_LENGTH$1]<2?"0"+o:o;return(0<e?e+".":strEmpty)+o+":"+r+":"+n+"."+t}var PageView=function(){function e(e,t,n,r,o,i,a){this.aiDataContract={ver:1,name:0,url:0,duration:0,properties:0,measurements:0,id:0};var _=this;_.ver=2,_.id=dataSanitizeId(e,a),_.url=dataSanitizeUrl(e,n),_[_DYN_NAME$1]=dataSanitizeString(e,t)||strNotSpecified,isNaN(r)||(_[_DYN_DURATION]=msToTimeSpan(r)),_[_DYN_PROPERTIES]=dataSanitizeProperties(e,o),_[_DYN_MEASUREMENTS$1]=dataSanitizeMeasurements(e,i)}return e.envelopeType="Microsoft.ApplicationInsights.{0}.Pageview",e.dataType="PageviewData",e}(),RemoteDependencyData=function(){function e(e,t,n,r,o,i,a,_,s,u,c,l){void 0===s&&(s="Ajax"),this.aiDataContract={id:1,ver:1,name:0,resultCode:0,duration:0,success:0,data:0,target:0,type:0,properties:0,measurements:0,kind:0,value:0,count:0,min:0,max:0,stdDev:0,dependencyKind:0,dependencySource:0,commandName:0,dependencyTypeName:0};var N=this,t=(N.ver=2,N.id=t,N[_DYN_DURATION]=msToTimeSpan(o),N.success=i,N.resultCode=a+"",N.type=dataSanitizeString(e,s),AjaxHelperParseDependencyPath(e,n,_,r));N.data=dataSanitizeUrl(e,r)||t.data,N.target=dataSanitizeString(e,t.target),u&&(N.target="".concat(N.target," | ").concat(u)),N[_DYN_NAME$1]=dataSanitizeString(e,t[_DYN_NAME$1]),N[_DYN_PROPERTIES]=dataSanitizeProperties(e,c),N[_DYN_MEASUREMENTS$1]=dataSanitizeMeasurements(e,l)}return e.envelopeType="Microsoft.ApplicationInsights.{0}.RemoteDependency",e.dataType="RemoteDependencyData",e}(),Trace=function(){function e(e,t,n,r,o){this.aiDataContract={ver:1,message:1,severityLevel:0,properties:0};var i=this;i.ver=2,i[_DYN_MESSAGE]=dataSanitizeMessage(e,t=t||strNotSpecified),i[_DYN_PROPERTIES]=dataSanitizeProperties(e,r),i[_DYN_MEASUREMENTS$1]=dataSanitizeMeasurements(e,o),n&&(i[_DYN_SEVERITY_LEVEL]=n)}return e.envelopeType="Microsoft.ApplicationInsights.{0}.Message",e.dataType="MessageData",e}(),PageViewPerformance=function(){function e(e,t,n,r,o,i,a){this.aiDataContract={ver:1,name:0,url:0,duration:0,perfTotal:0,networkConnect:0,sentRequest:0,receivedResponse:0,domProcessing:0,properties:0,measurements:0};var _=this;_.ver=2,_.url=dataSanitizeUrl(e,n),_[_DYN_NAME$1]=dataSanitizeString(e,t)||strNotSpecified,_[_DYN_PROPERTIES]=dataSanitizeProperties(e,o),_[_DYN_MEASUREMENTS$1]=dataSanitizeMeasurements(e,i),a&&(_.domProcessing=a.domProcessing,_[_DYN_DURATION]=a[_DYN_DURATION],_.networkConnect=a.networkConnect,_.perfTotal=a.perfTotal,_.receivedResponse=a.receivedResponse,_.sentRequest=a.sentRequest)}return e.envelopeType="Microsoft.ApplicationInsights.{0}.PageviewPerformance",e.dataType="PageviewPerformanceData",e}(),Data=function(e,t){this.aiDataContract={baseType:1,baseData:1},this.baseType=e,this.baseData=t},SeverityLevel=createEnumStyle({Verbose:0,Information:1,Warning:2,Error:3,Critical:4});function _aiNameFunc(e){var t="ai."+e+".";return function(e){return t+e}}var _aiApplication=_aiNameFunc("application"),_aiDevice=_aiNameFunc("device"),_aiLocation=_aiNameFunc("location"),_aiOperation=_aiNameFunc("operation"),_aiSession=_aiNameFunc("session"),_aiUser=_aiNameFunc("user"),_aiCloud=_aiNameFunc("cloud"),_aiInternal=_aiNameFunc("internal"),ContextTagKeys=function(e){function t(){return e.call(this)||this}return __extendsFn(t,e),t}(createClassFromInterface({applicationVersion:_aiApplication("ver"),applicationBuild:_aiApplication("build"),applicationTypeId:_aiApplication("typeId"),applicationId:_aiApplication("applicationId"),applicationLayer:_aiApplication("layer"),deviceId:_aiDevice("id"),deviceIp:_aiDevice("ip"),deviceLanguage:_aiDevice("language"),deviceLocale:_aiDevice("locale"),deviceModel:_aiDevice("model"),deviceFriendlyName:_aiDevice("friendlyName"),deviceNetwork:_aiDevice("network"),deviceNetworkName:_aiDevice("networkName"),deviceOEMName:_aiDevice("oemName"),deviceOS:_aiDevice("os"),deviceOSVersion:_aiDevice("osVersion"),deviceRoleInstance:_aiDevice("roleInstance"),deviceRoleName:_aiDevice("roleName"),deviceScreenResolution:_aiDevice("screenResolution"),deviceType:_aiDevice("type"),deviceMachineName:_aiDevice("machineName"),deviceVMName:_aiDevice("vmName"),deviceBrowser:_aiDevice("browser"),deviceBrowserVersion:_aiDevice("browserVersion"),locationIp:_aiLocation("ip"),locationCountry:_aiLocation("country"),locationProvince:_aiLocation("province"),locationCity:_aiLocation("city"),operationId:_aiOperation("id"),operationName:_aiOperation("name"),operationParentId:_aiOperation("parentId"),operationRootId:_aiOperation("rootId"),operationSyntheticSource:_aiOperation("syntheticSource"),operationCorrelationVector:_aiOperation("correlationVector"),sessionId:_aiSession("id"),sessionIsFirst:_aiSession("isFirst"),sessionIsNew:_aiSession("isNew"),userAccountAcquisitionDate:_aiUser("accountAcquisitionDate"),userAccountId:_aiUser("accountId"),userAgent:_aiUser("userAgent"),userId:_aiUser("id"),userStoreRegion:_aiUser("storeRegion"),userAuthUserId:_aiUser("authUserId"),userAnonymousUserAcquisitionDate:_aiUser("anonUserAcquisitionDate"),userAuthenticatedUserAcquisitionDate:_aiUser("authUserAcquisitionDate"),cloudName:_aiCloud("name"),cloudRole:_aiCloud("role"),cloudRoleVer:_aiCloud("roleVer"),cloudRoleInstance:_aiCloud("roleInstance"),cloudEnvironment:_aiCloud("environment"),cloudLocation:_aiCloud("location"),cloudDeploymentUnit:_aiCloud("deploymentUnit"),internalNodeName:_aiInternal("nodeName"),internalSdkVersion:_aiInternal("sdkVersion"),internalAgentVersion:_aiInternal("agentVersion"),internalSnippet:_aiInternal("snippet"),internalSdkSrc:_aiInternal("sdkSrc")})),CtxTagKeys=new ContextTagKeys;function _disableEvents(e,t){eventOff(e,null,null,t)}function createOfflineListener(e){var t,n=getDocument(),r=getNavigator(),o=!1,i=[],a=1,_=(!r||isNullOrUndefined(r.onLine)||r.onLine||(a=2),0),s=l(),u=mergeEvtNamespace(createUniqueNamespace("OfflineListener"),e);try{c(getWindow())&&(o=!0),n&&(t=n.body||n).ononline&&c(t)&&(o=!0)}catch(D){o=!1}function c(e){var t=!1;return e&&(t=eventOn(e,"online",E,u))&&eventOn(e,"offline",f,u),t}function l(){return 2!==_&&2!==a}function N(){var e=l();s!==e&&(s=e,arrForEach(i,function(e){var t={isOnline:s,rState:a,uState:_};try{e(t)}catch(D){}}))}function E(){a=1,N()}function f(){a=2,N()}return{isOnline:function(){return s},isListening:function(){return o},unload:function(){var e=getWindow();e&&o&&(_disableEvents(e,u),n&&!isUndefined((e=n.body||n).ononline)&&_disableEvents(e,u),o=!1)},addListener:function(t){return i.push(t),{rm:function(){var e=i.indexOf(t);if(-1<e)return i.splice(e,1)}}},setOnlineState:function(e){_=e,N()}}}var BreezeChannelIdentifier="AppInsightsChannelPlugin",STR_DURATION="duration",_DYN_TAGS="tags",_DYN_DEVICE_TYPE="deviceType",_DYN_DATA="data",_DYN_NAME="name",_DYN_TRACE_ID="traceID",_DYN_LENGTH="length",_DYN_STRINGIFY="stringify",_DYN_MEASUREMENTS="measurements",_DYN_DATA_TYPE="dataType",_DYN_ENVELOPE_TYPE="envelopeType",_DYN_TO_STRING="toString",_DYN_ENQUEUE="enqueue",_DYN_COUNT="count",_DYN_PUSH="push",_DYN_EMIT_LINE_DELIMITED_0="emitLineDelimitedJson",_DYN_CLEAR="clear",_DYN_MARK_AS_SENT="markAsSent",_DYN_CLEAR_SENT="clearSent",_DYN_BUFFER_OVERRIDE="bufferOverride",_DYN__BUFFER__KEY="BUFFER_KEY",_DYN__SENT__BUFFER__KEY="SENT_BUFFER_KEY",_DYN_CONCAT="concat",_DYN__MAX__BUFFER__SIZE="MAX_BUFFER_SIZE",_DYN_TRIGGER_SEND="triggerSend",_DYN_DIAG_LOG="diagLog",_DYN_INITIALIZE="initialize",_DYN__SENDER="_sender",_DYN_ENDPOINT_URL$1="endpointUrl",_DYN_INSTRUMENTATION_KEY$1="instrumentationKey",_DYN_CUSTOM_HEADERS="customHeaders",_DYN_MAX_BATCH_SIZE_IN_BY1="maxBatchSizeInBytes",_DYN_ONUNLOAD_DISABLE_BEA2="onunloadDisableBeacon",_DYN_IS_BEACON_API_DISABL3="isBeaconApiDisabled",_DYN_ALWAYS_USE_XHR_OVERR4="alwaysUseXhrOverride",_DYN_ENABLE_SESSION_STORA5="enableSessionStorageBuffer",_DYN__BUFFER="_buffer",_DYN_ONUNLOAD_DISABLE_FET6="onunloadDisableFetch",_DYN_DISABLE_SEND_BEACON_7="disableSendBeaconSplit",_DYN_GET_SENDER_INST="getSenderInst",_DYN__ON_ERROR="_onError",_DYN__ON_PARTIAL_SUCCESS="_onPartialSuccess",_DYN__ON_SUCCESS="_onSuccess",_DYN_ITEMS_RECEIVED="itemsReceived",_DYN_ITEMS_ACCEPTED="itemsAccepted",_DYN_BASE_TYPE="baseType",_DYN_SAMPLE_RATE="sampleRate",_DYN_GET_HASH_CODE_SCORE="getHashCodeScore",strBaseType="baseType",strBaseData="baseData",strProperties="properties",strTrue="true";function _setValueIf(e,t,n){return setValue(e,t,n,isTruthy)}function _extractPartAExtensions(e,t,n){for(var r=n[_DYN_TAGS]=n[_DYN_TAGS]||{},o=t.ext=t.ext||{},i=t[_DYN_TAGS]=t[_DYN_TAGS]||[],a=o.user,a=(a&&(_setValueIf(r,CtxTagKeys.userAuthUserId,a.authId),_setValueIf(r,CtxTagKeys.userId,a.id||a.localId)),o.app),a=(a&&_setValueIf(r,CtxTagKeys.sessionId,a.sesId),o.device),a=(a&&(_setValueIf(r,CtxTagKeys.deviceId,a.id||a.localId),_setValueIf(r,CtxTagKeys[_DYN_DEVICE_TYPE],a.deviceClass),_setValueIf(r,CtxTagKeys.deviceIp,a.ip),_setValueIf(r,CtxTagKeys.deviceModel,a.model),_setValueIf(r,CtxTagKeys[_DYN_DEVICE_TYPE],a[_DYN_DEVICE_TYPE])),t.ext.web),t=(a&&(_setValueIf(r,CtxTagKeys.deviceLanguage,a.browserLang),_setValueIf(r,CtxTagKeys.deviceBrowserVersion,a.browserVer),_setValueIf(r,CtxTagKeys.deviceBrowser,a.browser),_setValueIf(t=(t=(t=n[_DYN_DATA]=n[_DYN_DATA]||{})[strBaseData]=t[strBaseData]||{})[strProperties]=t[strProperties]||{},"domain",a.domain),_setValueIf(t,"isManual",a.isManual?strTrue:null),_setValueIf(t,"screenRes",a.screenRes),_setValueIf(t,"userConsent",a.userConsent?strTrue:null)),o.os),a=(t&&(_setValueIf(r,CtxTagKeys.deviceOS,t[_DYN_NAME]),_setValueIf(r,CtxTagKeys.deviceOSVersion,t.osVer)),o.trace),_=(a&&(_setValueIf(r,CtxTagKeys.operationParentId,a.parentID),_setValueIf(r,CtxTagKeys.operationName,dataSanitizeString(e,a[_DYN_NAME])),_setValueIf(r,CtxTagKeys.operationId,a[_DYN_TRACE_ID])),{}),s=i[_DYN_LENGTH]-1;0<=s;s--)objForEachKey(i[s],function(e,t){_[e]=t}),i.splice(s,1);objForEachKey(i,function(e,t){_[e]=t});t=__assignFn(__assignFn({},r),_);t[CtxTagKeys.internalSdkVersion]||(t[CtxTagKeys.internalSdkVersion]=dataSanitizeString(e,"javascript:".concat(EnvelopeCreator.Version),64)),n[_DYN_TAGS]=optimizeObject(t)}function _extractPropsAndMeasurements(e,n,r){isNullOrUndefined(e)||objForEachKey(e,function(e,t){isNumber(t)?r[e]=t:isString(t)?n[e]=t:hasJSON()&&(n[e]=getJSON()[_DYN_STRINGIFY](t))})}function _convertPropsUndefinedToCustomDefinedValue(n,r){isNullOrUndefined(n)||objForEachKey(n,function(e,t){n[e]=t||r})}function _createEnvelope(e,t,n,r){r=new Envelope(e,r,t),_setValueIf(r,"sampleRate",n[SampleRate]),(n[strBaseData]||{}).startTime&&(r.time=toISOString(n[strBaseData].startTime)),r.iKey=n.iKey,t=n.iKey.replace(/-/g,"");return r[_DYN_NAME]=r[_DYN_NAME].replace("{0}",t),_extractPartAExtensions(e,n,r),n[_DYN_TAGS]=n[_DYN_TAGS]||[],optimizeObject(r)}function EnvelopeCreatorInit(e,t){isNullOrUndefined(t[strBaseData])&&_throwInternal(e,1,46,"telemetryItem.baseData cannot be null.")}var EnvelopeCreator={Version:"3.3.9"};function DependencyEnvelopeCreator(e,t,n){EnvelopeCreatorInit(e,t);var r=t[strBaseData][_DYN_MEASUREMENTS]||{},o=t[strBaseData][strProperties]||{},n=(_extractPropsAndMeasurements(t[_DYN_DATA],o,r),isNullOrUndefined(n)||_convertPropsUndefinedToCustomDefinedValue(o,n),t[strBaseData]);if(isNullOrUndefined(n))return _warnToConsole(e,"Invalid input for dependency data"),null;var i=n[strProperties]&&n[strProperties][HttpMethod]?n[strProperties][HttpMethod]:"GET",i=new RemoteDependencyData(e,n.id,n.target,n[_DYN_NAME],n[STR_DURATION],n.success,n.responseCode,i,n.type,n.correlationContext,o,r),n=new Data(RemoteDependencyData[_DYN_DATA_TYPE],i);return _createEnvelope(e,RemoteDependencyData[_DYN_ENVELOPE_TYPE],t,n)}function EventEnvelopeCreator(e,t,n){EnvelopeCreatorInit(e,t);var r={},o={},n=(t[strBaseType]!==Event$1[_DYN_DATA_TYPE]&&(r.baseTypeSource=t[strBaseType]),t[strBaseType]===Event$1[_DYN_DATA_TYPE]?(r=t[strBaseData][strProperties]||{},o=t[strBaseData][_DYN_MEASUREMENTS]||{}):t[strBaseData]&&_extractPropsAndMeasurements(t[strBaseData],r,o),_extractPropsAndMeasurements(t[_DYN_DATA],r,o),isNullOrUndefined(n)||_convertPropsUndefinedToCustomDefinedValue(r,n),t[strBaseData][_DYN_NAME]),n=new Event$1(e,n,r,o),r=new Data(Event$1[_DYN_DATA_TYPE],n);return _createEnvelope(e,Event$1[_DYN_ENVELOPE_TYPE],t,r)}function ExceptionEnvelopeCreator(e,t,n){EnvelopeCreatorInit(e,t);var r=t[strBaseData][_DYN_MEASUREMENTS]||{},o=t[strBaseData][strProperties]||{},n=(_extractPropsAndMeasurements(t[_DYN_DATA],o,r),isNullOrUndefined(n)||_convertPropsUndefinedToCustomDefinedValue(o,n),t[strBaseData]),n=Exception.CreateFromInterface(e,n,o,r),o=new Data(Exception[_DYN_DATA_TYPE],n);return _createEnvelope(e,Exception[_DYN_ENVELOPE_TYPE],t,o)}function MetricEnvelopeCreator(e,t,n){EnvelopeCreatorInit(e,t);var r=t[strBaseData],o=r[strProperties]||{},i=r[_DYN_MEASUREMENTS]||{},n=(_extractPropsAndMeasurements(t[_DYN_DATA],o,i),isNullOrUndefined(n)||_convertPropsUndefinedToCustomDefinedValue(o,n),new Metric(e,r[_DYN_NAME],r.average,r.sampleCount,r.min,r.max,r.stdDev,o,i)),r=new Data(Metric[_DYN_DATA_TYPE],n);return _createEnvelope(e,Metric[_DYN_ENVELOPE_TYPE],t,r)}function PageViewEnvelopeCreator(e,t,n){EnvelopeCreatorInit(e,t);var r,o=t[strBaseData],o=(isNullOrUndefined(o)||isNullOrUndefined(o[strProperties])||isNullOrUndefined(o[strProperties][STR_DURATION])?isNullOrUndefined(t[_DYN_DATA])||isNullOrUndefined(t[_DYN_DATA][STR_DURATION])||(r=t[_DYN_DATA][STR_DURATION],delete t[_DYN_DATA][STR_DURATION]):(r=o[strProperties][STR_DURATION],delete o[strProperties][STR_DURATION]),t[strBaseData]),i=(((t.ext||{}).trace||{})[_DYN_TRACE_ID]&&(i=t.ext.trace[_DYN_TRACE_ID]),o.id||i),a=o[_DYN_NAME],_=o.uri,s=o[strProperties]||{},u=o[_DYN_MEASUREMENTS]||{},o=(isNullOrUndefined(o.refUri)||(s.refUri=o.refUri),isNullOrUndefined(o.pageType)||(s.pageType=o.pageType),isNullOrUndefined(o.isLoggedIn)||(s.isLoggedIn=o.isLoggedIn[_DYN_TO_STRING]()),isNullOrUndefined(o[strProperties])||objForEachKey(o[strProperties],function(e,t){s[e]=t}),_extractPropsAndMeasurements(t[_DYN_DATA],s,u),isNullOrUndefined(n)||_convertPropsUndefinedToCustomDefinedValue(s,n),new PageView(e,a,_,r,s,u,i)),n=new Data(PageView[_DYN_DATA_TYPE],o);return _createEnvelope(e,PageView[_DYN_ENVELOPE_TYPE],t,n)}function PageViewPerformanceEnvelopeCreator(e,t,n){EnvelopeCreatorInit(e,t);var r=t[strBaseData],o=r[_DYN_NAME],i=r.uri||r.url,a=r[strProperties]||{},_=r[_DYN_MEASUREMENTS]||{},n=(_extractPropsAndMeasurements(t[_DYN_DATA],a,_),isNullOrUndefined(n)||_convertPropsUndefinedToCustomDefinedValue(a,n),new PageViewPerformance(e,o,i,undefined,a,_,r)),o=new Data(PageViewPerformance[_DYN_DATA_TYPE],n);return _createEnvelope(e,PageViewPerformance[_DYN_ENVELOPE_TYPE],t,o)}function TraceEnvelopeCreator(e,t,n){EnvelopeCreatorInit(e,t);var r=t[strBaseData].message,o=t[strBaseData].severityLevel,i=t[strBaseData][strProperties]||{},a=t[strBaseData][_DYN_MEASUREMENTS]||{},n=(_extractPropsAndMeasurements(t[_DYN_DATA],i,a),isNullOrUndefined(n)||_convertPropsUndefinedToCustomDefinedValue(i,n),new Trace(e,r,o,i,a)),r=new Data(Trace[_DYN_DATA_TYPE],n);return _createEnvelope(e,Trace[_DYN_ENVELOPE_TYPE],t,r)}var _a$1,_b$1,BaseSendBuffer=function(){function e(i,n){var a=[],r=!1,o=n.maxRetryCnt;this._get=function(){return a},this._set=function(e){return a=e},dynamicProto(e,this,function(t){t[_DYN_ENQUEUE]=function(e){t[_DYN_COUNT]()>=n.eventsLimitInMem?r||(_throwInternal(i,2,105,"Maximum in-memory buffer size reached: "+t[_DYN_COUNT](),!0),r=!0):(e.cnt=e.cnt||0,!isNullOrUndefined(o)&&e.cnt>o||a[_DYN_PUSH](e))},t[_DYN_COUNT]=function(){return a[_DYN_LENGTH]},t.size=function(){for(var e=a[_DYN_LENGTH],t=0;t<a[_DYN_LENGTH];t++)e+=a[t].item[_DYN_LENGTH];return n[_DYN_EMIT_LINE_DELIMITED_0]||(e+=2),e},t[_DYN_CLEAR]=function(){r=!(a=[])},t.getItems=function(){return a.slice(0)},t.batchPayloads=function(e){var t;return e&&0<e[_DYN_LENGTH]?(t=[],arrForEach(e,function(e){t[_DYN_PUSH](e.item)}),n[_DYN_EMIT_LINE_DELIMITED_0]?t.join("\n"):"["+t.join(",")+"]"):null},t.createNew=function(e,t,n){var r=a.slice(0),o=new(n?SessionStorageSendBuffer:ArraySendBuffer)(e=e||i,t=t||{});return arrForEach(r,function(e){o[_DYN_ENQUEUE](e)}),o}})}return e.__ieDyn=1,e}(),ArraySendBuffer=function(n){function r(e,t){e=n.call(this,e,t)||this;return dynamicProto(r,e,function(e,t){e[_DYN_MARK_AS_SENT]=function(e){t[_DYN_CLEAR]()},e[_DYN_CLEAR_SENT]=function(e){}}),e}return __extendsFn(r,n),r.__ieDyn=1,r}(BaseSendBuffer),PREVIOUS_KEYS=["AI_buffer","AI_sentBuffer"],SessionStorageSendBuffer=function(r){function d(c,e){var t=r.call(this,c,e)||this,l=!1,N=null==e?void 0:e.namePrefix,n=e[_DYN_BUFFER_OVERRIDE]||{getItem:utlGetSessionStorage,setItem:utlSetSessionStorage},E=n.getItem,f=n.setItem,D=e.maxRetryCnt;return dynamicProto(d,t,function(a,t){var e=_(d[_DYN__BUFFER__KEY]),n=_(d[_DYN__SENT__BUFFER__KEY]),r=function(){var n=[];try{return arrForEach(PREVIOUS_KEYS,function(e){var t=u(e);n=n[_DYN_CONCAT](t),N&&(t=u(N+"_"+e),n=n[_DYN_CONCAT](t))}),n}catch(e){_throwInternal(c,2,41,"Transfer events from previous buffers: "+getExceptionName(e)+". previous Buffer items can not be removed",{exception:dumpObj(e)})}return[]}(),r=n[_DYN_CONCAT](r),n=a._set(e[_DYN_CONCAT](r));function o(e,t){var n=[],r=[];return arrForEach(e,function(e){r[_DYN_PUSH](e.item)}),arrForEach(t,function(e){isFunction(e)||-1!==arrIndexOf(r,e.item)||n[_DYN_PUSH](e)}),n}function _(e){return i(N?N+"_"+e:e)}function i(e){try{var t=E(c,e);if(t){var n=getJSON().parse(t);if((n=isString(n)?getJSON().parse(n):n)&&isArray(n))return n}}catch(r){_throwInternal(c,1,42," storage key: "+e+", "+getExceptionName(r),{exception:dumpObj(r)})}return[]}function s(e,t){try{var e=N?N+"_"+e:e,n=JSON[_DYN_STRINGIFY](t);f(c,e,n)}catch(r){f(c,e,JSON[_DYN_STRINGIFY]([])),_throwInternal(c,2,41," storage key: "+e+", "+getExceptionName(r)+". Buffer cleared",{exception:dumpObj(r)})}}function u(e){try{var t=i(e),n=[];return arrForEach(t,function(e){n[_DYN_PUSH]({item:e,cnt:0})}),utlRemoveSessionStorage(c,e),n}catch(r){}return[]}n[_DYN_LENGTH]>d[_DYN__MAX__BUFFER__SIZE]&&(n[_DYN_LENGTH]=d[_DYN__MAX__BUFFER__SIZE]),s(d[_DYN__SENT__BUFFER__KEY],[]),s(d[_DYN__BUFFER__KEY],n),a[_DYN_ENQUEUE]=function(e){a[_DYN_COUNT]()>=d[_DYN__MAX__BUFFER__SIZE]?l||(_throwInternal(c,2,67,"Maximum buffer size reached: "+a[_DYN_COUNT](),!0),l=!0):(e.cnt=e.cnt||0,!isNullOrUndefined(D)&&e.cnt>D||(t[_DYN_ENQUEUE](e),s(d[_DYN__BUFFER__KEY],a._get())))},a[_DYN_CLEAR]=function(){t[_DYN_CLEAR](),s(d[_DYN__BUFFER__KEY],a._get()),s(d[_DYN__SENT__BUFFER__KEY],[]),l=!1},a[_DYN_MARK_AS_SENT]=function(e){s(d[_DYN__BUFFER__KEY],a._set(o(e,a._get())));var t=_(d[_DYN__SENT__BUFFER__KEY]);t instanceof Array&&e instanceof Array&&((t=t[_DYN_CONCAT](e))[_DYN_LENGTH]>d[_DYN__MAX__BUFFER__SIZE]&&(_throwInternal(c,1,67,"Sent buffer reached its maximum size: "+t[_DYN_LENGTH],!0),t[_DYN_LENGTH]=d[_DYN__MAX__BUFFER__SIZE]),s(d[_DYN__SENT__BUFFER__KEY],t))},a[_DYN_CLEAR_SENT]=function(e){e=o(e,_(d[_DYN__SENT__BUFFER__KEY]));s(d[_DYN__SENT__BUFFER__KEY],e)},a.createNew=function(e,t,n){n=!!n;var r=a._get().slice(0),o=_(d[_DYN__SENT__BUFFER__KEY]).slice(0),i=(e=e||c,t=t||{},a[_DYN_CLEAR](),new(n?d:ArraySendBuffer)(e,t));return arrForEach(r,function(e){i[_DYN_ENQUEUE](e)}),n&&i[_DYN_MARK_AS_SENT](o),i}}),t}var e;return __extendsFn(d,r),(e=d).VERSION="_1",d.BUFFER_KEY="AI_buffer"+e.VERSION,d.SENT_BUFFER_KEY="AI_sentBuffer"+e.VERSION,d.MAX_BUFFER_SIZE=2e3,d}(BaseSendBuffer),Serializer=function(){function e(l){dynamicProto(e,this,function(e){function u(a,_){var e="__aiCircularRefCheck",s={};if(!a)return _throwInternal(l,1,48,"cannot serialize object because it is null or undefined",{name:_},!0),s;if(a[e])return _throwInternal(l,2,50,"Circular reference detected while serializing object",{name:_},!0),s;if(a.aiDataContract)return a[e]=!0,objForEachKey(a.aiDataContract,function(e,t){var n=isFunction(t)?1&t():1&t,r=isFunction(t)?4&t():4&t,t=2&t,o=a[e]!==undefined,i=isObject(a[e])&&null!==a[e];!n||o||t?r||(n=i?(t?c:u)(a[e],e):a[e])!==undefined&&(s[e]=n):_throwInternal(l,1,24,"Missing required field specification. The field is required but not present on source",{field:e,name:_})}),delete a[e],s;if("measurements"===_)s=n(a,"number",_);else if("properties"===_)s=n(a,"string",_);else if("tags"===_)s=n(a,"string",_);else if(isArray(a))s=c(a,_);else{_throwInternal(l,2,49,"Attempting to serialize an object which does not implement ISerializable",{name:_},!0);try{getJSON()[_DYN_STRINGIFY](a),s=a}catch(t){_throwInternal(l,1,48,t&&isFunction(t[_DYN_TO_STRING])?t[_DYN_TO_STRING]():"Error serializing object",null,!0)}}return s}function c(e,t){if(e)if(isArray(e))for(var n=[],r=0;r<e[_DYN_LENGTH];r++){var o=u(e[r],t+"["+r+"]");n[_DYN_PUSH](o)}else _throwInternal(l,1,54,"This field was specified as an array in the contract but the item is not an array.\r\n",{name:t},!0);return n}function n(e,n,r){var o;return e&&(o={},objForEachKey(e,function(e,t){"string"===n?t===undefined?o[e]="undefined":null===t?o[e]="null":t[_DYN_TO_STRING]?o[e]=t[_DYN_TO_STRING]():o[e]="invalid field: toString() is not defined.":"number"===n?t===undefined?o[e]="undefined":o[e]=null===t?"null":parseFloat(t):(o[e]="invalid field: "+r+" is of unknown type.",_throwInternal(l,1,o[e],null,!0))})),o}e.serialize=function(e){e=u(e,"root");try{return getJSON()[_DYN_STRINGIFY](e)}catch(t){_throwInternal(l,1,48,t&&isFunction(t[_DYN_TO_STRING])?t[_DYN_TO_STRING]():"Error serializing object",null,!0)}}})}return e.__ieDyn=1,e}(),MIN_INPUT_LENGTH=8,HashCodeScoreGenerator=function(){function t(){}return t.prototype.getHashCodeScore=function(e){return this.getHashCode(e)/t.INT_MAX_VALUE*100},t.prototype.getHashCode=function(e){if(""===e)return 0;for(;e[_DYN_LENGTH]<MIN_INPUT_LENGTH;)e=e[_DYN_CONCAT](e);for(var t=5381,n=0;n<e[_DYN_LENGTH];++n)t=(t<<5)+t+e.charCodeAt(n),t&=t;return Math.abs(t)},t.INT_MAX_VALUE=2147483647,t}(),SamplingScoreGenerator=function(){var t=new HashCodeScoreGenerator,n=new ContextTagKeys;this.getSamplingScore=function(e){return e[_DYN_TAGS]&&e[_DYN_TAGS][n.userId]?t.getHashCodeScore(e[_DYN_TAGS][n.userId]):e.ext&&e.ext.user&&e.ext.user.id?t[_DYN_GET_HASH_CODE_SCORE](e.ext.user.id):e[_DYN_TAGS]&&e[_DYN_TAGS][n.operationId]?t.getHashCodeScore(e[_DYN_TAGS][n.operationId]):e.ext&&e.ext.telemetryTrace&&e.ext.telemetryTrace[_DYN_TRACE_ID]?t.getHashCodeScore(e.ext.telemetryTrace[_DYN_TRACE_ID]):100*Math.random()}},Sample=function(){function e(e,t){this.INT_MAX_VALUE=2147483647;t=t||safeGetLogger(null);(100<e||e<0)&&(t.throwInternal(2,58,"Sampling rate is out of range (0..100). Sampling will be disabled, you may be sending too much data which may affect your AI service level.",{samplingRate:e},!0),e=100),this[_DYN_SAMPLE_RATE]=e,this.samplingScoreGenerator=new SamplingScoreGenerator}return e.prototype.isSampledIn=function(e){var t=this[_DYN_SAMPLE_RATE];return null===t||t===undefined||100<=t||e.baseType===Metric[_DYN_DATA_TYPE]||this.samplingScoreGenerator.getSamplingScore(e)<t},e}(),UNDEFINED_VALUE$1=undefined,EMPTY_STR="",FetchSyncRequestSizeLimitBytes=65e3;function _getResponseText(e){try{return e.responseText}catch(t){}return null}function isOverrideFn(e){return e&&e.sendPOST}var defaultAppInsightsChannelConfig=objDeepFreeze(((_a$1={endpointUrl:cfgDfValidate(isTruthy,DEFAULT_BREEZE_ENDPOINT+DEFAULT_BREEZE_PATH)})[_DYN_EMIT_LINE_DELIMITED_0]=cfgDfBoolean(),_a$1.maxBatchInterval=15e3,_a$1[_DYN_MAX_BATCH_SIZE_IN_BY1]=102400,_a$1.disableTelemetry=cfgDfBoolean(),_a$1[_DYN_ENABLE_SESSION_STORA5]=cfgDfBoolean(!0),_a$1.isRetryDisabled=cfgDfBoolean(),_a$1[_DYN_IS_BEACON_API_DISABL3]=cfgDfBoolean(!0),_a$1[_DYN_DISABLE_SEND_BEACON_7]=cfgDfBoolean(!0),_a$1.disableXhr=cfgDfBoolean(),_a$1[_DYN_ONUNLOAD_DISABLE_FET6]=cfgDfBoolean(),_a$1[_DYN_ONUNLOAD_DISABLE_BEA2]=cfgDfBoolean(),_a$1[_DYN_INSTRUMENTATION_KEY$1]=UNDEFINED_VALUE$1,_a$1.namePrefix=UNDEFINED_VALUE$1,_a$1.samplingPercentage=cfgDfValidate(_chkSampling,100),_a$1[_DYN_CUSTOM_HEADERS]=UNDEFINED_VALUE$1,_a$1.convertUndefined=UNDEFINED_VALUE$1,_a$1.eventsLimitInMem=1e4,_a$1[_DYN_BUFFER_OVERRIDE]=!1,_a$1.httpXHROverride={isVal:isOverrideFn,v:UNDEFINED_VALUE$1},_a$1[_DYN_ALWAYS_USE_XHR_OVERR4]=cfgDfBoolean(),_a$1.transports=UNDEFINED_VALUE$1,_a$1.retryCodes=UNDEFINED_VALUE$1,_a$1.corsPolicy=UNDEFINED_VALUE$1,_a$1.maxRetryCnt={isVal:isNumber,v:10},_a$1)),CrossOriginResourcePolicyHeader="X-Set-Cross-Origin-Resource-Policy";function _chkSampling(e){return!isNaN(e)&&0<e&&e<=100}(_b$1={})[Event$1.dataType]=EventEnvelopeCreator,_b$1[Trace.dataType]=TraceEnvelopeCreator,_b$1[PageView.dataType]=PageViewEnvelopeCreator,_b$1[PageViewPerformance.dataType]=PageViewPerformanceEnvelopeCreator,_b$1[Exception.dataType]=ExceptionEnvelopeCreator,_b$1[Metric.dataType]=MetricEnvelopeCreator,_b$1[RemoteDependencyData.dataType]=DependencyEnvelopeCreator;var _a,_b,EnvelopeTypeCreator=_b$1,Sender=function(e){function se(){var A,O,C,R,P,v,h,L,b,U,F,M,G,w,x,H,$,j,V,k,B,K,z,X,W,q,Z,J,Q,ee,te,ne,re,oe,ie,ae=e.call(this)||this,_e=(ae.priority=1001,ae.identifier=BreezeChannelIdentifier,0);return dynamicProto(se,ae,function(E,r){function f(e,t){var n=_getResponseText(e);!e||n+""!="200"&&""!==n?(n=parseResponse(n))&&n[_DYN_ITEMS_RECEIVED]&&n[_DYN_ITEMS_RECEIVED]>n[_DYN_ITEMS_ACCEPTED]&&!B?E[_DYN__ON_PARTIAL_SUCCESS](t,n):E[_DYN__ON_ERROR](t,formatErrorMessageXdr(e)):(A=0,E[_DYN__ON_SUCCESS](t,0))}function D(e,t,n){4===e.readyState&&g(e.status,t,e.responseURL,n,formatErrorMessageXhr(e),_getResponseText(e)||e.response)}function d(e){try{var t;if(e)return(t=e.oriPayload)&&t[_DYN_LENGTH]?t:null}catch(n){}return null}function s(e,t){return!(j||(e?e.baseData&&!e[_DYN_BASE_TYPE]?(t&&_throwInternal(t,1,70,"Cannot send telemetry without baseData and baseType"),1):(e[_DYN_BASE_TYPE]||(e[_DYN_BASE_TYPE]="EventData"),E[_DYN__SENDER]?E._sample.isSampledIn(e)?(e[SampleRate]=E._sample[_DYN_SAMPLE_RATE],0):(t&&_throwInternal(t,2,33,"Telemetry item was sampled out and not sent",{SampleRate:E._sample[_DYN_SAMPLE_RATE]}),1):(t&&_throwInternal(t,1,28,"Sender was not initialized"),1)):(t&&_throwInternal(t,1,7,"Cannot send empty telemetry"),1)))}function u(e,n){var t=e.iKey||V,r=se.constructEnvelope(e,t,n,k);if(r){var o=!1;if(e[_DYN_TAGS]&&e[_DYN_TAGS][ProcessLegacy]&&(arrForEach(e[_DYN_TAGS][ProcessLegacy],function(e){try{e&&!1===e(r)&&(o=!0,_warnToConsole(n,"Telemetry processor check returns false"))}catch(t){_throwInternal(n,1,64,"One of telemetry initializers failed, telemetry item will not be sent: "+getExceptionName(t),{exception:dumpObj(t)},!0)}}),delete e[_DYN_TAGS][ProcessLegacy]),!o)return r}else _throwInternal(n,1,47,"Unable to create an AppInsights envelope")}function e(e){var t=EMPTY_STR,n=E[_DYN_DIAG_LOG]();try{var r=s(e,n),o=null;(o=r?u(e,n):o)&&(t=P.serialize(o))}catch(i){}return t}function t(e){var t=EMPTY_STR;return e&&e[_DYN_LENGTH]?"["+e.join(",")+"]":t}function n(e){var t=o();return{urlString:F,data:e,headers:t}}function T(e,o,t,n){void 0===n&&(n=!0);var r=function(e,t,n){var r=o;200===e&&r?E._onSuccess(r,r[_DYN_LENGTH]):n&&E[_DYN__ON_ERROR](r,n)},i=S(o),a=e&&e.sendPOST;return a&&i&&(n&&E._buffer[_DYN_MARK_AS_SENT](o),re.preparePayload(function(e){return a(e,r,!t)},ie,i,!t)),null}function S(e){var t,n;return isArray(e)&&0<e[_DYN_LENGTH]?(t=E[_DYN__BUFFER].batchPayloads(e),n=o(),{data:t,urlString:F,headers:n,disableXhrSync:J,disableFetchKeepAlive:!Q,oriPayload:e}):null}function o(){try{var e=h||{};return isInternalApplicationInsightsEndpoint(F)&&(e[RequestHeaders[6]]=RequestHeaders[7]),e}catch(t){}return null}function p(e){e=e?e[_DYN_LENGTH]:0;E[_DYN__BUFFER].size()+e>G&&(b&&!b.isOnline()||E[_DYN_TRIGGER_SEND](!0,null,10))}function g(e,t,n,r,o,i){var a=null;E._appId||(a=parseResponse(i))&&a.appId&&(E._appId=a.appId),(e<200||300<=e)&&0!==e?301!==e&&307!==e&&308!==e||_(n)?b&&!b.isOnline()?B||(l(t,10),_throwInternal(E[_DYN_DIAG_LOG](),2,40,". Offline - Response Code: ".concat(e,". Offline status: ").concat(!b.isOnline(),". Will retry to send ").concat(t.length," items."))):!B&&m(e)?(l(t),_throwInternal(E[_DYN_DIAG_LOG](),2,40,". Response code "+e+". Will retry to send "+t[_DYN_LENGTH]+" items.")):E[_DYN__ON_ERROR](t,o):E[_DYN__ON_ERROR](t,o):(_(n),206===e?(a=a||parseResponse(i))&&!B?E[_DYN__ON_PARTIAL_SUCCESS](t,a):E[_DYN__ON_ERROR](t,o):(A=0,E[_DYN__ON_SUCCESS](t,r)))}function _(e){return!(10<=v)&&!isNullOrUndefined(e)&&""!==e&&e!==F&&(F=e,++v,1)}function i(e,t){if(!L)return T(re&&re[_DYN_GET_SENDER_INST]([3],!0),e,t);L(e,!1)}function c(e){try{if(e&&e[_DYN_LENGTH])return isString(e[0])}catch(t){}}function I(e,t){var n=null;if(isArray(e)){for(var r=e[_DYN_LENGTH],o=0;o<e[_DYN_LENGTH];o++)r+=e[o].item[_DYN_LENGTH];return re.getSyncFetchPayload()+r<=FetchSyncRequestSizeLimitBytes?n=2:isBeaconsSupported()?n=3:(n=1,_throwInternal(E[_DYN_DIAG_LOG](),2,40,". Failed to send telemetry with Beacon API, retried with xhrSender.")),T(re&&re[_DYN_GET_SENDER_INST]([n],!0),e,t)}return null}function l(e,t){if(void 0===t&&(t=1),e&&0!==e[_DYN_LENGTH]){var n=E[_DYN__BUFFER];n[_DYN_CLEAR_SENT](e),A++;for(var r=0,o=e;r<o.length;r++){var i=o[r];i.cnt=i.cnt||0,i.cnt++,n[_DYN_ENQUEUE](i)}var e=t,t=(e=A<=1?10:(t=mathFloor((Math.pow(2,A)-1)/2*Math.random()*10)+1,mathMax(mathMin(t*=e,3600),10)),utcNow()+1e3*e);O=t,N()}}function N(){var e;R||C||(e=O?mathMax(0,O-utcNow()):0,e=mathMax(K,e),R=scheduleTimeout(function(){R=null,E[_DYN_TRIGGER_SEND](!0,null,1)},e))}function Y(){R&&R.cancel(),O=R=null}function m(e){return isNullOrUndefined(oe)?401===e||408===e||429===e||500===e||502===e||503===e||504===e:oe[_DYN_LENGTH]&&~oe.indexOf(e)}function y(e,t){var n,r="getNotifyMgr",o=E.core,r=n=o?o[r]?o[r]():o._notificationManager:n;if(r&&r.eventsSendRequest)try{r.eventsSendRequest(e,t)}catch(i){_throwInternal(E[_DYN_DIAG_LOG](),1,74,"send request notification failed: "+getExceptionName(i),{exception:dumpObj(i)})}}function a(){E[_DYN__SENDER]=null,E[_DYN__BUFFER]=null,E._appId=null,E._sample=null,G=_e=v=A=0,W=k=UNDEFINED_VALUE$1,ne=Q=J=B=j=w=C=!(h={}),re=te=ee=z=V=$=M=F=U=L=P=R=O=b=null,objDefine(E,"_senderConfig",{g:function(){return objExtend({},defaultAppInsightsChannelConfig)}})}a(),E.pause=function(){Y(),C=!0},E.resume=function(){C&&(C=!1,O=null,p(),N())},E.flush=function(e,t,n){if(void 0===e&&(e=!0),!C){Y();try{return E[_DYN_TRIGGER_SEND](e,null,n||1)}catch(r){_throwInternal(E[_DYN_DIAG_LOG](),1,22,"flush failed, telemetry will not be collected: "+getExceptionName(r),{exception:dumpObj(r)})}}},E.onunloadFlush=function(){if(!C)if(w||Z)try{return E[_DYN_TRIGGER_SEND](!0,i,2)}catch(e){_throwInternal(E[_DYN_DIAG_LOG](),1,20,"failed to flush with beacon sender on page unload, telemetry will not be collected: "+getExceptionName(e),{exception:dumpObj(e)})}else E.flush(!1)},E.addHeader=function(e,t){h[e]=t},E[_DYN_INITIALIZE]=function(e,c,t,n){E.isInitialized()&&_throwInternal(E[_DYN_DIAG_LOG](),1,28,"Sender is already initialized"),r[_DYN_INITIALIZE](e,c,t,n);var l=E.identifier,N=(P=new Serializer(c.logger),A=0,O=null,E[_DYN__SENDER]=null,v=0,E[_DYN_DIAG_LOG]());U=mergeEvtNamespace(createUniqueNamespace("Sender"),c.evtNamespace&&c.evtNamespace()),b=createOfflineListener(U),E._addHook(onConfigChange(e,function(e){e=e.cfg;e.storagePrefix&&utlSetStoragePrefix(e.storagePrefix);var t=createProcessTelemetryContext(null,e,c).getExtCfg(l,defaultAppInsightsChannelConfig),n=t[_DYN_ENDPOINT_URL$1],n=(F&&n===F&&(r=e[_DYN_ENDPOINT_URL$1])&&r!==n&&(t[_DYN_ENDPOINT_URL$1]=r),getInst("CompressionStream")),r=(ie=isFeatureEnabled("zipPayload",e,!1),isFunction(n)||(ie=!1),t.corsPolicy),n=(r?"same-origin"!==r&&"same-site"!==r&&"cross-origin"!==r||ae.addHeader(CrossOriginResourcePolicyHeader,r):delete h[CrossOriginResourcePolicyHeader],isPromiseLike(t[_DYN_INSTRUMENTATION_KEY$1])&&(t[_DYN_INSTRUMENTATION_KEY$1]=e[_DYN_INSTRUMENTATION_KEY$1]),objDefine(E,"_senderConfig",{g:function(){return t}}),M!==t[_DYN_ENDPOINT_URL$1]&&(F=M=t[_DYN_ENDPOINT_URL$1]),c.activeStatus()===ActiveStatus.PENDING?E.pause():c.activeStatus()===ActiveStatus.ACTIVE&&E.resume(),$&&$!==t[_DYN_CUSTOM_HEADERS]&&arrForEach($,function(e){delete h[e.header]}),G=t[_DYN_MAX_BATCH_SIZE_IN_BY1],w=(!1===t[_DYN_ONUNLOAD_DISABLE_BEA2]||!1===t[_DYN_IS_BEACON_API_DISABL3])&&isBeaconsSupported(),x=!1===t[_DYN_ONUNLOAD_DISABLE_BEA2]&&isBeaconsSupported(),H=!1===t[_DYN_IS_BEACON_API_DISABL3]&&isBeaconsSupported(),Z=t[_DYN_ALWAYS_USE_XHR_OVERR4],J=!!t.disableXhr,oe=t.retryCodes,t[_DYN_BUFFER_OVERRIDE]),r=!!t[_DYN_ENABLE_SESSION_STORA5]&&(!!n||utlCanUseSessionStorage()),o=t.namePrefix,i=r!==z||r&&W!==o||r&&X!==n;if(E[_DYN__BUFFER]){if(i)try{E[_DYN__BUFFER]=E[_DYN__BUFFER].createNew(N,t,r)}catch(u){_throwInternal(E[_DYN_DIAG_LOG](),1,12,"failed to transfer telemetry to different buffer storage, telemetry will be lost: "+getExceptionName(u),{exception:dumpObj(u)})}p()}else E[_DYN__BUFFER]=new(r?SessionStorageSendBuffer:ArraySendBuffer)(N,t);W=o,z=r,X=n,Q=!t[_DYN_ONUNLOAD_DISABLE_FET6]&&isFetchSupported(!0),ne=!!t[_DYN_DISABLE_SEND_BEACON_7],E._sample=new Sample(t.samplingPercentage,N),isPromiseLike(V=t[_DYN_INSTRUMENTATION_KEY$1])||(i=V,!isNullOrUndefined(o=e.disableInstrumentationKeyValidation)&&o||/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/.test(i))||_throwInternal(N,1,100,"Invalid Instrumentation key "+V),$=t[_DYN_CUSTOM_HEADERS],isString(F)&&!isInternalApplicationInsightsEndpoint(F)&&$&&0<$[_DYN_LENGTH]?arrForEach($,function(e){ae.addHeader(e.header,e.value)}):$=null,q=t.enableSendPromise;var r=function(){try{return{enableSendPromise:q,isOneDs:!1,disableCredentials:!1,disableXhr:J,disableBeacon:!H,disableBeaconSync:!x,senderOnCompleteCallBack:{xdrOnComplete:function(e,t,n){n=d(n);if(n)return f(e,n)},fetchOnComplete:function(e,t,n,r){r=d(r);if(r)return g(e.status,r,e.url,r[_DYN_LENGTH],e.statusText,n||"")},xhrOnComplete:function(e,t,n){n=d(n);if(n)return D(e,n,n[_DYN_LENGTH])},beaconOnRetry:function(e,t,n){var r=t,o=n,i=e&&e.oriPayload;if(ne)te&&te(i,!0),_throwInternal(E[_DYN_DIAG_LOG](),2,40,". Failed to send telemetry with Beacon API, retried with normal sender.");else{for(var a=[],_=0;_<i[_DYN_LENGTH];_++){var s=i[_],u=[s];o(S(u),r)?E._onSuccess(u,u[_DYN_LENGTH]):a[_DYN_PUSH](s)}0<a[_DYN_LENGTH]&&(te&&te(a,!0),_throwInternal(E[_DYN_DIAG_LOG](),2,40,". Failed to send telemetry with Beacon API, retried with normal sender."))}}}}}catch(e){}return null}(),n=(re?re.SetConfig(r):(re=new SenderPostManager)[_DYN_INITIALIZE](r,N),t.httpXHROverride),a=null,_=null,e=prependTransports([3,1,2],t.transports),a=re&&re[_DYN_GET_SENDER_INST](e,!1),s=re&&re.getFallbackInst(),o=(ee=function(e,t){return T(s,e,t)},te=function(e,t){return T(s,e,t,!1)},a=Z?n:a||n||s,E[_DYN__SENDER]=function(e,t){return T(a,e,t)},Q&&(L=I),prependTransports([3,1],t.unloadTransports));Q||(o=o.filter(function(e){return 2!==e})),_=re&&re[_DYN_GET_SENDER_INST](o,!0),_=!Z&&_||n,L=(L=(Z||t.unloadTransports||!L)&&_?function(e,t){return T(_,e,t)}:L)||ee,j=t.disableTelemetry,k=t.convertUndefined||UNDEFINED_VALUE$1,B=t.isRetryDisabled,K=t.maxBatchInterval}))},E.processTelemetry=function(e,t){var n=(t=E._getTelCtx(t))[_DYN_DIAG_LOG]();try{if(!s(e,n))return;var r=u(e,n);if(!r)return;var o=P.serialize(r),i=E[_DYN__BUFFER],a=(p(o),{item:o,cnt:0});i[_DYN_ENQUEUE](a),N()}catch(_){_throwInternal(n,2,12,"Failed adding telemetry to the sender's buffer, some telemetry will be lost: "+getExceptionName(_),{exception:dumpObj(_)})}E.processNext(e,t)},E.isCompletelyIdle=function(){return!C&&0===_e&&0===E._buffer[_DYN_COUNT]()},E.getOfflineListener=function(){return b},E._xhrReadyStateChange=function(e,t,n){if(!c(t))return D(e,t,n)},E[_DYN_TRIGGER_SEND]=function(e,t,n){var r;if(void 0===e&&(e=!0),!C)try{var o,i=E[_DYN__BUFFER];j?i[_DYN_CLEAR]():0<i[_DYN_COUNT]()&&(o=i.getItems(),y(n||0,e),r=t?t.call(E,o,e):E[_DYN__SENDER](o,e)),Y()}catch(a){i=getIEVersion();(!i||9<i)&&_throwInternal(E[_DYN_DIAG_LOG](),1,40,"Telemetry transmission failed, some telemetry will be lost: "+getExceptionName(a),{exception:dumpObj(a)})}return r},E.getOfflineSupport=function(){return{getUrl:function(){return F},createPayload:n,serialize:e,batch:t,shouldProcess:function(e){return!!s(e)}}},E._doTeardown=function(e,t){E.onunloadFlush(),runTargetUnload(b,!1),a()},E[_DYN__ON_ERROR]=function(e,t,n){if(!c(e))return e=e,t=t,_throwInternal(E[_DYN_DIAG_LOG](),2,26,"Failed to send telemetry.",{message:t}),void(E._buffer&&E._buffer[_DYN_CLEAR_SENT](e))},E[_DYN__ON_PARTIAL_SUCCESS]=function(e,t){if(!c(e)){for(var n=e,e=t,r=[],o=[],i=0,a=e.errors.reverse();i<a.length;i++){var _=a[i],s=n.splice(_.index,1)[0];(m(_.statusCode)?o:r)[_DYN_PUSH](s)}0<n[_DYN_LENGTH]&&E[_DYN__ON_SUCCESS](n,e[_DYN_ITEMS_ACCEPTED]),0<r[_DYN_LENGTH]&&E[_DYN__ON_ERROR](r,formatErrorMessageXhr(null,["partial success",e[_DYN_ITEMS_ACCEPTED],"of",e.itemsReceived].join(" "))),0<o[_DYN_LENGTH]&&(l(o),_throwInternal(E[_DYN_DIAG_LOG](),2,40,"Partial success. Delivered: "+n[_DYN_LENGTH]+", Failed: "+r[_DYN_LENGTH]+". Will retry to send "+o[_DYN_LENGTH]+" our of "+e[_DYN_ITEMS_RECEIVED]+" items"))}},E[_DYN__ON_SUCCESS]=function(e,t){c(e)||E._buffer&&E._buffer[_DYN_CLEAR_SENT](e)},E._xdrOnLoad=function(e,t){if(!c(t))return f(e,t)}}),ae}return __extendsFn(se,e),se.constructEnvelope=function(e,t,n,r){e=t===e.iKey||isNullOrUndefined(t)?e:__assignFn(__assignFn({},e),{iKey:t});return(EnvelopeTypeCreator[e.baseType]||EventEnvelopeCreator)(n,e,r)},se}(BaseTelemetryPlugin),_DYN_INSTRUMENTATION_KEY="instrumentationKey",_DYN_CONNECTION_STRING="connectionString",_DYN_ENDPOINT_URL="endpointUrl",_DYN_USER_OVERRIDE_ENDPOI0="userOverrideEndpointUrl",UNDEFINED_VALUE=undefined,defaultConfigValues=((_a={diagnosticLogInterval:cfgDfValidate(_chkDiagLevel,1e4)})[_DYN_CONNECTION_STRING]=UNDEFINED_VALUE,_a.endpointUrl=UNDEFINED_VALUE,_a[_DYN_INSTRUMENTATION_KEY]=UNDEFINED_VALUE,_a.featureOptIn=((_b={}).zipPayload={mode:1},_b),_a.extensionConfig={},_a);function _chkDiagLevel(e){return e&&0<e}var ApplicationInsights=function(){function e(n){var o,r=new AppInsightsCore;function i(e){e&&(e.baseData=e.baseData||{},e.baseType=e.baseType||"EventData"),r.track(e)}(isNullOrUndefined(n)||isNullOrUndefined(n[_DYN_INSTRUMENTATION_KEY])&&isNullOrUndefined(n[_DYN_CONNECTION_STRING]))&&throwError("Invalid input configuration"),dynamicProto(e,this,function(e){function t(){var e=createDynamicConfig(n||{},defaultConfigValues);o=e.cfg,r.addUnloadHook(onConfigChange(e,function(){var e,t,n=o[_DYN_CONNECTION_STRING];isPromiseLike(n)&&(e=createSyncPromise(function(r,e){doAwaitResponse(n,function(e){var t=e.value,n=o[_DYN_INSTRUMENTATION_KEY];!e.rejected&&t&&(n=parseConnectionString(o[_DYN_CONNECTION_STRING]=t).instrumentationkey||n),r(n)})}),t=createSyncPromise(function(r,e){doAwaitResponse(n,function(e){var t=e.value,n=o[_DYN_ENDPOINT_URL];!e.rejected&&t&&(n=(e=parseConnectionString(t).ingestionendpoint)?e+DEFAULT_BREEZE_PATH:n),r(n)})}),o[_DYN_INSTRUMENTATION_KEY]=e,o[_DYN_ENDPOINT_URL]=o[_DYN_USER_OVERRIDE_ENDPOI0]||t),isString(n)&&(t=(e=parseConnectionString(n)).ingestionendpoint,o[_DYN_ENDPOINT_URL]=o[_DYN_USER_OVERRIDE_ENDPOI0]||t+DEFAULT_BREEZE_PATH,o[_DYN_INSTRUMENTATION_KEY]=e.instrumentationkey||o[_DYN_INSTRUMENTATION_KEY]),o[_DYN_ENDPOINT_URL]=o[_DYN_USER_OVERRIDE_ENDPOI0]||o[_DYN_ENDPOINT_URL]})),r.initialize(o,[new Sender])}objDefine(e,"config",{g:function(){return o}}),t(),e.initialize=t,e.track=i,proxyFunctions(e,r,["flush","pollInternalLogs","stopPollingInternalLogs","unload","getPlugin","addPlugin","evtNamespace","addUnloadCb","onCfgChange","getTraceCtx","updateCfg","addTelemetryInitializer"])})}return e.__ieDyn=1,e}();exports.AppInsightsCore=AppInsightsCore,exports.ApplicationInsights=ApplicationInsights,exports.Sender=Sender,exports.SeverityLevel=SeverityLevel,exports.arrForEach=arrForEach,exports.isNullOrUndefined=isNullOrUndefined,exports.proxyFunctions=proxyFunctions,exports.throwError=throwError;
//# sourceMappingURL=aib.3.3.9.cjs.min.js.map
